angular.module('starter', ['ionic', 'ngCordova', 'starter.directives', 'starter.controllers', 'starter.services', 'pascalprecht.translate',
  'monospaced.elastic', 'angular-cache', 'ionic-zoom-view'/*, 'ionic.cloud'*/, 'ngCordovaOauth', 'uiCropper','templates','ngCordova.plugins.nativeStorage'])
.config(function($ionicConfigProvider, CacheFactoryProvider, $compileProvider, $logProvider) {
  angular.extend(CacheFactoryProvider.defaults, { maxAge: 15 * 60 * 1000 });
  $ionicConfigProvider.tabs.position('bottom');
  $ionicConfigProvider.navBar.alignTitle('center');
  $ionicConfigProvider.backButton.previousTitleText(false);
  $ionicConfigProvider.backButton.icon('icon-blury-icons_arrow-left-final');
  $ionicConfigProvider.backButton.text('');
  $ionicConfigProvider.views.swipeBackEnabled(false);
  $ionicConfigProvider.views.maxCache(50);

  $compileProvider.debugInfoEnabled(false);
  $logProvider.debugEnabled(false);
  
  /*$ionicCloudProvider.init({
    "core": {
      "app_id": "22e2233e"
    },
      "push": {
        "sender_id": "1037744853229",
        "pluginConfig": {
          "ios": {
            "alert": true,
            "badge": true,
            "sound": true
          },
          "android": {
            "iconColor": "#343434"
          }
        }
      }
  });*/
})
.run(["$locale", function ($locale) {
    $locale.NUMBER_FORMATS.GROUP_SEP = ".";
    $locale.NUMBER_FORMATS.DECIMAL_SEP = ",";
}])
.run(function($ionicPlatform, $state, $_sdk, $ionicScrollDelegate, $_helper, $rootScope, $_account_cache, $_language, $log, $_cache_helper, 
    $_notification, $_login, $filter, $_tracking, /*$ionicPush, */$timeout, $_network, $timeout, $_image_cache, $_sound, $ionicNavBarDelegate, $ionicHistory, $ionicViewSwitcher, $interval, $_popup, $_location, $_nativestorage, $ionicPopup, $_tos) {

  //Android Camera Fix
  $rootScope.cameraState = {
    takingPicture: false,
    imageUri: "",
    currentScreen: ""
  };

  $rootScope.cameraStateStorageKey = "CameraState";

  // Back-Button verschwindet-Bug fixen, siehe http://bit.ly/2gl7LP9
  $rootScope.$on('$stateChangeSuccess', function(e, toState, toParams, fromState, fromParams) {

      $log.debug("$stateChangeSuccess toState: ");
      $log.debug(toState);
      if(toState.name.indexOf("-chat-detail") !== -1) {
      //if(toState.name == "tab.chats-chat-detail") {
        $log.debug('toState.name == "tab.chats-chat-detail"');
        $ionicNavBarDelegate.showBackButton(true);
      }

      if(toState.name == "start-screen" && fromState.name != "login" && fromState.name != "introduction-swiper") {
        $_cache_helper.clear();
      }

      if(fromState.name == 'terms-of-use' && $rootScope.tosPopupOpen) openTosUpdatePopup();
      if(fromState.name == 'privacy-policy' && $rootScope.tosPopupOpen) openTosUpdatePopup();
  });
  
  //Use this Function instead of ionic.platform.ready
  var ionicPlatformReadyFunc = function(){
    $timeout(function(){
      $_image_cache.initImageCache();
    }, 250);
    
    $_language.setCacheLanguage();
    $_sound.preloadSounds();

    //Überprüfe ob history backView gesetzt ist, ansonsten gehe zurück
    $rootScope.$ionicGoBack = function() {
      $log.debug("ionicGoBack");
      $log.debug($ionicHistory.backView());
      $log.debug($state.current.name);
      $log.debug($state.current.name.substring(0,$state.current.name.indexOf('-')));
        if( $ionicHistory.backView() == null || !angular.isDefined($ionicHistory.backView()) ){
            var currState = $state.current.name;
            var go_state = currState.substring(0,currState.indexOf('-'));

            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.nextViewOptions({
                disableBack: true,
                historyRoot: true
            });

            $state.go(go_state);


        }else{
            $ionicHistory.goBack();
        }
    };

    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      StatusBar.styleDefault();
    }

    if (window.cordova && window.cordova.InAppBrowser) {
      window.open = window.cordova.InAppBrowser.open;
    }

    if($_account_cache.isLoggedIn()) {
      $_helper.refreshBadges();
      $_login.registerIonicPush();
      openRatingPopup();
    } else {
      $_login.deleteIonicPush();
    }

    document.addEventListener("offline", offlineCallback, false);
    document.addEventListener("online", onlineCallback, false);

    /* Google Analytics initialisieren  */
     if(typeof analytics !== 'undefined'){
        var isIOS = ionic.Platform.isIOS();
        var isAndroid = ionic.Platform.isAndroid();

        if(isIOS || isAndroid){
          analytics.debugMode();
          analytics.startTrackerWithId('UA-97204108-1');
          analytics.setAnonymizeIp(true);
        }
      }

    $timeout(function(){
      $_account_cache.setAppWasClosed(false);
    }, 1500);

    FCMPlugin.onNotification(function(data){
      $_notification.processPushNotification(data);
    });

    $rootScope.filterChanged = false;

    $rootScope.currentTime = moment.utc().format('YYYY-MM-DD HH:mm:ss'); ;
    $interval(function() {
      $rootScope.currentTime = moment.utc().format('YYYY-MM-DD HH:mm:ss'); ;
      $log.debug("currentTime");
      $log.debug($rootScope.currentTime);
    }, 15000);

    //Chat-Refresh-Interval
    $rootScope.chatRefreshIntervalTime = 20;
    $rootScope.lastChatRefreshTime = moment();
    $rootScope.chatRefreshInterval = $interval(function() {
      var now = moment();
      $log.debug("seconds: "+now.diff($rootScope.lastChatRefreshTime, 'seconds'));

      if($state.current.name.indexOf("-chat-detail") !== -1) {
        if(now.diff($rootScope.lastChatRefreshTime, 'seconds') > $rootScope.chatRefreshIntervalTime) {
            $rootScope.$broadcast('refresh-chat-interval');
        }
      }

      $log.debug("state");
      $log.debug($state.current.name);

    }, 3000);

    $rootScope.closePhotoRulesPopUp = function() {
      $_popup.closePhotoRulesPopUp();
    };
  };
  
  $ionicPlatform.ready(function() {
    //STORAGE FIX ANFANG

    $log.debug("INITIAL");
    $log.debug($_sdk.getUserID());
    $log.debug($_sdk.getxAuthToken());
    $log.debug("FAKE LOGOUT CLEAR WHOLE LOCALSTORAGE");
    //localStorage.clear();
    $log.debug("AFTER LOGOUT");
    $log.debug($_sdk.getUserID());
    $log.debug($_sdk.getxAuthToken());
    
    if ($_sdk.getUserID() == null || $_sdk.getUserID() == undefined || $_sdk.getUserID()=="" || $_sdk.getxAuthToken() == null || $_sdk.getxAuthToken() == undefined || $_sdk.getxAuthToken()=="" || $_account_cache.isLoggedIn()!=true) {
        
        $log.debug("NATIVE -> LOCAL");
        var userID = "";
        var xAuthToken ="";
        $_nativestorage.getItem("userID").then(function(value){
          userID = value;
          $_nativestorage.getItem("xAuthToken").then(function(value){
            xAuthToken = value;
            $_sdk.setUserID(userID);
            $_sdk.setxAuthToken(xAuthToken);
            $_account_cache.setLoginStatus(true);
            
            $log.debug("AFTER FIX");
            $log.debug($_sdk.getUserID());
            $log.debug($_sdk.getxAuthToken());
            //CONTINUE WITH CODE
            ionicPlatformReadyFunc();
            $state.go('tab.blury');
          },
          function(error){
            //CONTINUE WITH CODE
            ionicPlatformReadyFunc();
          });
        },
        function(error){
          //CONTINUE WITH CODE
          ionicPlatformReadyFunc();
        });
     
    }else{
      
      $log.debug("LOCAL -> NATIVE");
      
      $_nativestorage.setItem("userID", $_sdk.getUserID());
      $_nativestorage.setItem("xAuthToken", $_sdk.getxAuthToken());

      //CONTINUE WITH CODE
      ionicPlatformReadyFunc();
    }

  });

  $ionicPlatform.on('resume', function(event){
    $_tracking.trackEvent("User", "Open App", "", 0);

    if($_account_cache.isLoggedIn()){
      $timeout(function(){
        if(!$_network.isOffline() && $_location.hasLocationPermissions()) {
          $rootScope.$broadcast('refresh-chat-detail');
          $rootScope.$broadcast('refresh-chat-list');
          $rootScope.$broadcast('refresh-flirt-detail');
          $rootScope.$broadcast('refresh-flirt-list');
        }
      }, 1000);

      $_helper.refreshBadges();

      /*
      $_login.unRegisterIonicPush().then(
        function(success){
          $_login.registerIonicPush();
        }, function(error){}
      );
      */


    }

    // Camera Fix
    var storedState = window.localStorage.getItem($rootScope.cameraStateStorageKey);

    if(storedState) {
        $rootScope.cameraState = JSON.parse(storedState);
    }

    if($rootScope.cameraState.takingPicture && event.pendingResult) {
        // Figure out whether or not the plugin call was successful and call
        // the relevant callback. For the camera plugin, "OK" means a
        // successful result and all other statuses mean error
        if(event.pendingResult.pluginStatus === "OK") {
            // The camera plugin places the same result in the resume object
            // as it passes to the success callback passed to getPicture(),
            // thus we can pass it to the same callback. Other plugins may
            // return something else. Consult the documentation for
            // whatever plugin you are using to learn how to interpret the
            // result field
            $rootScope.cameraState.imageUri = event.pendingResult.result;
            if($rootScope.cameraState.currentScreen == "registrate") $state.go('registrate-step4');
            else if($rootScope.cameraState.currentScreen == "account") $state.go('tab.account');
            else if($rootScope.cameraState.currentScreen == "verification") {
              $state.go('tab.account');
              $timeout(function(){
                $state.go('tab.verify-account');
              }, 300);
            }
        } else {
            $rootScope.cameraState.takingPicture = false;
            if($rootScope.cameraState.currentScreen == "registrate") $state.go('registrate-step4');
            else if($rootScope.cameraState.currentScreen == "account") $state.go('tab.account');
            else if($rootScope.cameraState.currentScreen == "verification")  {
              $state.go('tab.account');
              $timeout(function(){
                $state.go('tab.verify-account');
              }, 300);
            }
        }
    }

    $timeout(function(){
      $_account_cache.setAppWasClosed(false);
    }, 1500);

    if ($rootScope.chatRefreshInterval === null) {
      $rootScope.chatRefreshInterval = $interval(function() {
        var now = moment();
        $log.debug("seconds: "+now.diff($rootScope.lastChatRefreshTime, 'seconds'));

        if($state.current.name.indexOf("-chat-detail") !== -1) {
          if(now.diff($rootScope.lastChatRefreshTime, 'seconds') > $rootScope.chatRefreshIntervalTime) {
              $rootScope.$broadcast('refresh-chat-interval');
          }
        }

        $log.debug("state");
        $log.debug($state.current.name);

      }, 3000);
     }
  });

  $ionicPlatform.on('pause', function(){
    $interval.cancel($rootScope.chatRefreshInterval);
    $rootScope.chatRefreshInterval = null;
    $_account_cache.setAppWasClosed(true);

    // Camera Fix
    if($rootScope.cameraState.takingPicture || $rootScope.cameraState.imageUri) {
      window.localStorage.setItem($rootScope.cameraStateStorageKey, JSON.stringify($rootScope.cameraState));
    }
  });

  var openRatingPopup = function() {
    AppRate.preferences = {
      displayAppName: 'Blury',
      usesUntilPrompt: 5,
      promptAgainForEachNewVersion: false,
      inAppReview: true,
      storeAppURL: {
        ios: '1225190412',
        android: 'market://details?id=com.bluryapp.app'
      },
      customLocale: {
        title: $filter('translate')('APP_RATE_TITLE'),
        message: $filter('translate')('APP_RATE_MESSAGE'),
        cancelButtonLabel: $filter('translate')('APP_RATE_CANCEL'),
        laterButtonLabel: $filter('translate')('APP_RATE_LATER'),
        rateButtonLabel: $filter('translate')('APP_RATE_RATE_NOW'),
        yesButtonLabel: $filter('translate')('APP_RATE_YES'),
        noButtonLabel: $filter('translate')('APP_RATE_NO'),
        appRatePromptTitle: $filter('translate')('APP_RATE_PROMPT_TITLE'),
        appRatePromptMessage: $filter('translate')('APP_RATE_PROMPT_MESSAGE'),
        feedbackPromptTitle: $filter('translate')('APP_RATE_FEEDBACK_TITLE'),
        feedbackPromptMessage: $filter('translate')('APP_RATE_FEEDBACK_MESSAGE')
      },
      callbacks: {
        handleNegativeFeedback: function(){
          cordova.plugins.email.open({
            to:      'info@bluryapp.com',
            subject: 'Blury Feedback',
            body:    'Mein Feedback zu Blury:'
          });
        },
        onRateDialogShow: function(callback){
          //callback(1) // cause immediate click on 'Rate Now' button
        },
        onButtonClicked: function(buttonIndex){
          //console.log("onButtonClicked -> " + buttonIndex);
        }
      }
    };

    AppRate.promptForRating(false);
  }

  var offlineCallback = function() {
    if(!$_account_cache.isOffline() && $state.current.name != "registrate") { // Wenn Flag noch nicht gesetzt wurde => Notification anzeigen
      var type = $_notification.getNotificationTypes().ERROR;
      var msg = $filter('translate')('YOUR_DEVICE_IS_OFFLINE');

      $_notification.showNotificationBar(msg, type, 0);
      $_account_cache.setOffline(true);
    }
  }

  var onlineCallback = function() {
    $_account_cache.setOffline(false);
    $_notification.closeNotification();
    $rootScope.$broadcast('connectivity-status-online');
  }

   $rootScope.$on("delete-push-token", function(){
      $_login.deleteIonicPush();
    });

   $rootScope.$on("connectivity-error", function(){
      hasShownOfflineNote = false;

      $_helper.hideLoadingIndicator();
      $_helper.hideSendIndicator();

      if($_network.isOffline()) {
        offlineCallback();
      }
    });

  /*$rootScope.$on('cloud:push:notification', function(event, data) {
      $_notification.processPushNotification(data);
    });*/

    $rootScope.$on('request-timeout', function(){

      $log.debug("request-timeout");
      $_helper.hideLoadingIndicator();
      $_helper.hideSendIndicator();
      var type = $_notification.getNotificationTypes().ERROR;
      var msg = $filter('translate')('REQUEST_ERROR');

      $_notification.showNotificationBar(msg, type);
    });

    $rootScope.$on('wartungsmodus', function(){
      $_notification.showNotificationBar($filter('translate')('WARTUNGSMODUS'), $_notification.getNotificationTypes().ERROR);
    });

    $rootScope.appVersionPopupOpen = false;

    $rootScope.$on('app-version-too-old', function(){
      if(!$rootScope.appVersionPopupOpen) {
        $rootScope.appVersionPopupOpen = true;
        var confirmPopup = $ionicPopup.show({
          title: $filter('translate')('APP_VERSION_TOO_OLD'),
          template: $filter('translate')('APP_VERSION_TOO_OLD_TEXT'),
          cssClass: 'popup-bottom-button',
          buttons: [
            {
              text: "DOWNLOAD",
              onTap: function(e) {
                $rootScope.appVersionPopupOpen = false;
                window.open("http://www.bluryapp.com/download", '_system');  
                return true;
              }
            }
          ],
        });
      }
      
    });


    $rootScope.tosPopupOpen = false;

    $rootScope.$on('tos-update', function(){
      if(!$rootScope.tosPopupOpen) {
        openTosUpdatePopup();    
      }
      
    });

    function openTosUpdatePopup() {
      $rootScope.tosPopupOpen = true;
      var confirmPopup = $ionicPopup.confirm({
        title: $filter('translate')('CONFIRM_NEW_TERMS_OF_USE'),
        template: $filter('translate')('CONFIRM_NEW_TERMS_OF_USE_TEXT'),
        cssClass: 'confirm-popup',
        cancelText: $filter('translate')('CANCEL'),
        okText: $filter('translate')('CONFIRM')
      })
      .then(function(res) {
        $rootScope.tosPopupOpen = false;
        if(res) {
          if($rootScope.askForEmailPermission) {
            openEmailPermissionPopup();
          } else {
            updateTosCall(false);
          }
          
        }
        
      });
    }

    function openEmailPermissionPopup() {
      var confirmPopup = $ionicPopup.confirm({
        title: $filter('translate')('CONFIRM_EMAIL_PERMISSIONS'),
        template: $filter('translate')('CONFIRM_EMAIL_PERMISSIONS_TEXT'),
        cssClass: 'confirm-popup',
        cancelText: $filter('translate')('APP_RATE_NO'),
        okText: $filter('translate')('APP_RATE_YES')
      })
      .then(function(res) {
        if(res) {
          updateTosCall(true);
        } else {
          updateTosCall(false);
        }
        
      });
    }

    function updateTosCall(mailPermission) {
      $_tos.updateTos(mailPermission).then(function(data) {
        var type = $_notification.getNotificationTypes().POSITIVE;
        var msg = $filter('translate')('TOS_UPDATE_SUCCESS');

        $_notification.showNotificationBar(msg, type);
      },
      function(error){
        var type = $_notification.getNotificationTypes().ERROR;
        var msg = $filter('translate')('TOS_UPDATE_FAIL');

        $_notification.showNotificationBar(msg, type);
      });
    }


  /*
   * Window Listener für das Verschieben von Popups und anderen Elementen, wenn die Tastatur geöffnet wird
   */
  function keyboardHideHandler(e){
    if(cordova.platformId === 'ios'){
      setTimeout(function(){
        var oldHeight = window.screen.height;
        $('.setHeight').css('height', oldHeight + 'px');
      }, 50);
    }

    $('.setMargin').css('margin-bottom',  '0px');
  }

  function keyboardShowHandler(e){
    if(cordova.platformId === 'ios'){
      setTimeout(function(){
        var newHeight = window.screen.height - e.keyboardHeight;
        $('.setHeight').css('height', newHeight+'px');
        $('.setHeight').css('transition', 'all 250ms');
      }, 50);
    }

     $('.setMargin').css('margin-bottom',  '15px');
  }

  window.addEventListener('native.keyboardshow', keyboardShowHandler);
  window.addEventListener('native.keyboardhide', keyboardHideHandler);


  $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    $rootScope.rootCurrentTab = $_helper.getCurrentTab($state);
  });

  $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams, options){
    var newState = toState.name;
    var fromState = fromState.name;

    if(newState != 'tab.blury' && newState != 'tab.chats' && newState != 'tab.flirts' && newState != 'tab.account' && fromState != 'tab.' + $rootScope.rootCurrentTab + '-flirt-detail-rate') {
      $_sound.playClick();
    } else if(newState == 'tab.blury' && (fromState == 'tab.chats' || fromState == 'tab.flirts' || fromState == 'tab.account')) {
      $_sound.playTabChange();
    }
  });

  $rootScope.tabSelect = function() {
    $_sound.playTabChange();
  }

  $rootScope.notifyIonicGoingBack = function() {
    $_sound.playClick();
  }
  
})


.config(function($stateProvider, $urlRouterProvider, $translateProvider) {

  $stateProvider

  // Startscreen

  .state('start-screen', {
    url: '/start-screen',
    templateUrl: 'templates/start-screen.html',
    onEnter: function($state, $_sdk, $_account_cache){
      if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
        $state.go('tab.blury');
      }
    }
  })

  // Slider

  .state('introduction-swiper', {
    url: '/introduction-swiper',
    templateUrl: 'templates/introduction-swiper.html',
    controller: 'IntroductionSwiperCtrl',
    onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
  })

  // Login

  .state('login', {
    url: '/login',
    templateUrl: 'templates/login.html',
    controller: 'LoginCtrl',
    onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
  })

  .state('password-recovery', {
    url: '/password-recovery/:mail',
    templateUrl: 'templates/password-recovery.html',
    controller: 'PasswordRecoveryCtrl',
    onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
  })

  //Registration

    .state('registrate-step1', {
      url: '/registrate/step1',
      templateUrl: 'templates/registrate-step1.html',
      controller: 'RegistrateCtrl',
      onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
    })

    .state('registrate-step2', {
      url: '/registrate/step2',
      templateUrl: 'templates/registrate-step2.html',
      controller: 'RegistrateCtrl',
      onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
    })

    .state('registrate-step3', {
      url: '/registrate/step3',
      templateUrl: 'templates/registrate-step3.html',
      controller: 'RegistrateCtrl',
      onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
    })

    .state('registrate-step4', {
      url: '/registrate/step4',
      templateUrl: 'templates/registrate-step4.html',
      controller: 'RegistrateCtrl',
      onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined && $_account_cache.isLoggedIn() == true){
          $state.go('tab.blury');
        }
      }
    })

    // Andere alleinstehende Seiten

    .state('terms-of-use', {
      url: '/registrate/terms-of-use',
      templateUrl: 'templates/terms-of-use.html',
      controller: 'TermsOfUseCtrl'
    })

    .state('privacy-policy', {
      url: '/registrate/privacy-policy',
      templateUrl: 'templates/privacy-policy.html',
      controller: 'PrivacyPolicyCtrl'
    })

    .state('take-photo', {
        url: '/take-photo/:id',
        templateUrl: 'templates/take-photo.html',
        controller: 'TakePhotoCtrl'
    })

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html',
    onEnter: function($state, $_sdk, $_account_cache){
        if($_sdk.getUserID() == null || $_sdk.getUserID() == undefined && $_account_cache.isLoggedIn() != true){
           $state.go('start-screen');
        }
    }
  })

  // Each tab has its own nav history stack:

  .state('tab.blury', {
    url: '/blury',
    views: {
      'tab-blury': {
        templateUrl: 'templates/tab-blury.html',
        controller: 'BluryCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = false;
      $_helper.refreshBadges();
    }
  })

  .state('tab.chats', {
    url: '/chats',
    views: {
      'tab-chats': {
        templateUrl: 'templates/tab-chats.html',
        controller: 'ChatsCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
        $rootScope.hideTabs = false;
        $_helper.refreshBadges();
      }
  })

  .state('tab.flirts', {
    url: '/flirts',
    views: {
      'tab-flirts': {
        templateUrl: 'templates/tab-flirts.html',
        controller: 'FlirtsCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = false;
      $_helper.refreshBadges();
    }
  })

  .state('tab.account', {
    url: '/account',
    views: {
      'tab-account': {
        templateUrl: 'templates/tab-account.html',
        controller: 'AccountCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = false;
      $_helper.refreshBadges();
    }
  })

  .state('tab.verify-account', {
    url: '/account/verify-account/:id',
    views: {
      'tab-account': {
        templateUrl: 'templates/verify-account.html',
        controller: 'VerifyAccountCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = true;
    }
  })

  .state('tab.delete-account', {
    url: '/account/delete-account',
    views: {
      'tab-account': {
        templateUrl: 'templates/delete-account.html',
        controller: 'DeleteAccountCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = true;
    }
  })

  .state('tab.change-password', {
    url: '/account/change-password',
    views: {
      'tab-account': {
        templateUrl: 'templates/change-password.html',
        controller: 'ChangePasswordCtrl'
      }
    },
    onEnter: function ($rootScope) {
      $rootScope.hideTabs = true;
    }
  })

  .state('tab.change-email', {
    url: '/account/change-email',
    views: {
      'tab-account': {
        templateUrl: 'templates/change-email.html',
        controller: 'ChangeMailCtrl'
      }
    },
    onEnter: function ($rootScope) {
      $rootScope.hideTabs = true;
    }
  })

  .state('tab.blocked-users', {
    url: '/account/blocked-users',
    views: {
      'tab-account': {
        templateUrl: 'templates/blocked-users.html',
        controller: 'BlockedUsersCtrl'
      }
    },
    onEnter: function ($rootScope, $_helper) {
      $rootScope.hideTabs = true;
    }
  })

  /*
  * Unterseiten, die von verschiedenen Tabs aus erreichbar sein sollen, müssen hier angelegt werden.
  * Dies verhindert, dass der Back-Button nicht funktioniert/ nicht angezeigt wird.
  */
  var tabs = ["blury", "chats", "flirts", "account", "registrate"]; // Alle Tabs

  for (index = 0; index < tabs.length; index++) {
    var tabName = tabs[index];
    var tab_tabName = 'tab-' + tabName;

    $stateProvider
      .state('tab.'+tabName+'-flirt-detail', {
        url: '/'+tabName+'/flirts/:flirtId',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/flirt-detail.html',
            controller: 'FlirtDetailCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-create-account', {
        url: '/' +tabName+ '/create-account',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/create-account.html',
            controller: 'CreateAccountCtrl'
          }
        },
        onEnter: function ($rootScope, $_helper) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-chat-detail', {
        url: '/'+tabName+'/chat-detail/:chatId',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/chat-detail.html',
            controller: 'ChatDetailCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-profile', {
        url: '/'+tabName+'/profile/:id',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/tab-profile.html',
            controller: 'ProfileCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = false;
        }
      })

      .state('tab.'+tabName+'-flirt-detail-rate', {
        url: '/'+tabName+'/flirts/:flirtId/rate/:roundId',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/flirt-detail-rate.html',
            controller: 'FlirtDetailRateCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-flirt-detail-answer', {
        url: '/'+tabName+'/flirts/:flirtId/answer/:roundId',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/flirt-detail-answer.html',
            controller: 'FlirtDetailAnswerCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-flirt-detail-my-answer', {
        url: '/'+tabName+'/flirts/:flirtId/my-answer/:roundId',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/flirt-detail-my-answer.html',
            controller: 'FlirtDetailMyAnswerCtrl'
          }
        },
        onEnter: function ($rootScope) {
          $rootScope.hideTabs = true;
        }
      })

      .state('tab.'+tabName+'-show-points', {
        url: '/'+tabName+'/show-points',
        views: {
          [tab_tabName]: {
            templateUrl: 'templates/show-points.html',
            controller: 'ShowPointsCtrl'
          }
        },
        onEnter: function ($rootScope, $_helper) {
          $_helper.refreshBadges();
        }
      })
  }

  $urlRouterProvider.otherwise('/start-screen'); // Standardscreen, bei fehlerhaftem Routing

  $translateProvider
    .useStaticFilesLoader({
        prefix: 'js/locales/',
        suffix: '.json'
      })
      .registerAvailableLanguageKeys(['en', 'de'], {
        'en' : 'en', 'en_GB': 'en', 'en_US': 'en',
        'de' : 'de', 'de_DE': 'de', 'de_CH': 'de'
      })
      .preferredLanguage('de')
      .fallbackLanguage('de')

      .registerAvailableLanguageKeys(['en', 'de'], {
        'en' : 'en',
        'en_GB': 'en',
        'en_US': 'en',
        'de' : 'de',
        'de_DE': 'de',
        'de_CH': 'de',
        'de_AT': 'de',
        '*':'en'

     })
      .preferredLanguage('de')
      .fallbackLanguage('de') // Zu 'en' ändern, wenn englische Übersetzungen vorhanden sind


      .determinePreferredLanguage()
      .useSanitizeValueStrategy('escapeParameters');
})

.filter('unsafe', function($sce) { return $sce.trustAsHtml; })

.constant('LOCALES', {
    'locales': [{
          name: 'Deutsch',
          key: 'de_DE',
          abbr: 'de',
          language_id: 1
        },{
          name: 'English',
          key: 'en_US',
          abbr: 'en',
          language_id: 2
        }]
})

.constant('CONFIG', {
    'min_age': 16
});
