angular.module('account.controller', [])

.controller('AccountCtrl', function($scope, $cordovaDatePicker, $_helper, $timeout, $translate, $_locale_settings, $ionicConfig, $rootScope, $location,
	$_account_cache, $_account, $_notification, $ionicPlatform, $state, $_popup, $filter, $_language, $_language_cache, $_sdk, $translate, $ionicScrollDelegate, 
	$_tracking, CONFIG, $_login, $_sound, $_crop, $_upload, $ionicModal, $log, $stateParams, $_file_cache, $_nativestorage, $cordovaSocialSharing, $ionicPopup) {

	$scope.attachment = {
		hasMedia: false,
		fileUrl: null,
		previewFileStorageKey: "",
		cropper: {}
	};
	$scope.load = {};
	$scope.load.isUploading = false;
	$scope.load.percent = 0;

	$_helper.initIonicModal($scope);

	var age_slider;
	var age_slider_data;
	var mediaTypeId = 1; //1 == Profilbild
	var objectId = $_sdk.getUserID();
	var cacheFileKey;

	$scope.page = {
		loaded : false,
		show_create_account: false,
		has_registered: false
	}

	$scope.sounds = $_sound;

	$scope.$on("$ionicView.enter", function(event, data){
		$timeout(function(){
			$scope.page.loaded = true;
			presentBlur();
		}, 250);
	});

	$scope.$on("$ionicView.beforeEnter", function(event, data){
    
		$_tracking.trackPage("Account Screen");

		cacheFileKey = "image_" + objectId + "_" + mediaTypeId;

		window.addEventListener('native.keyboardshow', keyboardShowHandler);
		window.addEventListener('native.keyboardhide', keyboardHideHandler);

		var showCreateAccountBox = $_account_cache.getShouldShowCreateAccountBox();
		if(showCreateAccountBox) {
			$ionicScrollDelegate.scrollTop();
			$ionicScrollDelegate.freezeAllScrolls(true);
		}

		$timeout(function(){
			$scope.page.show_create_account = $_account_cache.getShouldShowCreateAccountBox();
			$scope.page.has_registered = $_account_cache.getUserHasRegistered();
		}, 25);

		var data = $_account_cache.getAccountData();
    //console.log("FROMCACHE:");
    //console.log(data);
    //console.log($scope.formdata);

    $scope.formdata = {};
    $scope.formdata.user_has_image = 0;
    $scope.select = {};

    if(data != null && data != undefined) {

      setSlider(data);
      fillFormData(data," BEFOREENTTER");
      //loadProfileImage();

      if(data.login_type != 'device_id' && data.login_type != null && data.login_type != undefined) {
        $scope.hideCreateAccountBox();
      }
    }

    $scope.blur = {};
    $scope.blur.active = 0;
    $scope.blur.present = 0;

    $scope.input1_focused = false;
    $scope.input2_focused = false;
    $scope.input3_focused = false;

    $rootScope.badges.account = 0;

    requestAccountData();
    requestLanguages();

    // Camera-Fix
    if($rootScope.cameraState.takingPicture && $rootScope.cameraState.currentScreen == "account") {
      $rootScope.cameraState.currentScreen = "";
      $scope.cropImage($rootScope.cameraState.imageUri);
    }



	});

	$ionicPlatform.on('pause', function() {
		//$scope.saveData(false);
	});

	$ionicPlatform.on('resume', function(){
	      requestAccountData();
	      requestLanguages();
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		//$scope.saveData(false);
		$ionicScrollDelegate.freezeAllScrolls(false);
	});

	$scope.$on('$ionicView.afterLeave', function(){
		$_helper.refreshNewTab();
	});

	$scope.$on('refresh-account-tab', function(event, args) { // Reagiert auf Push-Benachrichtigung bzgl. des Profils
      requestAccountData();
  });

	/* Hinweis zum Erstellen eines Accounts verbergen. */
	$scope.hideCreateAccountBox = function() {
		$timeout(function(){
			$scope.page.show_create_account = false;
		}, 25);

		$_account_cache.setShouldShowCreateAccountBox(false);
		$ionicScrollDelegate.freezeAllScrolls(false);

		$timeout(function(){
			$ionicScrollDelegate.resize();
		}, 250);
	}

	function requestAccountData() {
		$_account.getAccountData().then(
			function(accountData){
				fillFormData(accountData);
				setSlider(accountData);

				if(accountData.login_type != 'device_id') {
					$scope.hideCreateAccountBox();
				}
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			}
		);
	}

	function requestLanguages() {
		$_language.getLanguages().then(
			function(languages) {
				$scope.languages = languages;
				var setLanguage = $_language_cache.getLanguageSettings();

				for(var i=0; i <= $scope.languages.length-1; i++) { // Setzt ng-model Variable, für die initiale Sprache
					if($scope.languages[i].languages_id == setLanguage.id) {
						$scope.select.selectedLang = $scope.languages[i];
					}
				}
			},
			function(error) {
				$_notification.showNotificationBar(error.msg, error.type);
			}
		);
	}

	$scope.$watch("select.selectedLang", function(newValue, oldValue) {
		if(newValue == null || newValue == undefined) {
			$scope.select.selectedLang = oldValue;
		}
	});

	function fillFormData(data) {
		var is_external = false;
		var date = $_helper.getDate(data.datevalue);
		var soundIsActive = $_account_cache.getSoundSetting();
		var vibrationIsActive = $_account_cache.getVibrationSetting();

		$timeout(function(){
			if(data.only_verified_profiles == 0 || data.only_verified_profiles == 1) data.only_verified_profiles = $_helper.isFalseOrTrue(data.only_verified_profiles);
			if(data.allow_only_verified_flirts == 0 || data.allow_only_verified_flirts == 1) data.allow_only_verified_flirts = $_helper.isFalseOrTrue(data.allow_only_verified_flirts);
			if(data.use_home_location == 0 || data.use_home_location == 1) data.use_home_location = $_helper.isFalseOrTrue(data.use_home_location);

			$scope.formdata = {
				name: data.name,
				city: data.city,
				hashtag1: data.hashtag1,
				hashtag2: data.hashtag2,
				hashtag3: data.hashtag3,
				looking_for_distance: data.looking_for_distance,
				looking_for_age_from: data.looking_for_age_from,
				looking_for_age_to: data.looking_for_age_to,
				looking_for_age_to_min: parseInt(data.looking_for_age_from) + 4,
				sounds: soundIsActive,
				vibrations: vibrationIsActive,
				looking_for_gender: data.looking_for_gender,
				gender: data.gender,
				datepicker: date,
				birthdate: data.datevalue,
				profile_img: data.profile_img,
				datevalue: data.datevalue,
				login_type: data.login_type,
				email: data.email,
				verification_status: data.verification_status,
				current_media_object: data.current_media_object,
				only_verified_profiles: data.only_verified_profiles,
				allow_only_verified_flirts: data.allow_only_verified_flirts,
				home_location_id: data.home_location_id,
				home_location_city: data.home_location_city,
				use_home_location: data.use_home_location,
				current_points: data.current_points
			}

			if($scope.formdata.current_media_object > 0) $scope.formdata.user_has_image = 1;
			else $scope.formdata.user_has_image = 2;

			$scope.lastAgeFrom = data.looking_for_age_from;
			$scope.lastAgeTo = data.looking_for_age_to;
			$scope.lastDistance = data.looking_for_distance;

		}, 50);
	}

	$scope.saveDistance = function() {
		if($scope.lastDistance != $scope.formdata.looking_for_distance) {
			$scope.lastDistance = $scope.formdata.looking_for_distance;
			$scope.saveData();
		}
	};
  
	$scope.saveData = function(show_notification) {
		if(checkHashtags()) {
			$_account.saveAccountData($scope.formdata).then(
				function(success){
					$_tracking.trackEvent("Profile", "Edit", "", 0);
					$rootScope.filterChanged = true;
					if(show_notification != false) {
						$timeout(function(){
							$_notification.showNotificationBar(success.msg, success.type);
						}, 250);
					}

					$timeout(function(){
						if($scope.formdata.allow_only_verified_flirts == 0 || $scope.formdata.allow_only_verified_flirts == 1) $scope.formdata.allow_only_verified_flirts = $_helper.isFalseOrTrue($scope.formdata.allow_only_verified_flirts);
						if($scope.formdata.use_home_location == 0 || $scope.formdata.use_home_location == 1) $scope.formdata.use_home_location = $_helper.isFalseOrTrue($scope.formdata.use_home_location);
					}, 250);
				},
				function(error){
					if(show_notification != false) {
						$timeout(function(){
							$_notification.showNotificationBar(error.msg, error.type);
						}, 250);
					}

					if(error.code == 263) {
						$timeout(function(){
							$scope.formdata.allow_only_verified_flirts = false;
							$scope.formdata.only_verified_profiles = false;
						}, 350);
					}
				}
			);
		}
	}

	/*
	 * Überprüft die Hashtags auf Gültigkeit:
	 * - länger als 2 Zeichen
	 * - alle verschieden
	 */
	function checkHashtags() {
		var hashtag1 = $scope.formdata.hashtag1;
		var hashtag2 = $scope.formdata.hashtag2;
		var hashtag3 = $scope.formdata.hashtag3;

		var hashtagEqualFailMsg = function() {
			var msg = $filter('translate')('YOUR_HASHTAGS_MUST_BE_DIFFERENT_FROM_EACH_OTHER');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);
		}

		if($scope.formdata.hashtag1.length < 2 || $scope.formdata.hashtag2.length < 2 || $scope.formdata.hashtag3.length < 2) {
			var msg = $filter('translate')('YOUR_HASHTAG_MUST_BE_MIN_TWO_CHARS');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);

			return false;
		}

		if(hashtag1 == hashtag2 || hashtag1 == hashtag3) {
			hashtagEqualFailMsg();
			return false;
		}

		if(hashtag2 == hashtag1 || hashtag2 == hashtag3) {
			hashtagEqualFailMsg();
			return false;
		}

		if(hashtag3 == hashtag1 || hashtag3 == hashtag2) {
			hashtagEqualFailMsg();
			return false;
		}

		return true;
	}

	function setSlider(data) {
		var for_age_from = data.looking_for_age_from;
		var for_age_to = data.looking_for_age_to;
		var looking_to_min = parseInt(for_age_from) + 4;
		var looking_from_max = parseInt(for_age_from) - 4;

		var ageSliderOptions = {
			min: CONFIG.min_age,
			max: 50,
			type: 'double',
			hide_min_max: true,
			hide_from_to: true,
			to_min: looking_to_min,
			from_max: looking_from_max,
			onFinish: updateMinMax
		}

		age_slider = $("#age_slider");
		age_slider.ionRangeSlider(ageSliderOptions);
		age_slider_data = $("#age_slider").data("ionRangeSlider");

		age_slider_data.update({
			from: for_age_from,
			to: for_age_to
		});

		age_slider.on("change", onSliderChange);
	}

	$scope.openDatePicker = function() {
		var options = $_helper.getBirthDatePickerOptions();
		$scope.formdata.datevalue = new Date();
		options.date = $scope.formdata.birthdate;

		$cordovaDatePicker.show(options).then(function(date){
			if(date == null || date == undefined) {
			} else if(moment().diff(date, 'years') < CONFIG.min_age) {
	    		$_notification.showNotificationBar(
	    			$filter('translate')('YOU_HAVE_TO_BE_OVER_16'),
	    			$_notification.getNotificationTypes().ERROR
	    		);
	    	} else {
	    		$scope.formdata.datevalue = new Date(date);
				$scope.formdata.datepicker = moment(date).format('DD. MMMM YYYY');
				$scope.formdata.birthdate = new Date(date);
	    	}
		});
	};

	$scope.resetBlur = function() {
		var elem = $('.profile-img-selector-account');
		$scope.blur.active = 0;
		$_helper.resetBlur(elem);
	}

	$scope.blurImage = function() {
		$scope.blur.active = 1;
		var elem = $('.profile-img-selector-account');
		$_helper.blurProfileImage(elem);
	}

	function keyboardShowHandler() {
		//$ionicScrollDelegate.resize();
	}

	function keyboardHideHandler() {
		//$ionicScrollDelegate.resize();
	}

	function onSliderChange () {
		var $this = $(this),
		value = $this.prop("value").split(";");

		if($scope.formdata.looking_for_age_from != value[0]) {
			$timeout(function(){
				$scope.formdata.looking_for_age_from = value[0];
			},25);
		}

		if($scope.formdata.looking_for_age_to != value[1]) {
			$timeout(function(){
				$scope.formdata.looking_for_age_to = value[1];
			},25);
		}
	}

	/*
	* Der Abstand zwischen gesuchtem Mindest- und Höchstalter muss immer 4 Jahre betragen.
	* Dies wird hier garantiert.
	*/
	var updateMinMax = function (data) {
		var new_from_max = data.to - 4;
		var new_to_min = data.from + 4;

		$timeout(function(){
			$scope.formdata.looking_for_age_from_max = parseInt(new_from_max);
			$scope.formdata.looking_for_age_to_min = parseInt(new_to_min);
		},25);

		if(age_slider_data != null && age_slider_data != undefined && ($scope.lastAgeFrom != data.from || $scope.lastAgeTo != data.to)) {
			$scope.saveData();
			$scope.lastAgeFrom = data.from;
			$scope.lastAgeTo = data.to;
		}
	};

	$scope.$watch("formdata.looking_for_age_to_min", function(newValue, oldValue) {
		if($scope.formdata != null && $scope.formdata != undefined) {
			var new_to_min = $scope.formdata.looking_for_age_to_min;

			if(age_slider_data != null && age_slider_data != undefined) {
				age_slider_data.update({
					to_min: new_to_min
				});
			}
			
		}
	});

	$scope.$watch("formdata.looking_for_age_from_max", function(newValue, oldValue) {
		if($scope.formdata != null && $scope.formdata != undefined) {
			var new_from_max = $scope.formdata.looking_for_age_from_max;

			if(age_slider_data != null && age_slider_data != undefined) {
				age_slider_data.update({
					from_max: new_from_max
				});
			}
		}
	});

	$scope.$watch("formdata.hashtag1", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.formdata.hashtag1 = oldValue;
		}
	});

	$scope.$watch("formdata.hashtag2", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.formdata.hashtag2 = oldValue;
		}
	});

	$scope.$watch("formdata.hashtag3", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.formdata.hashtag3 = oldValue;
		}
	});

	$scope.$watch("formdata.sounds", function(newValue, oldValue) {
		$_account_cache.saveAccountData($scope.formdata);
		$_account_cache.setSoundSetting(newValue);
	});

	$scope.$watch("formdata.vibrations", function(newValue, oldValue) {
		$_account_cache.saveAccountData($scope.formdata);
		$_account_cache.setVibrationSetting(newValue);
	});

	function checkVerificationStatus() {
		if($scope.formdata.login_type == 'device_id') {
			$_notification.showNotificationBar(
				$filter('translate')('CREATE_AND_VERIFICATE_ACCOUNT_TO_USE_THIS_OPTIONS'),
				$_notification.getNotificationTypes().ERROR
			);
		} else {
			$_notification.showNotificationBar(
				$filter('translate')('VERIFICATE_ACCOUNT_TO_USE_THIS_OPTIONS'),
				$_notification.getNotificationTypes().ERROR
			);
		}
	}

	$scope.changeVerifiedProfilesOption = function() {
		if($scope.formdata.verification_status == 'wait' || $scope.formdata.verification_status == 'check') {
			checkVerificationStatus();

			$timeout(function(){
				$scope.formdata.only_verified_profiles = false;
			}, 350);
		} else {
			$scope.saveData();
		}
	}

	$scope.changeVerifiedFlirtsOption = function() {
		if($scope.formdata.verification_status == 'wait' || $scope.formdata.verification_status == 'check') {
			checkVerificationStatus();

			$timeout(function(){
				$scope.formdata.allow_only_verified_flirts = false;
			}, 350);
		} else {
			$scope.saveData();
		}
	}

	$scope.changeHomeLocationOption = function() {
		if($scope.formdata.home_location_id == 0) {
			$_notification.showNotificationBar(
				$filter('translate')('SET_HOME_LOCATION_FIRST'),
				$_notification.getNotificationTypes().ERROR
			);

			$timeout(function(){
				$scope.formdata.use_home_location = false;
			}, 350);
		} else {
			$scope.saveData();
		}
	}

	$scope.setHomeLocation = function() {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('SET_HOME_LOCATION'),
			template: $filter('translate')('SET_HOME_LOCATION_ALERT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('APP_RATE_NO'),
        	okText: $filter('translate')('YES')
		})
		.then(function(res) {
			if(res) {
				$_account.setHomeLocation().then(
					function(data){
						$log.debug(data);
						
						$timeout(function(){
							$scope.formdata.home_location_city = data.city;
							$scope.formdata.home_location_id = data.user_location_id;

						},25);
						$_notification.showNotificationBar(
							$filter('translate')('SET_HOME_LOCATION_SUCCESSFUL'),
							$_notification.getNotificationTypes().POSITIVE
						);
					},
					function(error){
						$_notification.showNotificationBar(error.msg, error.type);
					}
				);
			} else {
			  
			}

		});
	
	}

	$scope.openFAQ = function() {
		window.open('http://www.bluryapp.com/faq', '_blank', "location=no");
	}

	$scope.getHelp = function() {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('GET_HELP_TITLE'),
			template: $filter('translate')('GET_HELP_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('HELP'),
			okText: $filter('translate')('FAQ')
		})
		.then(function(res) {
			if(res) {
				$scope.openFAQ();
			} else {
			  	cordova.getAppVersion.getVersionNumber().then(function (version) {
				    cordova.plugins.email.open({
						to:      'info@bluryapp.com',
						subject: 'Blury Hilfe',
						isHtml:  true,
						body:    "Ich brauche Hilfe bei:<br><br><br><br><br><br>------------<br>Meine Systeminfos:<br>Betriebssystem: "+device.platform+"<br>Version: "+device.version+"<br>Hersteller: "+device.manufacturer+"<br>Model: "+device.model+"<br>App-Version: "+version
					});
				});
			}

		});


		
		
	}

	$scope.sendFeedback = function() {
		cordova.plugins.email.open({
			to:      'info@bluryapp.com',
			subject: 'Blury Feedback',
			body:    'Mein Feedback zu Blury:'
		});
	}

	$scope.suggestQuestions = function() {
		cordova.plugins.email.open({
			to:      'info@bluryapp.com',
			subject: 'Blury Fragen vorschlagen',
			body:    'Ich möchte folgende Fragen vorschlagen:'
		});
	}

	$scope.sharePrompt = function() {
		//console.log("share");
	    $_account.getShareLink().then(function(data) {
	    	//console.log(data);
	    	$cordovaSocialSharing.share(data.text, null, null, data.share_link);
	    },
		function(error){
			$timeout(function(){
				$_notification.showNotificationBar(error.msg, error.type);
			}, 250);
		});


	    
	};

	$scope.goToFB = function() {
		window.open("https://fb.me/bluryapp/", '_system');
	}

	$scope.goToIG = function() {
		window.open('http://instagram.com/blury_app/', '_system');
	}

	$scope.newsletterSubscription = function() {
		window.open('http://www.bluryapp.com/newsletter?e='+$scope.formdata.email, '_system');
	}

	$scope.verifyAccount = function() {
		if($scope.formdata.verification_status == 'wait' && $scope.formdata.login_type == "device_id") {
			$_popup.createAccountToVerificatePopup();
		} else if($scope.formdata.verification_status == 'wait' && $scope.formdata.login_type != "device_id") {
			$state.go('tab.verify-account', {id: $scope.formdata.current_media_object});
		}
	}

	$scope.changeProfilePicture = function() {
		$state.go('take-photo');
	};

	$scope.changeLanguage = function(obj) {
		$timeout(function(){
			var key = obj.languages_shortkey;
			var language_id = obj.languages_id;
			var languages_name = obj.languages_name;

			$scope.formdata.language_id = language_id;
			$_language.setLanguage(language_id, key, languages_name);
		}, 50);
	};

	/* Zeigt den Blur-Effekt beim Aufruf der Seite an. */
	function presentBlur() {
		var elem = $('.profile-img-selector-account');
		$timeout(function(){
			$scope.blur.present = 1;
			$scope.blurImage();
			$timeout(function(){
				$scope.blur.present = 0
				$scope.resetBlur(elem);
			}, 1000);
		},1000);
	}

	$scope.logout = function() {
		$_login.logout();
	};

	/* Image-Upload-Handling START */

	function loadProfileImage() {
		$_file_cache.read(cacheFileKey).then(function(content) {
			$log.debug("Erfolgreich Foto "+cacheFileKey+" geladen");
			$scope.formdata.profile_img = content;
		}).catch(function(err) {
			$log.debug("Konnte Foto "+cacheFileKey+" NICHT geladen");
			$log.debug(err);
		});
	}

	$scope.submitCroppedMedia = function() {
		// Upload-Indicator
		$timeout(function(){
			$scope.load.isUploading = true;
			$scope.load.percent = 0;
			$_upload.uploadPopup($scope);
		}, 50);

		// Upload-Prozess
		var saveProfileImage = function(sourceImage) {

			//$_helper.convertLocalImageToBase64(sourceImage,  function(base64) {  
				/*
				Mögliche Fehlerquelle: QuotaExceededError (DOM Exception 22): The quota has been exceeded.
				Habe es deswegen jetzt über den $_file_cache gelöst
				$_account_cache.saveAccountImage(base64);
				*/
				//$_file_cache.save(cacheFileKey, base64).then(function() {
				$_file_cache.save(cacheFileKey, sourceImage).then(function() {
					$log.debug("Erfolgreich Foto "+cacheFileKey+" gecached");

					$_account_cache.saveOldAccountImageIdBeforeUpload($_account_cache.getOldAccountImageId());
					$_account_cache.saveOldAccountImageId(0);
					$_account_cache.setUserHasProfileImage(true);
					$_account_cache.saveAccountImage(cacheFileKey);

					loadProfileImage();
				}).catch(function(err) {
					$log.debug("Konnte Foto "+cacheFileKey+" NICHT cachen");
				});
			//});

		};

		$scope.$evalAsync(function(){
			$_sdk.setObjectID(objectId);
			$_sdk.upload(mediaTypeId, $scope.attachment.cropper.resizedImage, function(currentStatus){

			    $timeout(function(){
					$scope.load.percent = parseInt(currentStatus);
			    }, 25);

			}, function(response){ // Upload erfolgreich
				var responseJSON = JSON.parse(response.response);
				$log.debug(responseJSON);
				if(responseJSON.ack == "failure"){

					$log.error("responseJSON.ack failure");
          $log.error(responseJSON);
					var msg = $filter('translate')('UPLOAD_FAILED');
					if(responseJSON.code == 244) msg = $filter('translate')('NO_FACE_RECOGNIZED');

					var type = $_notification.getNotificationTypes().ERROR;
					$_popup.closeAllOpenedPopups();
					$_notification.showNotificationBar(msg, type);
					$scope.load.isUploading = false;

				} else if(responseJSON.ack == "success") {

					$log.debug("responseJSON.ack success");

					$scope.load.isUploading = false;
					$_popup.closeAllOpenedPopups();

					if(mediaTypeId == 1) { // Profilbild
						saveProfileImage($scope.attachment.cropper.croppedImage);
						$_account_cache.setUserHasProfileImage(true);
						$scope.formdata.user_has_image = 1;
					}
				}

			}, function(error) { // Upload error
        $log.error(error);
				$timeout(function(){ // 244
					$_popup.closeAllOpenedPopups();
					var type = $_notification.getNotificationTypes().ERROR;
					var msg = $filter('translate')('UPLOAD_FAILED');
					$_notification.showNotificationBar(msg, type);
				}, 50);
			});
		});
	};

	$scope.cropImage = function(fileURL) {
		$rootScope.cameraState.takingPicture = false;
		plugins.crop.promise(fileURL, {
			quality: 100
		}).then(function success (newPath) {
			$scope.attachment.cropper.croppedImage = newPath;
			$scope.formdata.profile_img = newPath;

			$_upload.resizeImage(1000, newPath, function(data) {
          $scope.attachment.cropper.resizedImage = data;
          $scope.submitCroppedMedia();
      });

			//$scope.submitCroppedMedia();
		}).catch(function fail (err) {
			$log.debug("Crop Fail err");
			$log.debug(err);
		});
	};

	$scope.showTakePhotoActionsheet = function() {

		var setUploadFile = function(fileURL, previewFileStorageKey, previewID) {
		    
	    $scope.attachment.hasMedia = true;
	    $scope.attachment.fileUrl = fileURL;
	    $scope.attachment.previewFileStorageKey = previewFileStorageKey;

			$rootScope.cameraState.imageUri = fileURL;

			$scope.cropImage(fileURL);
		};

		var imageHandler = function(source) {
		  $_upload.getImage(source).then(function(imageUri) {
		    setUploadFile(imageUri, "previewProfileImage", "profile_image");
		  }).catch(function(err) {
		    $log.debug("$_upload.getImage catch: ");
		    $log.debug(err);
		    
		    var msg = $filter('translate')('CHOOSE_FOTO_FAIL');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);

		    $rootScope.cameraState.takingPicture = false;
		  });
		};


		$_upload.uploadFileActionSheet().then(function(type) {
			$_popup.showPhotoRulesPopup().then(function() {
				$rootScope.cameraState.takingPicture = true;
				$rootScope.cameraState.imageUri = "";
				$rootScope.cameraState.currentScreen = "account";
				imageHandler($_helper.getImageSourceFromCam(type));
			}).catch(function(err) {
				$log.debug(err);
			});
		  
		}).catch(function(err) {
		  $log.debug(err);
		});
	};

	/* Image-Upload-Handling END */

});
