angular.module('blocked_users.controller', [])

.controller('BlockedUsersCtrl', function($scope, $cordovaDatePicker, $_helper, $timeout, $translate, $_options, $_tracking, 
	$_user_block, $_notification, $_blocked_users_cache, $ionicPopup, $filter, $ionicScrollDelegate, $ionicActionSheet) {
	$scope.data = {};
	$scope.load = {};
	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Blocked Users Screen");
		$scope.load.infinite = true;

		$scope.data.blocked = $_blocked_users_cache.getBlockedUsers();
		getBlockedUsers();
	});

	$scope.$on("connectivity-status-online", function(){
        $scope.load.infinite = true;
    });

	$scope.$on("connectivity-error", function(){
		$scope.load.infinite = false;
	});

	$scope.refresh = function() {
		getBlockedUsers();
	}

	function getBlockedUsers() {
		$_user_block.getBlockedUsers().then(function(blocked){
			$timeout(function(){
				$scope.data.blocked = blocked;

				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}, 50);
		}, function(error){
			if(error.code == 46) {
				$scope.data.blocked = {};
			} else {
				$_notification.showNotificationBar(error.msg, error.type);
			}

			if(error.code == 0) { // Fehler im API Call
				$scope.load.infinite = false;
			}

			$scope.$broadcast('scroll.refreshComplete');
			$scope.$broadcast('scroll.infiniteScrollComplete');
		});
	}

	$scope.loadMore = function() {
		if($scope.data.blocked == null || $scope.data.blocked == undefined || $scope.data.blocked.length == 0 || $scope.data.blocked.length == undefined || $_user_block.isOnFirstPage()) {
			getBlockedUsers();
		} else if($_user_block.isOnLastPage()) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			$_user_block.loadMore().then(
				function(res) {
					$scope.$broadcast('scroll.infiniteScrollComplete');
                    if(angular.equals($scope.data.blocked, res)) {
                        return;
                    }

                    $timeout(function(){
                    	var blockedArr = $scope.data.blocked.concat(res);

                    	$scope.data.blocked = blockedArr;
                    	$_blocked_users_cache.saveBlockedUsers($scope.data.blocked);
                    	$ionicScrollDelegate.resize();
                    }, 50);
				},
				function(error) {
					if(error.code == 0) { // Fehler im API Call
						$scope.load.infinite = false;
					}

					$scope.$broadcast('scroll.infiniteScrollComplete');
				}
			);
		}
	}

	$scope.unblockUser = function(item) {
		hideSheet = $ionicActionSheet.show({
            buttons: [
                { text: $filter('translate')('UNBLOCK') },
            ],
            titleText: $filter('translate')('OPTIONS'),
            cancelText: $filter('translate')('CANCEL'),

            cancel: function() {
            },
            buttonClicked: function(index) {
                hideSheet();
                if(index==0) unblock(item);
            }
        });
	}

	function unblock(item) {
		$_options.unblockUser(item.user_id).then(
			function(success){
				$timeout(function(){
					$timeout(function(){
						$scope.data.blocked = $_blocked_users_cache.getBlockedUsers();
					}, 25);

					$_notification.showNotificationBar(success.msg, success.type);
				}, 250);
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			}
		);
	}
});
