angular.module('blury.controller', [])

.controller('BluryCtrl', function($scope, $_sdk, $_users_cache, $_blury, $timeout, $_notification, $state, $ionicScrollDelegate, $timeout, $_registrate, $filter,
	$_location, $_login, $ionicPlatform, /*$ionicPush, */$_helper, $_tracking, $rootScope, $_image_cache, $_account_cache, $_popup, $_sound, $_account_cache, $log) {
	var refreshing = false;
	
	$scope.$on("$ionicView.enter", function(event, data){
		$_tracking.trackPage("Blury Screen");

		$scope.load = {};
        $scope.load.infinite = true;
        $scope.load.profile_image_alert = false; // Hinweis, ob Profilbild da ist oder nicht
        $scope.load.location_alert = false;

        var hasProfileImg = $_account_cache.getUserHasProfileImage();
        $scope.load.profile_image_alert = !hasProfileImg;

        $timeout(function(){

			var users = $_users_cache.getUsers();

			$log.debug("Users:");
			$log.debug(users);

			if(users != null && users != undefined && users.length != undefined && users.length > 0) {
				$timeout(function(){
					$scope.data = users;
					updateLocation();
					
					if($rootScope.filterChanged) {
						$rootScope.filterChanged = false;
						getUsers();
					}

					$_users_cache.saveUsers($scope.data);
				}, 50);
			} else {
				getUsers();
			}

		}, 50);
	});

	$scope.$on("connectivity-error", function(){
		$scope.load.infinite = false;
	});

	$scope.$on("connectivity-status-online", function(){
        $scope.load.infinite = true;
    });

    $scope.$on('$ionicView.afterLeave', function(){
		$_helper.refreshNewTab();
	});

	$scope.refresh = function() {
		if($scope.load.profile_image_alert == false && $scope.load.location_alert == false) {
			$_sound.playRefresh();
			refreshing = true;
			updateLocation();
			getUsers();
			$_users_cache.saveUsers($scope.data);
		}
	}

	function getUsers() {
		$_blury.getUsers().then(
			function(data){
				$timeout(function(){
					$scope.data = data;
					$scope.load.profile_image_alert = false;

					if(refreshing) {
						refreshing = false;
						$_sound.playRefreshFinish();
					}
					
					$scope.$broadcast('scroll.refreshComplete');
					$scope.$broadcast('scroll.infiniteScrollComplete');
				}, 50);
			},
			function(error){
				if(refreshing) {
					refreshing = false;
					$_sound.playRefreshFinish();
				}
				
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');

				if(error.code == 46) {
					$timeout(function(){
						$scope.data = {};
						$scope.load.profile_image_alert = false;
					}, 50);
				} else if(error.code == 265) {
					$timeout(function(){
						$scope.load.profile_image_alert = true;
					}, 50);
				} else if(error.code == 271) {
					$timeout(function(){
						//$scope.load.location_alert = true;
						var msg = $filter('translate')('GRANT_GPS_PERMISSIONS');
						var type = $_notification.getNotificationTypes().ERROR;
						$_notification.showNotificationBar(msg, type);
					}, 50);
				} else {
					$timeout(function(){
						$_notification.showNotificationBar(error.msg, error.type);
						$scope.load.profile_image_alert = false;
					}, 500);
				}

				if(error.code == 0 || error.code == -1) {
					$scope.load.infinite = false;
					$scope.load.profile_image_alert = false;
				}
			}
		);
	}

	$scope.startFlirt = function(user) {
		if(user.can_start_flirt) {
			$_helper.showLoadingIndicator();
			$_blury.startFlirt(user.user_id).then(
				function(success){
					$_helper.hideLoadingIndicator();
					goToFlirt(success);
				},
				function(error){
					$_helper.hideLoadingIndicator();
					$timeout(function(){
						$_notification.showNotificationBar(error.msg, error.type);
					}, 500);

					// User doesnt exist
					if(error.code == 133) {
						$_users_cache.deleteUser(user);
						$scope.data = $_blury.removeUserFromList($scope.data, user.user_id);
					}
				}
			);
		} else {
			$_popup.verificateAccountToStartFlirtPopup();
		}
	}

	$scope.loadMore = function() {
		if(($scope.data == null || $scope.data == undefined || $scope.data.length == 0 || $scope.data.length == undefined/* || $_blury.isOnFirstPage()*/)
			&& $scope.load.profile_image_alert == false && $scope.load.location_alert == false) {
			//getUsers();

			// Wenn erste und letzte Seite
			if($_blury.isOnLastPage()) $scope.$broadcast('scroll.infiniteScrollComplete');

		} else if($_blury.isOnLastPage()) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			if($scope.load.profile_image_alert == true || $scope.load.location_alert == true || $scope.data.length < 16){
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			$_blury.loadMore().then(
				function(res) {
					$scope.$broadcast('scroll.infiniteScrollComplete');
                    if(angular.equals($scope.data, res)) {
                        return;
                    }

                    $timeout(function(){
                    	if($scope.data == null || $scope.data == undefined || $scope.data.length == undefined) { // check wenn scope data leer ist
                    		$scope.data = [];
                    	}

                    	//if(!checkForDoubleResults(res)) {
                    		$log.debug("$scope.data");
                    		$log.debug($scope.data);
                    		$scope.data = $scope.data.concat(res);
                    		$log.debug($scope.data);
                    		$scope.data = $_blury.removeDuplicates($scope.data, "user_id");
                    		$log.debug($scope.data);
                    		$_users_cache.saveUsers($scope.data);
                    		$ionicScrollDelegate.resize();
                    	//}
                    }, 50);
				},
				function(error) {
					$scope.$broadcast('scroll.infiniteScrollComplete');
					if(error.code == -1) {
						$_notification.showNotificationBar(error.msg, error.type);
					}
					
					if(error.code == 0 || error.code == -1) {
						$scope.load.infinite = false;
					}
				}
			);
		}
	}

	$scope.authorizeLocation = function() {
		$_location.requestLocationAuthorization().then(
			function(success){
				getUsers();
				return;
			},
			function(error){
				if(error == true) {
					authorizeLocationPopup();
				}
			}
		);
	}

	function authorizeLocationPopup() {
		var text;

		if(cordova.platformId == 'ios') text = $filter('translate')('AUTHORIZE_LOCATION_TEXT_IOS');
		if(cordova.platformId == 'android') text = $filter('translate')('AUTHORIZE_LOCATION_TEXT_ANDROID');

		$_popup.alert(
			text,
			$filter('translate')('AUTHORIZE_LOCATION_HEAD')
		);
	}

	function checkForDoubleResults(res) {
		if($scope.data.length >= res.length) {
			var start = ($scope.data.length-1) - (res.length-1);

			for(var i=0; i<=res.length-1; i++) {
				for(var x = 0; x <= res.length-1; x++) {
					if(JSON.stringify(res[i]) == JSON.stringify($scope.data[start+x])) {
						return true;
					}
				}
			}
			return false;
		}

		return false;
	}

	function goToFlirt(id) {
		var tabname = $rootScope.rootCurrentTab;
		$state.go('tab.' + tabname + '-flirt-detail', {flirtId: id});
	}

	// Aktualisiert die Entfernungen zu den jeweiligen Usern in der Liste
	function updateLocation() {
		$_location.getCurrentLocation().then(
			function(locationObj){
				$log.debug(locationObj);
				var my_lat = locationObj.lat;
				var my_lng = locationObj.lng;

				for(var i=0; i<=$scope.data.length-1; i++) {
					if($scope.data[i].use_home_location != 1) {
						var other_lat = $scope.data[i].lat;
						var other_lng = $scope.data[i].lng;

						var distance = $_location.getDistance(my_lat, my_lng, other_lat, other_lng);

						$scope.data[i].distance = parseInt(distance,10);
					}
					
				}
			}, function(error){
				$log.debug(error);
			}
		);
	}
});