angular.module('change_password.controller', [])

.controller('ChangePasswordCtrl', function($scope, $timeout, $_account, $_notification, $ionicHistory, $ionicConfig, $_tracking, $filter) {
	$scope.change = {
		password_equality: false
	};

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Passwort ändern Screen");
	});

	$scope.changePassword = function() {
		if($scope.change.password_equality != true) {
			var msg = $filter('translate')('PASSWORD_CONFIRM_NOT_EQUAL');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);
		} else if($scope.change.new_password.length < 6) {
			var msg = $filter('translate')('YOUR_PASSWORD_MUST_BE_MIN_SIX_CHARS');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);
		} else {
			$_account.changePassword($scope.change.old_password, $scope.change.new_password).then(function(success){
				$ionicHistory.goBack();

				$timeout(function(){
					$_notification.showNotificationBar(success.msg, success.type, 5000);
				}, 500);
				
			}, function(error){
				$_notification.showNotificationBar(error.msg, error.type);	
			});
		}
	}

	// Prüft ob eingegebene Passwörter gleich sind
	$scope.$watch("change.new_repeat", function(newValue, oldValue) {
		if($scope.change.password_equality != null && $scope.change.password_equality != undefined) {
			if($scope.change.new_password == $scope.change.new_repeat) {
				$timeout(function(){
					$scope.change.password_equality = true;
				}, 25);
			} else {
				$timeout(function(){
					$scope.change.password_equality = false;
				}, 25);
			}
		}
	});

	$scope.$watch("change.new_password", function(newValue, oldValue) {
		if($scope.change.password_equality != null && $scope.change.password_equality != undefined) {
			if($scope.change.new_password == $scope.change.new_repeat) {
				$timeout(function(){
					$scope.change.password_equality = true;
				}, 25);
			} else {
				$timeout(function(){
					$scope.change.password_equality = false;
				}, 25);
			}
		}
	});
});
