angular.module('chat_detail.controller', [])

.controller('ChatDetailCtrl', function($scope, $filter, $ionicScrollDelegate, $_popup, $timeout, $ionicActionSheet, $state, $_chat_detail_cache, $interval, $_sound,
    $_chat_detail, $stateParams, $_notification, $_sdk, $_options, $rootScope, $_helper, $ionicHistory, $_chat_list_cache, $ionicPlatform, $_helper, $_tracking, $_network, $ionicPlatform, $ionicConfig, $log) {
    var keyboardHeight = 0;
    var footerBar;
    var txtInput;
    var getMessagesInterval;
    var newHeight;

    $scope.$on("$ionicView.beforeEnter", function(event, viewData){
        $ionicConfig.scrolling.jsScrolling(true);
        $timeout(function(){
            viewData.enableBack = true;
            $scope.view = {}; // Speichert den Title und ob es Nachrichten zum Nachladen gibt (=> ob der Ion Refresh angezeigt wird)
            $scope.loggedInUserId = $_sdk.getUserID();
            $scope.today = $filter('date')(new Date(), 'dd-MM-yyyy');
            $scope.countdownStarted = false;

            var chatId = $stateParams.chatId;
            $_tracking.trackPage("Chat");

            $scope.chat = $_chat_detail_cache.getChat(chatId);
            var unsendMessages = $_chat_detail_cache.getUnsendMessages(chatId);

            if(unsendMessages != null && unsendMessages != undefined) {
                $scope.chat.messages = $scope.chat.messages.concat(unsendMessages);
            }

            $log.debug("1scrollBottom");
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();

            if($scope.chat != null && $scope.chat != undefined) {
                checkUnreadMessages();
                setTitle();
            }

            if($scope.chat == null || $scope.chat == undefined) {
                $_helper.showLoadingIndicator();
            }            

            getCachedTypedMessage();
            getChatMessages();

    		
        }, 25);

        window.addEventListener('native.keyboardshow', keyboardShowHandler);
        window.addEventListener('native.keyboardhide', keyboardHideHandler);

        $_helper.hideAccessoryBar(true);
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
        $_helper.hideAccessoryBar(false);
        //$timeout.cancel(getMessagesInterval);
        $scope.countdownStarted = false;

        // Zurücksetzen der Höhe aller Content-Bereiche
        $('ion-tabs').find('ion-content').css('bottom', 0 + 'px');
        resetContentHeight();
        cacheTypedMessage();
        $_helper.refreshBadges();
	});

    $ionicPlatform.on('resume', function(){
        /*if(!$scope.countdownStarted) {
            $timeout.cancel(getMessagesInterval);
            startGetChatMessagesInterval();
        }*/
        getCachedTypedMessage();
    });

    $ionicPlatform.on('pause', function() {
        //$timeout.cancel(getMessagesInterval);
        $scope.countdownStarted = false;
        cacheTypedMessage();
    });

    $scope.$on('refresh-chat-detail', function(event, args) { // Reagiert auf Push-Benachrichtigung in diesem Chat
        getChatMessages(true);
        $rootScope.chatRefreshIntervalTime = 60;
    });

    $scope.$on('refresh-chat-interval', function(event, args) { // Reagiert auf den Timer in diesem Chat
        $log.debug("refreshchatinterval");
        getChatMessages(true);
    });

    $scope.$on('$ionicView.loaded', function(e) {
        footerBar = document.body.querySelector('.chat-footer');
        txtInput = angular.element(footerBar.querySelector('textarea'));

        $timeout(function(){
            //resizeScreen();
        }, 1500);
    });

    function cacheTypedMessage() {
        var chatId = $stateParams.chatId;
        if($scope.messageinput != null && $scope.messageinput != undefined) {
            $_chat_detail_cache.putTypedMessage(chatId, $scope.messageinput);
        } else {
            $_chat_detail_cache.putTypedMessage(chatId, "");
        }
    }

    function getCachedTypedMessage() {
        var chatId = $stateParams.chatId;
        var input = $_chat_detail_cache.getCachedMessage(chatId);

        if(input != null && input != undefined && input.replace(/^\s+|\s+$/g, "").trim() != ""){
            $scope.messageinput = input;
        }
    }

    function setTitle() {
        $timeout(function(){
            $scope.view.title = $scope.chat.info.name + ', ' + $scope.chat.info.age;
            $scope.view.sub_title = parseInt($scope.chat.info.distance, 10) + ' km';
            $scope.view.is_verified = $scope.chat.info.is_verified;
        }, 25);
    }

    function getChatMessages(isPush) {
        isPush = (typeof isPush === 'undefined') ? false : isPush;

        $rootScope.lastChatRefreshTime = moment();
        $log.debug("getChatMessagesSTART");
        
        var chatId = $stateParams.chatId;
        $_chat_detail.getChat(chatId, isPush).then(
            function(chat) {
                $timeout(function(){

                    $log.debug("chat");
                    $log.debug(chat);

                    $log.debug("scope.chat");
                    $log.debug($scope.chat);

                    $_chat_detail_cache.saveChat(chatId, chat);

                    // Remove unsent messages
                    $_chat_detail.removeSentMessagesFromCache(chat.messages, chatId);

                    // Concat Msg
                    if($scope.chat != null && $scope.chat != undefined && $scope.chat.messages != null && $scope.chat.messages != undefined && $scope.chat.messages.length > 0) {
                        chatMessages = [];
                        for(msg in $scope.chat.messages) {
                            if($scope.chat.messages[msg].status == null || $scope.chat.messages[msg].status == undefined) chatMessages.push($scope.chat.messages[msg]);
                        }
                        var scopeChat = chat;
                        scopeChat.messages = chatMessages.concat(scopeChat.messages);
                    } else {
                        var scopeChat = chat;
                    }

                    $log.debug("scopeChat");
                    $log.debug(scopeChat);

                    // Concat Unsend
                    var unsendMessages = $_chat_detail_cache.getUnsendMessages(chatId);

                    if(unsendMessages != null && unsendMessages != undefined) {
                        scopeChat.messages = scopeChat.messages.concat(unsendMessages);
                    }

                    $log.debug("chatMessages");
                    $log.debug(scopeChat.messages);

                    scopeChat.messages = $_chat_detail.prepareMessageArray(scopeChat.messages);

                    $log.debug(scopeChat.messages);

                    $scope.chat = scopeChat;

                    setTitle();
                    
                    if(/*!isPush || */$_helper.isScrolledToBottom($ionicScrollDelegate.$getByHandle('chatDetailScroll'))) {
                        $log.debug("2scrollBottom");
                        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
                        $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
                    } else {
                        $log.debug("2resize");
                        //var currentTop = $ionicScrollDelegate.$getByHandle('chatDetailScroll').getScrollPosition().top;
                        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
                        //$ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollTo(0, currentTop);
                    }

                    $scope.view.isOnLastPage = $_chat_detail.isOnLastPage();
                    checkUnreadMessages();
                    $_helper.hideLoadingIndicator();

                    $rootScope.lastChatRefreshTime = moment();

                }, 10);
            },
            function(error) {
                $_helper.hideLoadingIndicator();
                $rootScope.lastChatRefreshTime = moment();

                if(error != null) {
                    if(error.code == 148 || error.code == 90 || error.code == 237) { // Chat existiert nicht, Empfaenger existiert nicht, User har dich geblockt
                        $ionicHistory.goBack();
                        $_chat_list_cache.deleteElementFromList(chatId);
                    } 
                    $timeout(function(){
                        $_notification.showNotificationBar(error.msg, error.type);
                    }, 250);
                    
                    
                } 
            }
        );

        /*if(!$scope.countdownStarted) {
            $timeout.cancel(getMessagesInterval);
            startGetChatMessagesInterval();
        }*/

    }

    /*function startGetChatMessagesInterval() { // Spricht alle x Sekunden den Server an und fragt nach neuen Nachrichten, wenn Push deaktiviert ist
        $scope.countdownStarted = true;
        getMessagesInterval = $timeout(function(){
            $log.debug("getMessagesInterval");
            var now = moment();
            $log.debug("seconds: "+now.diff(lastGetTime, 'seconds'));

            if(now.diff(lastGetTime, 'seconds') > refreshInterval) {
                getChatMessages(true);
            }
            
            startGetChatMessagesInterval();
        }, 3000);
    }*/

    /*function cancelChatMessagesIntervall(){
        if(getMessagesInterval != null && getMessagesInterval != undefined) {
            $interval.cancel();
        }
    }*/
    // Überprüft ob in diesem Chat ungelesene Nachrichten bestehen.
    // Ist dem so, wird so lange auf Nachrichten des anderen Users geprüft bis die Zahl der ungelesenen Nachrichten erreicht ist.
    function checkUnreadMessages() {
        var chatId = $stateParams.chatId;
        var unreadMessages = $_chat_detail_cache.getChatReadStatus(chatId);

        if(unreadMessages != 0 && unreadMessages != null && unreadMessages != undefined) {
            var other_messages_counter = 0;
            var other_user_id = $scope.chat.info.user_id;
            var my_user_id = $scope.chat.info.user_id;
            var messageObj = $scope.chat.messages;
            for(var i=0; i <= messageObj.length-1; i++) {
                var message_user_id = messageObj[i].usr_id;
                if(message_user_id == other_user_id) {
                    other_messages_counter++;
                }

                if(unreadMessages == other_messages_counter) {
                    $_chat_detail_cache.markChatAsRead(chatId);
                    break;
                }
            }
        }
    }

    $scope.loadMore = function() {
        if($_chat_detail.isOnLastPage()) {
            $scope.view.isOnLastPage = $_chat_detail.isOnLastPage();
            $scope.$broadcast('scroll.refreshComplete');
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
            return;
        }

        var chatId = $stateParams.chatId;
        $_chat_detail.loadMore(chatId).then(
            function(res) {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.view.isOnLastPage = $_chat_detail.isOnLastPage();

                if(angular.equals($scope.chat.messages, res.messages)) {
                    return;
                }

                $timeout(function(){
                    $scope.chat.messages = res.messages.concat($scope.chat.messages);
                    $scope.chat.messages = $_chat_detail.prepareMessageArray($scope.chat.messages);
                    //$_chat_detail_cache.saveChat(chatId, $scope.chat);

                    checkUnreadMessages();
                    $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
                }, 50);
            },
            function(error) {
                if(error != null) {
                    $_notification.showNotificationBar(error.msg, error.type);
                }
            }
        );
    }

    $scope.sendMessage = function(msgId) {
        keepKeyboardOpen();
        $_sound.playClick();

        if(cordova.platformId === 'android') {
            resetContentHeight();
        }

        if($scope.messageinput.trim() === '')
            return;

        var msg = $scope.messageinput;
        var chatId = $stateParams.chatId;
        if(typeof msgId === 'undefined') {
            msgId = $_helper.generateRandomString(30);
        }
        var msgObj = cacheUnsendMessage(msgId);

        var checkIfMessageSentTimer = $timeout(function() { // Prüft nach 2 Minuten ob die Nachricht verschickt wurde, wenn nicht wird sie als failed markiert
            $_chat_detail_cache.removeUnsendMessage(chatId, msgId);
            msgObj.status = "failed";
            $_chat_detail_cache.putUnsendMessage(msgObj, chatId);
        }, 30000); // 120000

        $_chat_detail.sendMessage(chatId, msg, msgId).then(
            function(success){
                $log.debug("success");
                $log.debug(success);
                $timeout.cancel(checkIfMessageSentTimer);
                $timeout(function(){
                    msgObj.status = "sent";
                    msgObj.date = new Date();
                    $log.debug("resize scrollBottom");
                    $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
                    $timeout(function() {                        
                        $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom(true);
                    }, 100);

                    $_chat_detail_cache.removeUnsendMessage(chatId, msgId);
                    getChatMessages(true);
                }, 50);
            },
            function(error){
                $log.debug("error");
                $log.debug(error);
                $timeout.cancel(checkIfMessageSentTimer);
                //$scope.messageinput = msg;
                $_notification.showNotificationBar(error.msg, error.type);

                $_chat_detail_cache.removeUnsendMessage(chatId, msgId);
                msgObj.status = "failed";
                $_chat_detail_cache.putUnsendMessage(msgObj, chatId);
                if(error.code == 148 || error.code == 90 || error.code == 237) {
                    $ionicHistory.goBack();
                    $_chat_list_cache.deleteElementFromList(chatId);
                }
            }
        );
        
    }

    function cacheUnsendMessage(msgId) { // Speichert eine Nachricht in den Cache, für den "unsend message" Status
        var chatId = $stateParams.chatId;
        var msg = $scope.messageinput.trim();

        var date = moment().format('YYYY-MM-DDTHH:mm:ss');
        var fulldate = $_helper.newDate(date);
        var short_date = moment(date).format('DD.MM.YY');
        var status = "pending";

        $log.debug(date);

        var networkState = navigator.connection.type;

        if(networkState == Connection.NONE) {
            status = "failed";
        }

        var msgObj = {
            id: msgId,
            message: msg,
            status: status,
            system_message: false,
            sorting_date: new Date(),
            short_date: short_date,
            usr_id: $_sdk.getUserID()
        }

        $_chat_detail_cache.putUnsendMessage(msgObj, chatId);

        var unsendMessages = $_chat_detail_cache.getUnsendMessages(chatId);

        var msgArr = [msgObj];

        $timeout(function(){
            $scope.chat.messages = $scope.chat.messages.concat(msgArr);
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
            $timeout(function() {              
                $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom(true);
            }, 100);
            
        }, 50);

        $scope.messageinput = "";
        return msgObj;
    }

    function deleteFailedMessage(index, message) {
        var chatId = $stateParams.chatId;
        var msgId = message.id;
        $scope.chat.messages.splice(index, 1);
        $_chat_detail_cache.removeUnsendMessage(chatId, msgId);
        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
        $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
    }

    function sendMessageAgain(index, message) {
        deleteFailedMessage(index, message);
        $log.debug("sendMessageAgain");
        $log.debug(message);
        $scope.messageinput = message.message;
        $scope.sendMessage(message.id);
    }

    $scope.sendAgainDialog = function(index, message) { // Dialog für Nachrichten, die gefailed sind
        hideSheet = $ionicActionSheet.show({
            buttons: [
                { text: $filter('translate')('SEND_AGAIN') },
                { text: $filter('translate')('DELETE_MESSAGE') }
            ],
            titleText: $filter('translate')('OPTIONS'),
            cancelText: $filter('translate')('CANCEL'),

            cancel: function() {
                $_sound.playClick();
            },
            buttonClicked: function(idx) {
                $_sound.playClick();
                hideSheet();
                if(idx==0) sendMessageAgain(index, message);
                else if (idx==1) deleteFailedMessage(index, message);
            }
        });
    }

    $scope.showProfile = function() {
        var currentTab = $rootScope.rootCurrentTab;
        var userId = $scope.chat.info.user_id;
        $state.go('tab.' + currentTab + '-profile', {id: userId})
    }

	$scope.showOptions = function() {
        $_sound.playClick();
        var userId = $scope.chat.info.user_id;
        var flirtId = $stateParams.chatId;

        getReasons();

        hideSheet = $ionicActionSheet.show({
            buttons: [
                { text: $filter('translate')('DELETE_CHAT') },
                { text: $filter('translate')('REPORT_USER') },
                { text: $filter('translate')('BLOCK_USER') }
            ],
            titleText: $filter('translate')('OPTIONS'),
            cancelText: $filter('translate')('CANCEL'),

            cancel: function() {
                $_sound.playClick();
            },
            buttonClicked: function(index) {
                hideSheet();
                if(index==0) $_popup.deleteChatPopup(flirtId, true);
                else if (index==1) $_popup.reportUserPopup(userId, $scope, false);
                else if (index==2) $_popup.blockUserPopup(userId, true);
            }
        });
	}

    function getReasons() {
        $_options.getReportReasons().then(
            function(list){
                $scope.reasons = list;
            },
            function(error){
                $_notification.showNotificationBar(error.msg, error.type);
            }
        );
    }

    // Keyboardhandler für iOS fixes
    function keyboardShowHandler(e){
        $log.debug("keyboardShowHandler");
        /*if(cordova.platformId === 'ios'){
            $timeout(function(){
                keyboardHeight = e.keyboardHeight;
                var newHeight = window.screen.height - e.keyboardHeight;
                $('.setHeight').css('height', newHeight+'px');
                $('.setHeight').css('transition', 'all 250ms');
                resizeScreen();
          }, 50);
        }

        if(cordova.platformId === 'android') {
            resetContentHeight();
        }

        $('.setMargin').css('margin-bottom',  '15px');*/

        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
        $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
    }

    function keyboardHideHandler(e){
        $log.debug("keyboardHideHandler");
        /*if(cordova.platformId === 'ios'){
            $timeout(function(){
                if(e.keyboardHeight == null || e.keyboardHeight == undefined) {
                    keyboardHeight = 0;
                    resizeScreen();
                } else {
                    keyboardHeight = e.keyboardHeight;
                }
            }, 50);
        }

        if(cordova.platformId === 'android') {
            resizeScreen();
        }*/

        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();

    }

    function keepKeyboardOpen() { // Verhindert das Schließen der Tastatur
        $log.debug("keepKeyboardOpen");
        txtInput.one('blur', function() {
            txtInput[0].focus();
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
        });
    }

    function resetContentHeight() {
        $log.debug("resetContentHeight");
        /*var height = $('.chat-footer').outerHeight();
        newHeight = height + keyboardHeight;
        $('#chatDetailContent').css('bottom', newHeight + 'px');*/
        $ionicScrollDelegate.$getByHandle('chatDetailScroll').resize();
    }

    function resizeScreen() { // Verändert Höhe des Screens je nach größe der Eingabe
        $log.debug("resizeScreen");
        if($state.current.name === 'tab.chats-chat-detail') { // Bugfix für die Höhe nach Verlassen des Chats
            resetContentHeight();            
            $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
        }
    }

    $scope.$watch("chat.messageinput", function(newValue, oldValue) {
        $log.debug("chat.messageinput");
        if(newValue == null || newValue == undefined) {
            $timeout(function(){
                var height = $('.chat-footer').outerHeight();
                if(height != 50) {
                    resizeScreen();
                } else {
                    $ionicScrollDelegate.$getByHandle('chatDetailScroll').scrollBottom();
                }
            }, 50);
        } else {
            resizeScreen();
        }
    }, true);


});
