angular.module('create_account.controller', [])

.controller('CreateAccountCtrl', function($scope, $_helper, $timeout, $translate, $_tracking, $_register, $_notification, $ionicHistory, $_account_cache, $filter, $_sound, $_nativestorage) {
	$scope.create = {
		mail: '',
		password: '',
		password_repeat: '',
		password_equality: false
	}

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Create Account Screen");
	});

	$scope.$on("$ionicView.enter", function(event, data){

		// Login-Via-Facebook Überlappung Bug - FIX (ANDROID)
		if($("body").hasClass("platform-android")) {

			var input = $("input");
			var toggle = $(".bottom-login-text, .bar-footer");
			var hasFooter = $(".has-footer");
			var hasFooterBottomVal = hasFooter.css("bottom");

			window.addEventListener('native.keyboardshow', function() {
				toggle.css("display", "none");
				hasFooter.css("bottom", "0");
			});
			window.addEventListener('native.keyboardhide', function() {
				toggle.css("display", "block");
				hasFooter.css("bottom", hasFooterBottomVal + "px");
			});

			/*
			input.on("focus", function() {
				toggle.css("display", "none");
				hasFooter.css("bottom", "0");
			});

			input.on("blur", function() {
				toggle.css("display", "block");
				hasFooter.css("bottom", hasFooterBottomVal + "px");
			});*/

		} 

	});

	$scope.registerMail = function() {
		$_sound.playClick();
		if($scope.create.password_equality != true) {
			var msg = $filter('translate')('PASSWORD_CONFIRM_NOT_EQUAL');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);
		} else {
			$_register.registerMail($scope.create.mail, $scope.create.password).then(function(success){
	        //Save email for Email-Login
	        $_nativestorage.setItem("lastEmail",$scope.create.mail);
        
				$timeout(function(){
					$_notification.showNotificationBar(success.msg, success.type, 5000);
				}, 500);
				$_account_cache.setShouldShowCreateAccountBox(false);
				$_account_cache.setUserHasRegistered(true);
				$ionicHistory.goBack();
			}, function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			});
		}
	}

	$scope.registerFacebook = function() {
		$_sound.playClick();
		$_register.registerFacebook().then(function(success){
			$_account_cache.setShouldShowCreateAccountBox(false);
			$_account_cache.setUserHasRegistered(true);
			$ionicHistory.goBack();

			$timeout(function(){
				$_notification.showNotificationBar(success.msg, success.type);
			}, 500);

		}, function(error){
			$_notification.showNotificationBar(error.msg, error.type);
		});
	}

	// Prüft ob eingegebene Passwörter gleich sind
	$scope.$watch("create.password_repeat", function(newValue, oldValue) {
		if($scope.create.password_equality != null && $scope.create.password_equality != undefined) {
			if($scope.create.password == $scope.create.password_repeat) {
				$timeout(function(){
					$scope.create.password_equality = true;
				}, 25);
			} else {
				$timeout(function(){
					$scope.create.password_equality = false;
				}, 25);
			}
		}
	});

	$scope.$watch("create.password", function(newValue, oldValue) {
		if($scope.create.password_equality != null && $scope.create.password_equality != undefined) {
			if($scope.create.password == $scope.create.password_repeat) {
				$timeout(function(){
					$scope.create.password_equality = true;
				}, 25);
			} else {
				$timeout(function(){
					$scope.create.password_equality = false;
				}, 25);
			}
		}
	});
});
