angular.module('delete_account.controller', [])

.controller('DeleteAccountCtrl', function($scope, $timeout, $_account, $_notification, $ionicHistory, $_tracking, $_account_cache,
	$_options, $filter, $_delete_account, $_cache_helper, $_social_account, $state, $ionicPopup, $_sound, $log) {
	$scope.formdata = {};

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Account löschen Screen");

		var accountData = $_account_cache.getAccountData();
		$timeout(function(){
			$scope.formdata.login_type = accountData.login_type;
		}, 25);
		
		getDeleteReasons();
	});

	$scope.deleteAccount = function() {
		$_sound.playClick();
		if($scope.formdata.login_type == 'device_id') {
			if($scope.formdata.selected_reason == null || $scope.formdata.selected_reason == undefined) { // Formularfelder prüfen
				var msg = $filter('translate')('CHOOSE_DELETE_REASON');
				var type = $_notification.getNotificationTypes().ERROR;
				$_notification.showNotificationBar(msg, type);
			} else {
				askIfReallyDeletePopup();
			}
		}

		if($scope.formdata.login_type == 'email') {
			if($scope.formdata.selected_reason == null || $scope.formdata.selected_reason == undefined) { // Formularfelder prüfen
				var msg = $filter('translate')('CHOOSE_DELETE_REASON');
				var type = $_notification.getNotificationTypes().ERROR;
				$_notification.showNotificationBar(msg, type);
			} else if($scope.formdata.password == null || $scope.formdata.password == undefined || $scope.formdata.password.length < 0) {
				var msg = $filter('translate')('TYPE_IN_PASSWORD_TO_PROCEED');
				var type = $_notification.getNotificationTypes().ERROR;
				$_notification.showNotificationBar(msg, type);
			} else {
				askIfReallyDeletePopup()
			}
		}

		if($scope.formdata.login_type == 'social') {
			if($scope.formdata.selected_reason == null || $scope.formdata.selected_reason == undefined) { // Formularfelder prüfen
				var msg = $filter('translate')('CHOOSE_DELETE_REASON');
				var type = $_notification.getNotificationTypes().ERROR;
				$_notification.showNotificationBar(msg, type);
			} else {
				askIfReallyDeletePopup();
			}
		}
	}

	function askIfReallyDeletePopup() {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('DELETE_ACCOUNT'),
			template: $filter('translate')('CONFIRM_ACCOUNT_DELETE_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				if($scope.formdata.login_type == 'device_id') {
					deleteDeviceIdAccount($scope.formdata.selected_reason.id);
				}

				if($scope.formdata.login_type == 'email') {
					deleteMailAccount($scope.formdata.selected_reason.id, $scope.formdata.password);
				}

				if($scope.formdata.login_type == 'social') {
					$_social_account.getFacebookData().then(
						function(success){
							deleteFacebookAccount($scope.formdata.selected_reason.id, 'facebook', success.data.id, success.config.params.access_token);
						}, function(error){

						}
					);
				}
			} else {
				$_sound.playClick();
			}
		});
	}

	var deleteDeviceIdAccount = function(reason_id) {
		$_delete_account.deleteDeviceIdAccount(reason_id).then(function(success){
			$_cache_helper.clear();
			$state.go('start-screen');
		}, function(error) {
			$_notification.showNotificationBar(error.msg, error.type);
		});
	}

	function deleteMailAccount(reason_id, password) {
		$_delete_account.deleteMailAccount(reason_id, password).then(function(success){
			$_cache_helper.clear();
			$state.go('start-screen');
		}, function(error) {
			$_notification.showNotificationBar(error.msg, error.type);
		});
	}

	function deleteFacebookAccount(reason_id, platform, platform_id, platform_token) {
		$_delete_account.deleteFacebookAccount(reason_id, platform, platform_id, platform_token).then(function(success){
			$_cache_helper.clear();
			$state.go('start-screen');
		}, function(error) {
			$_notification.showNotificationBar(error.msg, error.type);
		});
	}

	function getDeleteReasons() {
		$_options.getDeleteReasons().then(function(list){
			$timeout(function(){
				$scope.formdata.reasons = list;
			}, 25);
		}, function(error){
			$log.debug("error");
		})
	}

});
