angular.module('flirt_detail_answer.controller', [])

.controller('FlirtDetailAnswerCtrl', function($scope, $timeout, $_font_color_helper, $_flirt_answer, $_flirt_detail, $_flirt_detail_cache, $_sound,
	$ionicHistory, $_notification, $stateParams, $filter, $_helper, $_tracking, $_flirt_answer_cache, $ionicPlatform, $_users_cache, $_popup) {
	var taHeightOld;
	var taHeightFocus;
	var scrollHeight;
	var typingTimeout;

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Answer Flirt");

		$scope.data = {};
		$scope.data.is_typing = true;
		$scope.flirt = {};
		$scope.color = {};
		$scope.textarea = {};
		$scope.color.counter_color = $_font_color_helper.getCounterColor(0);
		$scope.color.font_color = $_font_color_helper.getCounterFontBaseColor();
		$scope.textarea.font_size = $_font_color_helper.getFontSize(0);
		$scope.textarea.inputLength = 0;
		$scope.textarea.breaks = 0; // Speichert die Zahl der Umbrüche
		$scope.textarea.linesPerBreak = 20;

		taHeightOld = $('.textarea-answer').height();
		scrollHeight = $('.scroll').height();

		getCachedData();
		getQuestion();
		$_helper.hideAccessoryBar(true);

		window.addEventListener('native.keyboardshow', keyboardShowHandler);
		window.addEventListener('native.keyboardhide', keyboardHideHandler);
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$_helper.hideAccessoryBar(false);
		cacheAnswer();
	});

	$ionicPlatform.on('resume', function(){
		getCachedAnswer();
	});

	$ionicPlatform.on('pause', function(){
		cacheAnswer();
	});

	$scope.$on('refresh-flirt-detail-answer', function(event, args) { // Reagiert auf Push-Benachrichtigung in diesem Flirt
        $scope.flirt.flirt_answer_text = "";
		getQuestion();
		$_popup.alert($filter('translate')('QUESTION_WAS_CHANGED'), $filter('translate')('CHANGE_QUESTION_SUCCESS'));
    });

	function cacheAnswer() {
		var answer = $scope.flirt.flirt_answer_text;
		if(answer != null && answer != undefined) {
			if(answer.length >= 0 && answer.replace(/^\s+|\s+$/g, "").trim() != "") {
				$_flirt_answer_cache.saveFlirtAnswer($stateParams.flirtId, $stateParams.roundId, answer);
			}
		}
	}

	function getCachedAnswer() {
		var answer = $_flirt_answer_cache.getFlirtAnswer($stateParams.flirtId, $stateParams.roundId);

		if(answer != null && answer != undefined) {
			if(answer.length >= 0 && answer.replace(/^\s+|\s+$/g, "").trim() != "") {
				$timeout(function(){
					$scope.flirt.flirt_answer_text = answer;

					$scope.textarea.inputLength = answer.length;
					$scope.monitorLength(150);
				}, 50);
			}
		}
	}

	// Window Listener für das Verschieben von Popups und anderen Elementen
	  function keyboardHideHandler(e){
	  	$('.flirt-answer-form').css("height", taHeightOld + 'px');
	  }
		
	  function keyboardShowHandler(e){
	    var keyboardHeight = e.keyboardHeight;
	    var flirt_answer_form = $('.flirt-answer-form').outerHeight();
	    var newHeightAnswerForm = taHeightOld - keyboardHeight;

	    $('.flirt-answer-form').css("height", newHeightAnswerForm + 'px');
	  }

	function getCachedData() {
		$timeout(function() {
			$scope.flirt = $_flirt_detail_cache.getFlirtRound($stateParams.flirtId, $stateParams.roundId);
			var flirtDetail = $_flirt_detail_cache.getFlirtDetail($stateParams.flirtId);
			$scope.flirt.profile_img = flirtDetail.other_user.profile_image;
			$scope.title = {};
			$scope.title.view_title = flirtDetail.other_user.name + ', ' + flirtDetail.other_user.age;
			$scope.title.sub_title = parseInt(flirtDetail.other_user.distance, 10) + ' km';
			$scope.title.is_verified = flirtDetail.other_user.is_verified;

			getCachedAnswer();

			$timeout(function() {
				var scroll_content = $("ion-content.flirt-answer").outerHeight();
			    var question = $('.text-center.question').outerHeight();
			    var flirt_answer_form = $('.flirt-answer-form').outerHeight();

			    var newHeightAnswerForm = scroll_content - question;
			    taHeightOld = newHeightAnswerForm;

			    $('.flirt-answer-form').css("height", newHeightAnswerForm + 'px');
			}, 100);
		}, 50);
	}

	function getQuestion() {
		var flirtId = $stateParams.flirtId;
		var roundId = $stateParams.roundId;

		$_flirt_detail.getRoundDetail(flirtId, roundId).then(
			function(flirt){
				if(flirt.my_round_status != 'answer') {
					rejectAnswer();
				} else {
					$scope.flirt = flirt;
					$scope.flirt.flirtId = flirtId;
					$scope.flirt.roundId = roundId;
					$scope.questionId = flirt.question_id;
					$scope.view_title = flirt.name + ', ' + flirt.age;
				}

			},
			function(error){
				$ionicHistory.goBack();
				$timeout(function(){
					$_notification.showNotificationBar(error.msg, error.type);
				}, 250);
			}
		);
	}

	function rejectAnswer() {
		$ionicHistory.goBack();
		$timeout(function(){
			var msg = $filter('translate')('YOU_CANNOT_ANSWER_THIS_QUESTION_ANYMORE');
			var type = $_notification.getNotificationTypes().ERROR;
			$_notification.showNotificationBar(msg, type);
		}, 250);
	}

	$scope.showProfileImage = function() {
		$_sound.playClick();
	}

	$scope.sendAnswer = function() {
		$_sound.playClick();
		$_helper.showSendIndicator();
		$scope.flirt.roundId = $stateParams.roundId;
		$_flirt_answer.sendAnswer($scope.flirt.roundId, $scope.flirt.flirt_answer_text, $scope.questionId).then(
			function(success){
				$_helper.hideSendIndicator();
				$_tracking.trackEvent("Flirt", "Answer", "", $stateParams.roundId);
				$ionicHistory.goBack();
				$_flirt_detail_cache.saveStartedFlirtRound($scope.flirt.user_id);
				$_users_cache.deleteUser($scope.flirt.user_id);
			},
			function(error){
				$_helper.hideSendIndicator();
				if(error.code == 141 || error.code == 142 || error.code == 232 || error.code == 160 || error.code == 161) { // Flirt abgelaufen oder existiert nicht, doppelte Antwort: 232, 160
					$ionicHistory.goBack();
				}
				if(error.code == 141 || error.code == 142 || error.code == null || error.code == undefined) { // hat bereits geantwortet, da also keine notification anzeigen
					$timeout(function(){
						$_notification.showNotificationBar(error.msg, error.type);
					}, 500);
				}

				if(error.code == 272) { // hat bereits geantwortet
					$timeout(function(){
						$_notification.showNotificationBar(error.msg, error.type);
						$ionicHistory.goBack();
					}, 500);
				}

				if(error.code == 279) { // Frage geändert
					$timeout(function(){
						//$_notification.showNotificationBar(error.msg, error.type);
						$_popup.alert(msg, $filter('translate')('CHANGE_QUESTION_SUCCESS'));
						getQuestion();
					}, 200);
				}
			}
		);
	}

	// Checkt ob die maximale Eingabelänge erreicht ist
	$scope.monitorLength = function(maxLength) {
		isTypingChecker();

	  if($scope.flirt.flirt_answer_text != null && $scope.flirt.flirt_answer_text != undefined) {
	  		if($scope.flirt.flirt_answer_text.replace(/^\s+|\s+$/g, "").trim() != "") {
			  	// Prüft die Anzahl der Umbrüche im Text
			  	$scope.textarea.breaks = $scope.flirt.flirt_answer_text.split("\n").length-1;
			  	var subtractLines = $scope.textarea.linesPerBreak * $scope.textarea.breaks - $scope.textarea.breaks; // Minus Anzahl der Umbrüche selbst, um ng-trim beizubehalten

			  	$timeout(function(){
			  		var length = $scope.flirt.flirt_answer_text.length + subtractLines;

			  		if(length > maxLength) {
			    		var slice = true;
			    		var str = $scope.flirt.flirt_answer_text;
			    		var i = 0;

			    		while(slice) { // Schneidet so oft den letzten Character des Inputs ab, bis die maximale Anzahl wieder erreicht ist, Berücksichtig dabei die LinesPerBreak
			    			str = str.slice(0, -1);
			    			var breaks = str.split("\n").length-1;
			    			i = i+1;

			    			subtractLines = $scope.textarea.linesPerBreak * breaks - breaks;
			    			length = str.length + subtractLines;

			    			if(length <= maxLength) {
			    				slice = false;
			    				$scope.flirt.flirt_answer_text = str;
			    			}
			    		}

			    		$scope.textarea.inputLength = $scope.flirt.flirt_answer_text.length + subtractLines;
			 		} else {
			 			$scope.textarea.inputLength = $scope.flirt.flirt_answer_text.length + subtractLines;
			 		}
			  	}, 25);
			}
	  	}
	}

	// Prüft ob der Nutzer noch tippt
	function isTypingChecker() {
		if(typingTimeout != null && typingTimeout != undefined) {
			$timeout.cancel(typingTimeout);
		}

		$scope.data.is_typing = true;

		typingTimeout = $timeout(function(){
			stoppedTyping();
		}, 400);
	}

	// Zeigt den Senden Button an, wenn Nutzer nicht mehr tippt
	function stoppedTyping() {
		$timeout(function(){
			if($scope.textarea.inputLength > 0 && $scope.flirt.flirt_answer_text != undefined) {
				if($scope.flirt.flirt_answer_text.replace(/^\s+|\s+$/g, "").trim() != "") {
					$scope.data.is_typing = false;
				}
			}
		}, 25);
	}

	$scope.$watch('flirt.flirt_answer_text', function(newValue, oldValue) {
		if(newValue == null || newValue == undefined || newValue.replace(/^\s+|\s+$/g, "").trim() == "") {
			$scope.textarea.inputLength = 0;
		}

		if($scope.flirt != null && $scope.flirt != undefined) {
			if($scope.flirt.flirt_answer_text == null || $scope.flirt.flirt_answer_text == undefined || $scope.flirt.flirt_answer_text.replace(/^\s+|\s+$/g, "").trim() == "") {
					$timeout(function () {
						$scope.color.counter_color = $_font_color_helper.getCounterColor(0);
						$scope.textarea.font_size = $_font_color_helper.getFontSize(0);
						$scope.color.font_color = $_font_color_helper.getCounterFontBaseColor();
					}, 25);
			}

			if($scope.flirt.flirt_answer_text != null && $scope.flirt.flirt_answer_text != undefined) {
				if($scope.flirt.flirt_answer_text.replace(/^\s+|\s+$/g, "").trim() != "") {
					var length = $scope.textarea.inputLength;
					var actualColor = $_font_color_helper.getActualColor(length);

					if(actualColor > 35) {
						$scope.color.font_color = $_font_color_helper.getCounterFontContrastColor();
					} else {
						$scope.color.font_color = $_font_color_helper.getCounterFontBaseColor();
					}

					$timeout(function () {
		            	$scope.color.counter_color = $_font_color_helper.getCounterColor(length);
		        	}, 25);

		        	$timeout(function () {
		            	$scope.textarea.font_size = $_font_color_helper.getFontSize(length);
		        	}, 25);
	        	}
			}
		}
    });

});
