angular.module('flirt_detail.controller', [])

.controller('FlirtDetailCtrl', function($scope, $translate, $_popup, $ionicPopup, $filter, $state, $ionicScrollDelegate, $ionicHistory, $_notification,
	$ionicActionSheet, $timeout, $stateParams, $_font_color_helper, $_flirt_detail, $_flirt_detail_cache, $_options, $rootScope, $_sound, $_flirt_answer_cache,
	$_flirts, $_flirt_list_cache, $ionicHistory, $_helper, $ionicPlatform, $_tracking, $_popup, $_points) {

	var refreshing = false;
	var loadingView = true;
	$scope.information = {};

	$scope.$on('$ionicView.beforeEnter', function(){
		loadingView = true;
		var flirtId = $stateParams.flirtId;
		if(flirtId == null || flirtId == undefined || flirtId == "") {
			$ionicHistory.goBack();
		} else {
			$_tracking.trackPage("Flirt");

			$scope.flirt_detail = $_flirt_detail_cache.getFlirtDetail(flirtId);

			if($scope.flirt_detail != null && $scope.flirt_detail != undefined) {
				settings();
			}

			if($scope.flirt_detail == null || $scope.flirt_detail == undefined) {
				$_helper.showLoadingIndicator();
			}

			if($state.current.name == "tab." + $rootScope.rootCurrentTab + "-flirt-detail") {
				getFlirtDetail(flirtId);
			}
		}
	});

	$scope.$on("$ionicView.enter", function() {
		loadingView = false;
	});

	$scope.$on('$ionicView.beforeLeave', function(){
		resetScreen();
	});

	$scope.$on('refresh-flirt-detail', function(event, args) { // Reagiert auf Push-Benachrichtigung in diesem Flirt
        var flirtId = $stateParams.flirtId;
		getFlirtDetail(flirtId);
    });

	$scope.refresh = function() {
		$_sound.playRefresh();
		refreshing = true;
		loadingView = true;
		var flirtId = $stateParams.flirtId;
		getFlirtDetail(flirtId);
	}

	function getFlirtDetail(flirtId) {
		var answer;

		if($scope.flirt_detail != undefined) {
			answer = $_flirt_answer_cache.getFlirtAnswer($stateParams.flirtId, $scope.flirt_detail.rounds[$scope.flirt_detail.next_round-1].round_id);
		}
		
		if(answer != null && answer != undefined && answer.length > 0) {
			$timeout(function(){
				$scope.information.answer_cached = true;
			}, 50);
		} else {
			$timeout(function(){
				$scope.information.answer_cached = false;
			}, 50);
		}

		

		$_flirt_detail.getFlirtDetail(flirtId).then(
			function(flirt){
				$timeout(function(){
					$scope.flirt_detail = flirt;
					settings();
					checkAndShowPopup();
					saveFlirtDetailToCache(flirtId);

					if(refreshing) {
						refreshing = false;
						loadingView = false;
						$_sound.playRefreshFinish();
					}

					$scope.$broadcast('scroll.refreshComplete');
					$_helper.refreshBadges();
					$_helper.hideLoadingIndicator();
				}, 50);
			},
			function(error){
				if(error.code == 46) {
					$ionicHistory.goBack();
				}

				if(refreshing) {
					refreshing = false;
					loadingView = false;
					$_sound.playRefreshFinish();
				}

				$_notification.showNotificationBar(error.msg, error.type);
				$scope.$broadcast('scroll.refreshComplete');
				$_helper.hideLoadingIndicator();
			}
		);
	}

	function saveFlirtDetailToCache(flirtId) {
		var round = $scope.flirt_detail.rounds.length;
		var flirt_state = $scope.flirt_detail.rounds[round-1].state;
		var flirt_round_valid_until = $scope.flirt_detail.rounds[round-1].flirt_round_valid_until;
		var is_expired = $scope.flirt_detail.rounds[round-1].flirt_round_expired;

		$_flirt_list_cache.updateFlirtRoundStatus(flirtId, flirt_state, round, flirt_round_valid_until, is_expired);
	}

	/* Einstellungen für die Anzeige */
	function settings() {
		if($scope.flirt_detail != null && $scope.flirt_detail != undefined){
			$scope.showRound($scope.flirt_detail.next_round);
		}

		$scope.show = {
			my_answer: true,
			flirt_answer: false
		}

		$scope.reportReason = {};
		$timeout(function(){
			$scope.view_title = $scope.flirt_detail.other_user.name + ", " + $scope.flirt_detail.other_user.age;
			$scope.sub_title = parseInt($scope.flirt_detail.other_user.distance, 10) + ' km';

			if($scope.flirt_detail.rounds[0] != null && $scope.flirt_detail.rounds[0] != undefined) {
				$scope.flirt_detail.rounds[0].question_font_size = $_font_color_helper.getQuestionFontSize($scope.flirt_detail.rounds[0].question.length);
				$('.game-question1').attr('style', 'font-size:' + $scope.flirt_detail.rounds[0].question_font_size + ' !important');
			}

			if($scope.flirt_detail.rounds[1] != null && $scope.flirt_detail.rounds[1] != undefined) {
				$scope.flirt_detail.rounds[1].question_font_size = $_font_color_helper.getQuestionFontSize($scope.flirt_detail.rounds[1].question.length);
				$('.game-question2').attr('style', 'font-size:' + $scope.flirt_detail.rounds[1].question_font_size + ' !important');
			}

			if($scope.flirt_detail.rounds[2] != null && $scope.flirt_detail.rounds[2] != undefined) {
				$scope.flirt_detail.rounds[2].question_font_size = $_font_color_helper.getQuestionFontSize($scope.flirt_detail.rounds[2].question.length);
				$('.game-question3').attr('style', 'font-size:' + $scope.flirt_detail.rounds[2].question_font_size + ' !important');
			}
		}, 50);

		var currentLocale = $translate.proposedLanguage();

		if(currentLocale == 'de') {
			$scope.action_img_url = "img/action_img/geantwortet.png";
		} else {
			$scope.action_img_url = "img/action_img/answered.png";
		}
	}

	// Überprüft ob das Next Round Popup bereits gesehen wurde oder nicht. Falls nicht, wird es angezeigt
	function checkAndShowPopup() {
		var next_round = $scope.flirt_detail.next_round;

		if(next_round > 1) {
			var isLastRound = false;
			var roundObj = $scope.flirt_detail.rounds[next_round-2];

			if($scope.flirt_detail.rounds.length == 3) {
				roundObj = $scope.flirt_detail.rounds[1];
			}

			// Prüfung ob jetzt die letzte Runde gespielt wird.
			if($scope.flirt_detail.rounds.length == 3 && $scope.flirt_detail.rounds[2].state != 'answer') {
				isLastRound = true;
				roundObj = $scope.flirt_detail.rounds[2];
			}

			// Prüfung ob Popup gesehen
			var flirtId = $scope.flirt_detail.flirtId;
			var lastRoundId = roundObj.round_id;
			var completed_round_seen = roundObj.my_seen_time;

			// Popup anzeigen
			if(roundObj.state == 'complete' && (completed_round_seen == null || completed_round_seen == undefined)) {
				if(isLastRound) {
					$_tracking.trackEvent("Flirt", "Round Complete", "Round 3", lastRoundId);
					$_tracking.trackEvent("Flirt", "Match", "", $scope.flirt_detail.match_id);

					$scope.showNextRoundPopup(next_round); // Spiel erfolgreich abgeschlossen
					$_flirt_list_cache.deleteElementFromList(flirtId);
				} else {
					$_tracking.trackEvent("Flirt", "Round Complete", "Round " + (next_round-1), lastRoundId);
					$scope.showNextRoundPopup(next_round-1);
				}
			}

			// Verlorenes Spiel
			if(roundObj.state == 'deleted' || roundObj.state == 'gameover' && (completed_round_seen == null || completed_round_seen == undefined)) {
				$_sound.playZonk();
			}
		}
	}

	$scope.showNextRoundPopup = function(round){
		if($state.current.name == "tab." + $rootScope.rootCurrentTab + "-flirt-detail") {
			var prev_img = round;

			if(round == 3) {
				prev_img = 2;
			}

			$timeout(function(){
				$scope.flirt = {};
				$scope.flirt.name = $scope.flirt_detail.other_user.name;
				$scope.flirt.age = $scope.flirt_detail.other_user.age;
				$scope.flirt.hashtags = '#'+$scope.flirt_detail.other_user.hashtag1 + ' #' + $scope.flirt_detail.other_user.hashtag2 + ' #' + $scope.flirt_detail.other_user.hashtag3;
				$scope.flirt.gender = $scope.flirt_detail.other_user.gender;
				$scope.flirt.img = $scope.flirt_detail.other_user.profile_image;
				$scope.flirt.round = round;
				$scope.flirt.prev_round_img = $scope.flirt_detail.round_img[prev_img]; // später an die Runde anpassen
				$scope.flirt.match_id = $scope.flirt_detail.match_id;
				$scope.flirt.round = round;

				$_popup.showNextRoundPopup($scope, round);
			}, 150);

			if(round == 3) {
				$timeout(function(){
					conf_construct(3000);
					conf_RestartConfetti();
				}, 150);
			}
		}
	}

	$scope.closeNextRoundPopUp = function() {
		$_popup.closeNextRoundPopUp();
	}

	/*
	* Zeigt die Details der angeklickten Runde im Flirt-Detail Bereich an.
	* Dabei werden die sichtbaren/nicht sichtabren Infos in den Runden entsprechend angepasst.
	*/
	$scope.showRound = function(round) {
		var cachedData = $_flirt_detail_cache.getFlirtDetail($stateParams.flirtId);

		switch(round) {
			case 1:
				if($scope.flirt_detail.next_round > 0) {
					if(!loadingView) $_sound.playClick();
					$scope.flirt_detail.show_round = 1;
					$scope.flirt_detail.selected_round_state = $scope.flirt_detail.rounds[0].state;
					$scope.flirt_detail.other_user.hashtag1 = "???";
					$scope.flirt_detail.other_user.hashtag2 = "???";
					$scope.flirt_detail.other_user.hashtag3 = "???";
					$scope.flirt_detail.other_user.name = "???";

					$ionicScrollDelegate.resize();
					resizeScreen();
				}
			break;

			case 2:
				if($scope.flirt_detail.next_round > 1) {
					if(!loadingView) $_sound.playClick();
					$scope.flirt_detail.show_round = 2;
					$scope.flirt_detail.selected_round_state = $scope.flirt_detail.rounds[1].state;
					$scope.flirt_detail.other_user.name = cachedData.other_user.name;
					$scope.flirt_detail.other_user.hashtag1 = "???";
					$scope.flirt_detail.other_user.hashtag2 = "???";
					$scope.flirt_detail.other_user.hashtag3 = "???";

					$ionicScrollDelegate.resize();
					resizeScreen();
				}
			break;

			case 3:
				if($scope.flirt_detail.next_round > 2) {
					if(!loadingView) $_sound.playClick();
					$scope.flirt_detail.show_round = 3;
					$scope.flirt_detail.selected_round_state = $scope.flirt_detail.rounds[2].state;
					$scope.flirt_detail.other_user.hashtag1 = cachedData.other_user.hashtag1;
					$scope.flirt_detail.other_user.hashtag2 = cachedData.other_user.hashtag2;
					$scope.flirt_detail.other_user.hashtag3 = cachedData.other_user.hashtag3;

					$ionicScrollDelegate.resize();
					resizeScreen();
				}
			break;
		}

		$timeout(function(){
			$scope.flirt_detail.other_user.profile_image = $scope.flirt_detail.round_img[round];
		}, 50);
	}

	$scope.showFlirtAnswer = function() {
		if(!loadingView) $_sound.playClick();
		$timeout(function(){
			$scope.show.my_answer = false;
			$scope.show.flirt_answer = true;
			resizeScreen();
		}, 10);
	}

	$scope.showMyAnswer = function() {
		if(!loadingView) $_sound.playClick();
		$timeout(function(){
			$scope.show.my_answer = true;
			$scope.show.flirt_answer = false;
			resizeScreen();
		}, 10);
	}

	function resizeScreen() {
		$timeout(function(){
			var answersHeight = $('.answers').height();

			if(answersHeight == null || answersHeight == undefined) {
				answersHeight = 0;
			}

			$('ion-content').css("margin-bottom", answersHeight + 'px');
			$ionicScrollDelegate.resize();
		}, 100);
	}

	function resetScreen() {
		$('ion-content').css('margin-bottom', 0 + 'px');
	}

	$scope.answerQuestion = function() {
		var currentTab = $rootScope.rootCurrentTab;
		var actRoundId = $scope.flirt_detail.rounds[$scope.flirt_detail.next_round-1].round_id;
		$state.go('tab.' + currentTab + '-flirt-detail-answer', { flirtId: $scope.flirt_detail.flirtId, roundId: actRoundId});
	}

	$scope.rateAnswer = function() {
		var currentTab = $rootScope.rootCurrentTab;
		var rateRoundId = $scope.flirt_detail.rounds[$scope.flirt_detail.show_round-1].round_id;
		$state.go('tab.' + currentTab + '-flirt-detail-rate', { flirtId: $scope.flirt_detail.flirtId, roundId: rateRoundId});
	}

	$scope.showOptionSheet = function() {
		if(!loadingView) $_sound.playClick();
		var flirtId = $scope.flirt_detail.flirtId;
		var userId = $scope.flirt_detail.other_user.user_id;

		$_flirts.showOptions(userId, flirtId, $scope, true);
	}

	$scope.showProfile = function() {
		$_sound.playClick();
	}

	$scope.changeQuestion = function() {
		$_points.getValueForType(13).then(
			function(data){
				console.log(data);
				var points = Math.abs(parseInt(data[0].point_types_value, 10));
				var mypoints = Math.abs(parseInt(data[0].my_current_points, 10));
				if(points>0) {
					if(mypoints<points) {
						$_popup.alert($filter('translate')('NOT_ENOUGH_POINTS_TEXT').replace("{points}", points) + $filter('translate')('YOUR_POINTS').replace("{mypoints}", mypoints), $filter('translate')('NOT_ENOUGH_POINTS'));
					} else {
						var confirmPopup = $ionicPopup.confirm({
					        title: $filter('translate')('CHANGE_QUESTION_TITLE'),
					        template: $filter('translate')('CHANGE_QUESTION_TEXT').replace("{points}", points) + $filter('translate')('YOUR_POINTS').replace("{mypoints}", mypoints),
					        cssClass: 'confirm-popup',
					        cancelText: $filter('translate')('CANCEL'),
					        okText: $filter('translate')('YES')
					      })
					      .then(function(res) {
					        if(res) {
					          $_points.changeQuestion($scope.flirt_detail.rounds[$scope.flirt_detail.show_round-1].round_id).then(function(data) {
					            var type = $_notification.getNotificationTypes().POSITIVE;
					            var msg = $filter('translate')('CHANGE_QUESTION_SUCCESS');

					            $_notification.showNotificationBar(msg, type);

					            getFlirtDetail($stateParams.flirtId);
					          },
					          function(error){
					          	if(error.code == 278) {
									var type = $_notification.getNotificationTypes().ERROR;
					            	var msg = $filter('translate')('NOT_ENOUGH_POINTS');
					            	$_notification.showNotificationBar(msg, type);
								} else if(error.code == 276) {
									var type = $_notification.getNotificationTypes().ERROR;
					            	var msg = $filter('translate')('QUESTION_ALREADY_ANSWERED');
					            	getFlirtDetail($stateParams.flirtId);
					            	$_popup.alert(msg, $filter('translate')('CHANGE_QUESTION_FAIL'));
								} else {
									var type = $_notification.getNotificationTypes().ERROR;
					            	var msg = $filter('translate')('CHANGE_QUESTION_FAIL');
					            	$_notification.showNotificationBar(msg, type);
								}

					            
					          });
					        }
					        
					      });
					}
					
					
				}
				
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			}
		)
	}

	$scope.reactivateFlirt = function(item, index) {
		console.log(item);
		console.log("reactivateFlirt");
		var flirtId = $stateParams.flirtId;
		$_points.getValueForType(14).then(
			function(data){
				console.log(data);
				var points = Math.abs(parseInt(data[0].point_types_value, 10));
				var mypoints = Math.abs(parseInt(data[0].my_current_points, 10));
				if(points>0) {
					if(mypoints<points) {
						$_popup.alert($filter('translate')('NOT_ENOUGH_POINTS_TEXT').replace("{points}", points) + $filter('translate')('YOUR_POINTS').replace("{mypoints}", mypoints), $filter('translate')('NOT_ENOUGH_POINTS'));
					} else {
						var confirmPopup = $ionicPopup.confirm({
					        title: $filter('translate')('REACTIVATE_FLIRT_TITLE'),
					        template: $filter('translate')('REACTIVATE_FLIRT_TEXT').replace("{points}", points) + $filter('translate')('YOUR_POINTS').replace("{mypoints}", mypoints),
					        cssClass: 'confirm-popup',
					        cancelText: $filter('translate')('CANCEL'),
					        okText: $filter('translate')('YES')
					      })
					      .then(function(res) {
					        if(res) {
					          $_points.reactivateFlirt(flirtId).then(function(data) {
					            var type = $_notification.getNotificationTypes().POSITIVE;
					            var msg = $filter('translate')('REACTIVATE_FLIRT_SUCCESS');

					            $_notification.showNotificationBar(msg, type);

					            getFlirtDetail($stateParams.flirtId);
					          },
					          function(error){
					          	if(error.code == 278) {
									var type = $_notification.getNotificationTypes().ERROR;
					            	var msg = $filter('translate')('NOT_ENOUGH_POINTS');
								} else {
									var type = $_notification.getNotificationTypes().ERROR;
					            	var msg = $filter('translate')('REACTIVATE_FLIRT_FAIL');
								}

					            $_notification.showNotificationBar(msg, type);
					          });
					        }
					        
					      });
					}
				}
				
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			}
		);
	}
})
