angular.module('flirt_detail_my_answer.controller', [])

.controller('FlirtDetailMyAnswerCtrl', function($scope, $timeout, $_flirt_answer, $_flirt_detail, $_flirt_detail_cache, $_notification,
	$stateParams, $_helper, $_tracking, $_flirt_answer_cache, $ionicPlatform, $ionicHistory, $_font_color_helper, $_sound, $log) {

	$scope.flirt = {};
	$scope.data = {};

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$_tracking.trackPage("Show My Answer");

		getCachedData();
		getCachedAnswer();
		getQuestion();
	});

	function getCachedAnswer() {
		var answer = $_flirt_answer_cache.getFlirtAnswer($stateParams.flirtId, $stateParams.roundId);

		if(answer != null && answer != undefined && answer.length >= 0) {
			$timeout(function(){
				var length = answer.length;
				$scope.data.my_answer = answer;
				$scope.data.font_size = $_font_color_helper.getFontSize(length);
			}, 50);
		}
	}

	function getCachedData() {
		$timeout(function() {
			$scope.flirt = $_flirt_detail_cache.getFlirtRound($stateParams.flirtId, $stateParams.roundId);
			var flirtDetail = $_flirt_detail_cache.getFlirtDetail($stateParams.flirtId);
			$scope.flirt.profile_img = flirtDetail.other_user.profile_image;
			$scope.title = {};
			$scope.title.view_title = flirtDetail.other_user.name + ', ' + flirtDetail.other_user.age;
			$scope.title.sub_title = parseInt(flirtDetail.other_user.distance, 10) + ' km';
			$scope.title.is_verified = flirtDetail.other_user.is_verified;
		}, 50);
	}

	function getQuestion() {
		var flirtId = $stateParams.flirtId;
		var roundId = $stateParams.roundId;

		var get = $_flirt_detail.getRoundDetail(flirtId, roundId, true);

		get.then(
			function(flirt){
				$scope.flirt = flirt;
				$scope.flirt.flirtId = flirtId;
				$scope.flirt.roundId = roundId;
				$scope.view_title = flirt.name + ', ' + flirt.age;
			},
			function(error){
				$log.debug(error.msg + ' ' + error.type);
				$ionicHistory.goBack();
				$timeout(function(){
					$_notification.showNotificationBar(error.msg, error.type);
				}, 250);
			}
		);
	}

	$scope.showProfile = function() {
		$log.debug("show profile");
		$_sound.playClick();
	}
});
