angular.module('introduction_swiper.controller', [])

.controller('IntroductionSwiperCtrl', function($scope, $timeout, $ionicPlatform, $filter, $compile, $state, $_tracking) {
    var slideNo = 1;

    var fourthSlide_1;
    var fourthSlide_1_1;
    var fourthSlide_2;
    var fourthSlide_2_1;
    var fourthSlide_2_2;
    var fourthSlide_3;
    var fourthSlide_3_1;
    var fourthSlide_3_2;
    var fourthSlide_3_3;

    var fifthSlide_1;
    var fifthSlide_2;
    var fifthSlide_3;

    $scope.showChatBubble = {
        first: false,
        second: false,
        heart: false
    }

    $scope.$on("$ionicView.beforeEnter", function(event, data){
        $_tracking.trackPage("Introduction Slider");
    });

    $ionicPlatform.ready(function(){
        $scope.profile_info = {
            name: "???",
            hashtag1: "???",
            hashtag2: "???",
            hashtag3: "???",
            last_round: false
        }

        $scope.blurredImage = 'img/introduction-slider/men-3.jpg';

    	var introSwiper = new Swiper ('.swiper-container', {
    		pagination: '.swiper-pagination',
	        slidesPerView: 1,
	        centeredSlides: true,
	        paginationClickable: true,
	        spaceBetween: 0,
    	});

        initSwiperHandler(introSwiper);
        initSkipButton();

        if(slideNo == 1) {
            firstSlideAnimation();
        }

    });

    $ionicPlatform.on('resume', function(){
        startSlideAnimation(slideNo);
    });

    $ionicPlatform.on('pause', function() {
        resetSlide(slideNo);
    });

    function initSwiperHandler(swiper) {
        swiper.on("onSlideNextStart", function(s){
            resetSlide(slideNo);
            slideNo = swiper.realIndex + 1;
            $timeout(function(){
                $scope.slide = slideNo;
            }, 500);

            startSlideAnimation(slideNo);

            if(slideNo == 5) {
                //$(".swiper-container").css("transition", "height .5s");
                $(".swiper-container").css("height", "calc(100% - 65px)");
            } else {
                $(".swiper-container").css("height", "100%");
            }
        });

        swiper.on("onSlidePrevStart", function(s){
            resetSlide(slideNo);
            slideNo = swiper.realIndex + 1;

            $timeout(function(){
                $scope.slide = slideNo;
            }, 500);

            if(slideNo == 5) {
                $(".swiper-container").css("height", "90%");
            } else {
                $(".swiper-container").css("height", "100%");
            }

            startSlideAnimation(slideNo);
        });
    }

    function resetSlide(slide) {
        switch(slide) {
            case 1:
                resetFirstSlide();
            break;
            case 2:
            break;
            case 3:
            break;
            case 4:
                resetFourthSlide();
            break;
            case 5:
                resetfifthSlide();
            break;
        }
    }

    /* Startet die Animation des aktuellen Slides nach Aufruf. */
    function startSlideAnimation(slide) {
        switch(slide) {
            case 1:
                firstSlideAnimation();
            break;
            case 2:
            break;
            case 3:
                thirdSlideAnimation();
            break;
            case 4:
                fourthSlideAnimation();
            break;
            case 5:
                fifthSlideAnimation();
            break
        }
    }

    function firstSlideAnimation(){
        $timeout(function(){
            $('.intro-taken-img-unblur-div').css("-webkit-transition", "margin-right 1s");
            $('.intro-taken-img-unblur-div').css("transition", "margin-right 1s");
            $('.intro-taken-img-unblur-div').css("margin-right", "100px"); // 100px

            $('.slide-blur-img').css("-webkit-transition", "margin 1s");
            $('.slide-blur-img').css("transition", "margin 1s");
            $('.slide-blur-img').css("margin-left", "50px"); // 50%
        }, 250);
    }

    function resetFirstSlide() {
        $('.intro-taken-img-unblur-div').css("-webkit-transition", "");
        $('.intro-taken-img-unblur-div').css("transition", "");
        $('.intro-taken-img-unblur-div').css("margin-right", "");

        $('.slide-blur-img').css("-webkit-transition", "");
        $('.slide-blur-img').css("transition", "");
        $('.slide-blur-img').css("margin-left", ""); // 50%
    }

    function thirdSlideAnimation() {
        var answer_text = $filter('translate')('INTRODUCTION_SWIPER_3_ANSWER');
        $timeout(function(){
            $(".introduction-answer-typed").typed({
                strings: [answer_text],
                typeSpeed: 25
            });
        }, 500);
    }

    function fourthSlideAnimation() {
        fourthSlide_1 = $timeout(function(){
            $(".first-round").addClass("animated pulse-hard");
            $(".first-round").css("z-index", "10000");

            fourthSlide_1_1 = $timeout(function(){
                $scope.blurredImage = 'img/introduction-slider/men-2.jpg';


                fourthSlide_2 = $timeout(function(){
                    $(".introduction-confirm-round").removeClass("animated pulse-hard");
                    $(".second-round").addClass("animated pulse-hard actual-round");

                    $(".second-round").css("z-index", "10000");
                    $(".first-round").removeClass("animated pulse-hard actual-round");
                    $(".first-round").addClass("positive-round");

                    fourthSlide_2_1 = $timeout(function(){
                        //$(".introduction-profile-img").css("filter", "blur(1.25vw)");
                        $scope.blurredImage = 'img/introduction-slider/men-1.jpg';

                        fourthSlide_2_2 = $timeout(function(){
                            $scope.profile_info.name = $filter('translate')('INTRODUCTION_PROFILE_NAME');

                            fourthSlide_3 = $timeout(function(){
                                $(".introduction-confirm-round").removeClass("animated pulse-hard");
                                $(".second-round").removeClass("animated pulse-hard actual-round");
                                $(".second-round").addClass("positive-round");
                                $(".third-round").addClass("animated pulse-hard actual-round");

                                $(".third-round").css("z-index", "10000");

                                fourthSlide_3_1 = $timeout(function(){
                                    //$(".introduction-profile-img").css("filter", "blur(0vw)");
                                    $scope.blurredImage = 'img/introduction-slider/men.jpg';


                                    fourthSlide_3_2 = $timeout(function(){
                                        $scope.profile_info.hashtag1 = $filter('translate')('INTRODUCTION_HASHTAG_1');
                                        $scope.profile_info.hashtag2 = $filter('translate')('INTRODUCTION_HASHTAG_2');
                                        $scope.profile_info.hashtag3 = $filter('translate')('INTRODUCTION_HASHTAG_3');


                                        fourthSlide_3_3 = $timeout(function(){
                                            $scope.profile_info.last_round = true;

                                            $timeout(function(){
                                                $(".introduction-confirm-round").addClass("animated pulse infinite");
                                            }, 500);
                                        }, 1000); // fourthSlide_3_3
                                    }, 500); // fourthSlide_3_2
                                }, 500); // fourthSlide_3_1
                            }, 1000); // fourthSlide_3
                        }, 500); // fourthSlide_2_2
                    }, 500);
                }, 1000);
            }, 500);
        }, 250);
    }

    function resetFourthSlide() {
        $timeout.cancel(fourthSlide_1);
        $timeout.cancel(fourthSlide_1_1);
        $timeout.cancel(fourthSlide_2);
        $timeout.cancel(fourthSlide_2_1);
        $timeout.cancel(fourthSlide_2_2);
        $timeout.cancel(fourthSlide_3);
        $timeout.cancel(fourthSlide_3_1);
        $timeout.cancel(fourthSlide_3_2);
        $timeout.cancel(fourthSlide_3_3);

        $(".first-round").removeClass("animated pulse-hard actual-round positive-round");
        $(".second-round").removeClass("animated pulse-hard actual-round positive-round");
        $(".third-round").removeClass("animated pulse-hard actual-round positive-round");


        $(".first-round").addClass("actual-round");
        $(".second-round").removeClass("neutral-round");
        $(".third-round").removeClass("neutral-round");

        $(".first-round").css("z-index", "");
        $(".second-round").css("z-index", "");
        $(".third-round").css("z-index", "");

        //$(".introduction-profile-img").css("filter", "blur(2.25vw)");
        



        $timeout(function(){
            $scope.blurredImage = 'img/introduction-slider/men-3.jpg';
            $scope.profile_info.last_round = false;

            $scope.profile_info = {
                name: "???",
                hashtag1: "???",
                hashtag2: "???",
                hashtag3: "???"
            }
        }, 50);

        $(".introduction-confirm-round").removeClass("animated pulse infinite");
    }

    function fifthSlideAnimation() {
        fifthSlide_1 = $timeout(function(){
            $scope.showChatBubble.first = true;
            fifthSlide_2 = $timeout(function(){
                $scope.showChatBubble.second = true;
                fifthSlide_3 = $timeout(function(){
                    $scope.showChatBubble.heart = true;
                }, 850);
            }, 850);
        }, 450);
    }

    function resetfifthSlide() {
        $timeout.cancel(fifthSlide_1);
        $timeout.cancel(fifthSlide_2);
        $timeout.cancel(fifthSlide_3);

        $timeout(function() {
            $scope.showChatBubble = {
                first: false,
                second: false,
                heart: false
            }
        }, 50);
    }

    $scope.skip = function(){
        $state.go('registrate-step1');
    }

    function initSkipButton() {
        var skipText = $filter('translate')('SKIP');
        $(".swiper-pagination").prepend('<div class="swiper-skip" ng-click="skip();">' + skipText + '</div>');
        $compile($('.swiper-skip'))($scope);
    }
});
