angular.module('profile.controller', [])

.controller('ProfileCtrl', function($scope, $stateParams, $_profile, $_profile_cache, $_notification, $ionicHistory, $_sdk, $timeout, $_helper, $_tracking) {
	$scope.$on('$ionicView.beforeEnter', function(){
		var id = $stateParams.id;
		$scope.title = {};
		if(id == null || id == undefined || id == "") {
			$ionicHistory.goBack();
		} else {
			$_tracking.trackPage("Profile");
			var profile = $_profile_cache.getProfile(id);

			if(profile != null && profile != undefined) {
				$scope.profile = profile;
			}

			if(profile == null || profile == undefined) {
				$_helper.showLoadingIndicator();
			}

			getProfile(id);
		}
	})

	function getProfile(id) {
		$_profile.getProfile(id).then(
			function(profile){
				$scope.$apply(function(){
					$scope.profile = profile;
					$scope.title.view_title = profile.name + ', ' + profile.age;
					$scope.title.sub_title = parseInt(profile.distance, 10) + ' km';
					$scope.title.is_verified = profile.is_verified;
				}, 50);
				
				$_helper.hideLoadingIndicator();
				$scope.$broadcast('scroll.refreshComplete');
			},
			function(error){
				$ionicHistory.goBack();
				$timeout(function(){
					$_notification.showNotificationBar(error.msg, error.type);
				}, 500);
				
				$_helper.hideLoadingIndicator();
				$scope.$broadcast('scroll.refreshComplete');
			}
		);
	}
});
