angular.module('registrate.controller', [])

.controller('RegistrateCtrl', function($scope, $_sdk, $filter, $ionicHistory, $_account_cache, $_login, $cordovaDatePicker, $state, $_helper, $rootScope, $_sound, $_upload, $_file_cache, 
	$ionicScrollDelegate, $ionicPopup, $filter, $_helper, $_popup, $_wink_animation, $_registrate, $timeout, $_location, $_tos, $_notification, $_account, $_tracking, CONFIG, $log, $_nativestorage) {

  var blurImg = true;

  $scope.imageComplete = false;
  $scope.input1_focused = false;
  $scope.input2_focused = false;
  $scope.input3_focused = false;
  $scope.blur = {};
  $scope.blur.active = 0;
  $scope.load = {};
  $scope.load.isUploading = false;
  $scope.load.percent = 0;
  $scope.attachment = {
  	cropper: {}
  };
  $scope.page = {
  	loaded: false,
  	imageComplete: false,
  	setHeight: true
  };

  var locale = "de-de";
  var localeOptions = {year: 'numeric', month: 'long', day: 'numeric'};

  var mediaTypeId = 1; // 1 == Profilbild
  var objectId;
  var cacheFileKey;

  $scope.startBlury = function() {
  	$_account_cache.setLoginStatus(true);
  	$_account_cache.setShouldShowCreateAccountBox(true);
  	$state.go('tab.blury');
  	$ionicHistory.clearHistory();
  }

  $scope.$on('$ionicView.beforeEnter', function(){
  	checkWindowHeight();

  	if($_account_cache.getAccountData() != null || $_account_cache.getAccountData() != undefined) {
  		$scope.register = $_account_cache.getAccountData();
  	} else {
  		$scope.register = {};
  	}

  	if($state.current.name === "registrate-step1") {
  		if($_account_cache.shouldShowPopup()) {
  			$scope.confirmTerms();
  		}
  	}

  	if($state.current.name === "registrate-step3") {
  		if($scope.register.datevalue != null && $scope.register.datevalue != undefined) {
  			if(!$scope.register.datevalue) $scope.register.datevalue = new Date(new Date().setFullYear(new Date().getFullYear() - 20));
  			if(!$scope.register.datepicker) $scope.register.datepicker = new Date(new Date().setFullYear(new Date().getFullYear() - 20)).toLocaleString(locale, localeOptions);
  		}
  	}

  	if($state.current.name === "registrate-step4") {
  		// Camera-Fix
  		if($rootScope.cameraState.takingPicture && $rootScope.cameraState.currentScreen == "registrate") {
  			$rootScope.cameraState.currentScreen = "";

  			$_sdk.setClientID($rootScope.cameraState.clientID);
				$_sdk.setxAuthToken($rootScope.cameraState.xAuthToken);
				$_sdk.setUserID($rootScope.cameraState.userID);
        $_nativestorage.setItem("userID",$rootScope.cameraState.userID);
        $_nativestorage.setItem("xAuthToken",$rootScope.cameraState.xAuthToken);
        
  			$scope.cropImage($rootScope.cameraState.imageUri);
  		}
	    
  	}

  	
  });

  $scope.goBack = function() {
  	saveObject();
  	$ionicHistory.goBack();
  }

  $scope.$on('$ionicView.beforeLeave', function(){
  	//$_account_cache.saveAccountData($scope.register);
  	if($state.current.name === "registrate-step1") {
  		//$_wink_animation.stop();
  	}

  	if($state.current.name === "registrate-step2" || $state.current.name === "registrate") {
  		$_account_cache.saveShouldShowPopup(false);
  	}

  	if($state.current.name === 'terms-of-use' || $state.current.name === 'privacy-policy') {
  		$_account_cache.saveAccountData($scope.register);
  		$_account_cache.saveShouldShowPopup(true);
  	}
  });

  $scope.$on('$ionicView.enter', function(){
  	if($state.current.name == 'registrate-step4' && $scope.page.imageComplete == true) {
  		presentBlur();
  	}
  });


  $scope.saveStep1 = function() {
  	if($scope.register.name && $scope.register.name.length > 1 && $scope.register.city && $scope.register.city.length > 1) {
  		$scope.confirmTerms();
  	}
  }

  $scope.confirmTerms = function() {
  	var confirmPopup = $ionicPopup.confirm({
  		title: $filter('translate')('CONFIRM_TERMS_OF_USE'),
		template: $filter('translate')('CONFIRM_TERMS_OF_USE_TEXT'),
		cssClass: 'confirm-popup',
		cancelText: $filter('translate')('DECLINE'),
		okText: $filter('translate')('CONFIRM')
	})
	.then(function(res) {
		if(res) {
			$_sound.playClick();
			saveObject();
			$state.go('registrate-step2');
		} else {
			$_sound.playClick();
		}
	});
   }

	$scope.saveStep2 = function() {
		if($scope.register.datevalue && $scope.register.gender && $scope.register.gender.length > 3 && $scope.register.looking_for_gender && $scope.register.looking_for_gender.length > 3) {

	  	var confirmPopup = $ionicPopup.confirm({
	  		title: $filter('translate')('CONFIRM_AGE_AND_GENDER'),
				template: $filter('translate')('CONFIRM_AGE_AND_GENDER_TEXT'),
				cssClass: 'confirm-popup',
				cancelText: $filter('translate')('CANCEL'),
				okText: $filter('translate')('OK')
			})
			.then(function(res) {
				if(res) {
					$_sound.playClick();
					saveObject();
					$state.go('registrate-step3');
				} else {
					$_sound.playClick();
				}
			});


			
		}
	}

	$scope.saveStep3 = function() {
		if(checkHashtags()) {
			$scope.register.device_id = $_helper.getSHA1RegistrationCode();
			$scope.register.hash = $_helper.generateRandomString(30);

			saveObject();
		    registrateRequest();
		}
	}

	/*
	Überprüft die Hashtags auf:
	 - länger als 2 Zeichen
	 - alle verschieden
	*/
	function checkHashtags() {
		var hashtag1 = $scope.register.hashtag1;
		var hashtag2 = $scope.register.hashtag2;
		var hashtag3 = $scope.register.hashtag3;

		var hashtagEqualFailMsg = function() {
			var msg = $filter('translate')('YOUR_HASHTAGS_MUST_BE_DIFFERENT_FROM_EACH_OTHER');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);
		}

		if($scope.register.hashtag1.length < 2 || $scope.register.hashtag2.length < 2 || $scope.register.hashtag3.length < 2) {
			var msg = $filter('translate')('YOUR_HASHTAG_MUST_BE_MIN_TWO_CHARS');
			var type = $_notification.getNotificationTypes().ERROR;

			$_notification.showNotificationBar(msg, type);

			return false;
		}

		if(hashtag1 == hashtag2 || hashtag1 == hashtag3) {
			hashtagEqualFailMsg();
			return false;
		}

		if(hashtag2 == hashtag1 || hashtag2 == hashtag3) {
			hashtagEqualFailMsg();
			return false;
		}

		if(hashtag3 == hashtag1 || hashtag3 == hashtag2) {
			hashtagEqualFailMsg();
			return false;
		}

		return true;
	}

	$scope.abortRegistration = function() {
		$_sound.playClick();
		$_popup.abortRegistrationPopup();
	}

	$scope.openDatePicker = function () {
	    var options = $_helper.getBirthDatePickerOptions();

	    if($scope.register.birthdate != null && $scope.register.birthdate != undefined) {
	    	$scope.register.birthdate = new Date($scope.register.birthdate);
	    	options.date = $scope.register.birthdate;
	    }

	    $cordovaDatePicker.show(options).then(function(date){
	    	if(date == null || date == undefined) {

			} else if(moment().diff(date, 'years') < CONFIG.min_age) {
	    		$_notification.showNotificationBar(
	    			$filter('translate')('YOU_HAVE_TO_BE_OVER_16'),
	    			$_notification.getNotificationTypes().ERROR
	    		);

	    		$scope.register.datepicker = "";
	    		$scope.register.datevalue = "";
	    		$scope.register.birthdate = "";
	    	} else {
	    		$scope.register.datepicker = moment(date).format('DD. MMMM YYYY');
	    		$scope.register.datevalue = new Date(date);
	    		$scope.register.birthdate = new Date(date);
	    	}
	    });
	  };

	  $scope.scrollTop = function() {
	  	$ionicScrollDelegate.scrollTop();
	  }

	  $scope.selectLookingForGender = function(val) {
	  	$_sound.playClick();
	  	$scope.register.looking_for_gender = val;
	  }

	  $scope.selectGender = function(val) {
	  	$_sound.playClick();
	  	$scope.register.gender = val;
	  }

	$scope.$watch("register.hashtag1", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.register.hashtag1 = oldValue;
		}
	});

	$scope.$watch("register.hashtag2", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.register.hashtag2 = oldValue;
		}
	});

	$scope.$watch("register.hashtag3", function(newValue, oldValue) {
		if(!$_helper.hashtagIsValid(newValue)) {
			$scope.register.hashtag3 = oldValue;
		}
	});

	$scope.resetBlur = function() {
		$scope.blur.active = 0;
		var elem = $('.profile-img-selector-registrate');
		$_helper.resetBlur(elem);
	}

	$scope.blurImage = function() {
		$scope.blur.active = 1;
		var elem = $('.profile-img-selector-registrate');
		$_helper.blurProfileImage(elem);
	}

	function presentBlur() {
	  	$scope.blur.present = 0;

	  	$timeout(function(){
	  		$scope.blur.present = 1;
	  		$scope.blurImage();
	  		$timeout(function(){
	  			$scope.blur.present = 0
	  			$scope.resetBlur();
	  		}, 1000);
	  	},1000);
	}

	/* Veraltete Funktion für altes Take-Photo */
	$scope.changeProfilePicture = function() {
		$state.go('take-photo');
	};

	function saveObject() {
		$_account_cache.saveAccountData($scope.register);
	}

	/*
	 * Überprüft die Höhe des Screens, um einzustellen ob der "Weiter"-Button ab
	 * einer bestimmten Höhe nicht mehr angezeigt wird, wenn die Tastatur geöffnet ist.
	 */
	function checkWindowHeight() {
		var window_height = $(window).height();
	  	if(window_height <= 568) {
	  		$timeout(function(){
	  			$scope.page.setHeight = false;
	  		}, 50);
	  	}
	}

	function registrateRequest() {
		if($_sdk.getUserID() != null && $_sdk.getUserID() != undefined) {
			// refresh daten
			updateUserSettings();
		} else {
			$_sdk.setRequestID();
			$_helper.showLoadingIndicator();
			$_registrate.registrate($scope.register).then(
				function(success){
					signinRequest();
				},
				function(error){
					$_notification.showNotificationBar(error.msg, error.type);
					$_helper.hideLoadingIndicator();
				}
			);
		}
	}

	function signinRequest() {
		$_sdk.setClientID($scope.register.device_id);
		$_login.login($scope.register.device_id, $scope.register.hash).then(
			function(success){
				$_tracking.setUserId($_sdk.getUserID());
				$_helper.hideLoadingIndicator();
				setLocationRequest();
				$_login.registerIonicPush();
				$state.go('registrate-step4');
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
				$_helper.hideLoadingIndicator();
			}
		)
	}

	function setLocationRequest() {
		$_location.setCurrentLocation().then(
			function(success){
				$log.debug("Success setting location");
			},
			function(error){
				$log.debug("Error setting location");
			}
		)
	}

	function updateUserSettings(){
		$_helper.showLoadingIndicator();
		$_account.saveAccountData($scope.register).then(
			function(success){
				// Daten erfolgreich aktualisiert
				$_helper.hideLoadingIndicator();
				$state.go('registrate-step4');
			},
			function(error) {
				// Daten Aktualisieren fehlgeschlagen
				$_notification.showNotificationBar(error.msg, error.type);
				$_helper.hideLoadingIndicator();
			}
		);
	}

	/* Profilbild laden */

	function loadProfileImage() {
		$_file_cache.read(cacheFileKey).then(function(content) {
			$log.debug("Erfolgreich Foto "+cacheFileKey+" geladen");

			$timeout(function(){
				$scope.page.imageComplete = true;
				$scope.page.profile_img = content;
				$scope.page.loaded = true;
				presentBlur();
			}, 50);
		}).catch(function(err) {
			$log.debug("Konnte Foto "+cacheFileKey+" NICHT laden");
			$log.debug(err);

			$timeout(function(){
				$scope.page.imageComplete = false;
				$rootScope.badges.account = 1;
				$rootScope.badges.chats = 1;
			}, 50);
		});
	}

	/* Profilbild schießen */

	$scope.submitCroppedMedia = function() {
		// Upload-Indicator
		$timeout(function(){
			$scope.load.isUploading = true;
			$scope.load.percent = 0;
			$_upload.uploadPopup($scope);
		}, 50);

		// Upload-Prozess
		var saveProfileImage = function(sourceImage) {
			cacheFileKey = "image_" + objectId + "_" + mediaTypeId;

			$_helper.convertLocalImageToBase64(sourceImage,  function(base64) {
				$_file_cache.save(cacheFileKey, base64).then(function() {
					$log.debug("Erfolgreich Foto "+cacheFileKey+" gecached");

					$timeout(function(){
						$scope.page.imageComplete = true;
						loadProfileImage();

						$_account_cache.saveOldAccountImageIdBeforeUpload($_account_cache.getOldAccountImageId());
						$_account_cache.saveOldAccountImageId(0);
						$_account_cache.setUserHasProfileImage(true);
						$_account_cache.saveAccountImage(cacheFileKey);


					}, 50);
				}).catch(function(err) {
					$log.debug("Konnte Foto "+cacheFileKey+" NICHT cachen");
				});
			});
		};

		$scope.$evalAsync(function(){
			objectId = $_sdk.getUserID();
			$_sdk.setObjectID(objectId);
			$_sdk.upload(mediaTypeId, $scope.attachment.cropper.croppedImage, function(currentStatus){
				$timeout(function(){
					$scope.load.percent = parseInt(currentStatus);
			    }, 25);
			}, function(response){ // Upload erfolgreich
				var responseJSON = JSON.parse(response.response);
				$log.debug(responseJSON);
				if(responseJSON.ack == "failure"){

					$log.debug("responseJSON.ack failure");

					var msg = $filter('translate')('UPLOAD_FAILED');
					if(responseJSON.code == 244) msg = $filter('translate')('NO_FACE_RECOGNIZED');

					var type = $_notification.getNotificationTypes().ERROR;
					$_popup.closeAllOpenedPopups();
					$_notification.showNotificationBar(msg, type);
					$scope.load.isUploading = false;

				} else if(responseJSON.ack == "success") {

					$log.debug("responseJSON.ack success");

					$scope.load.isUploading = false;
					$_popup.closeAllOpenedPopups();

					if(mediaTypeId == 1) { // Profilbild
						saveProfileImage($scope.attachment.cropper.croppedImage);
						$_account_cache.setUserHasProfileImage(true);
					}
				}

			}, function(error) { // Upload error
				$timeout(function(){ // 244
					$_popup.closeAllOpenedPopups();
					var type = $_notification.getNotificationTypes().ERROR;
					var msg = $filter('translate')('UPLOAD_FAILED');
					$_notification.showNotificationBar(msg, type);
				}, 50);
			});
		});

	};

	$scope.cropImage = function(fileURL) {
		$rootScope.cameraState.takingPicture = false;
		plugins.crop.promise(fileURL, {
			quality: 100
		}).then(function success(newPath) {
			$scope.attachment.cropper.croppedImage = newPath;
			$scope.page.profile_img = newPath;

			$_upload.resizeImage(1000, newPath, function(data) {
          $scope.attachment.cropper.croppedImage = data;
          $scope.submitCroppedMedia();
      });

			//$scope.submitCroppedMedia();
		}).catch(function fail(err) {
			$log.debug(err);
		});
	};

	$scope.showTakePhotoActionsheet = function() {
		var setUploadFile = function(fileURL, previewFileStorageKey, previewID) {
		    
	    $scope.attachment.hasMedia = true;
	    $scope.attachment.fileUrl = fileURL;
	    $scope.attachment.previewFileStorageKey = previewFileStorageKey;

	    $rootScope.cameraState.imageUri = fileURL;

			$scope.cropImage(fileURL);
		};

		var imageHandler = function(source) {
		  $_upload.getImage(source).then(function(imageUri) {
		    setUploadFile(imageUri, "previewProfileImage", "profile_image");
		  }).catch(function(err) {
		    $log.debug("$_upload.getImage catch: ");
		    $log.debug(err);

		    var msg = $filter('translate')('CHOOSE_FOTO_FAIL');
			var type = $_notification.getNotificationTypes().ERROR;

			$log.debug(msg);

			$_notification.showNotificationBar(msg, type);

		    $rootScope.cameraState.takingPicture = false;
		  });
		};

		$_upload.uploadFileActionSheet().then(function(type) {
			$_popup.showPhotoRulesPopup().then(function() {
				$rootScope.cameraState.takingPicture = true;
				$rootScope.cameraState.imageUri = "";
				$rootScope.cameraState.currentScreen = "registrate";
				$rootScope.cameraState.clientID = $_sdk.getClientID();
				$rootScope.cameraState.xAuthToken = $_sdk.getxAuthToken();
				$rootScope.cameraState.userID = $_sdk.getUserID();
				imageHandler($_helper.getImageSourceFromCam(type));
			}).catch(function(err) {
				$log.debug(err);
			});
		  
		}).catch(function(err) {
		  $log.debug(err);
		});
	}

	/* Profilbild schießen Ende */
});
