angular.module('show_points.controller', [])

.controller('ShowPointsCtrl', function($scope, $_popup, $_points, $timeout, $_notification, $_points_cache, $_tracking, $cordovaSocialSharing, $_account) {
	$scope.$on('$ionicView.beforeEnter', function (event, viewData) {
		$_tracking.trackPage("Points List");
		$_popup.closeAllOpenedPopups();
		viewData.enableBack = true;
		$scope.point = {};
		$scope.point = $_points_cache.getPointsList();
		getPointsList();
    });

    function getPointsList() {
    	$_points.getPointsList().then(
			function(data){
				var pointsPos = [];
				var pointsNeg = [];
				for(i in data) {
					if(data[i].point_types_value > 0) pointsPos.push(data[i]);
					else if(data[i] != null) pointsNeg.push(data[i]);
				}
				$timeout(function(){
					$scope.point = {};
					$scope.point.pos = pointsPos;
					$scope.point.neg = pointsNeg;
					$_points_cache.savePointsList($scope.point);
					var pa = $_points_cache.getPointsList();
				}, 10);
			},
			function(error){
				$_notification.showNotificationBar(error.msg, error.type);
			}
		)
    }

    $scope.sharePrompt = function() {
		//console.log("share");
	    $_account.getShareLink().then(function(data) {
	    	//console.log(data);
	    	$cordovaSocialSharing.share(data.text, null, null, data.share_link);
	    },
		function(error){
			$timeout(function(){
				$_notification.showNotificationBar(error.msg, error.type);
			}, 250);
		});


	    
	};
});