angular.module('take_photo.controller', [])

.controller('TakePhotoCtrl', function($scope, $timeout, $ionicHistory, $ionicPlatform, $_notification, $_sound, $filter,
	$_account_cache, $_sdk, $_upload, $_popup, $_image_resize, $filter, $stateParams, $state, $_image_cache, $_helper, $log) {
	
	var block = false;
	var counter = 0;

	var mediaTypeId = 1; // 1 == Profilbild
	var objectId;

	$scope.initCamera = function() {
		$scope.load = {};
		$scope.load.isUploading = false;
		$scope.load.percent = 0;
		$scope.data = {};
		$scope.data.flash = 0;
		$scope.data.showimage = false;
		$scope.data.camera = "front";
		$('.view-container').css("background-color", "transparent");
		$('.take-picture-blurred-bg').css("height", getScreenHeight());
	}

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		checkCameraAuthorizationStatus();

		if($stateParams.id != null && $stateParams.id != undefined && $stateParams.id.length > 0 && $stateParams.id != ""){
			mediaTypeId = 'verification';
			objectId = $stateParams.id;
		}
		else {
			mediaTypeId = 1;
			objectId = $_sdk.getUserID();
		}
	});

	$scope.$on("$ionicView.afterEnter", function(event, data){
		//$scope.start();
	});

	$scope.$on("$ionicView.beforeLeave", function(event,data){
		if(cordova.platformId === 'android') {
			CameraPreview.hide();
			CameraPreview.stopCamera();
		} else {
			CameraPreview.hide();
		}
	})

	$ionicPlatform.on('resume', function(){
		$scope.start();
	});

	$scope.start = function() {
		var success = function(success) {
			$log.debug(success);
		}

		var error = function(error) {
			CameraPreview.show();
		}

		CameraPreview.startCamera({x: 0, y: 0, camera: $scope.data.camera, tapPhoto: false, previewDrag: false, toBack: true}, success, error);
	}

	$scope.stop = function() {
		CameraPreview.stopCamera();
	}

	$scope.take = function() {
		$_sound.playClick();
		CameraPreview.takePicture({quality: 100}, function(base64PictureData){
			$timeout(function() {
				CameraPreview.hide();
				$scope.data.image_url = 'data:image/jpeg;base64,' +base64PictureData[0];
				$scope.data.showimage = true;
			}, 100);
		});

		var deregisterBackButtonAction = $ionicPlatform.registerBackButtonAction(function(){
			$scope.reset();
		}, 101);

		$ionicPlatform.onHardwareBackButton(function(){
			deregisterBackButtonAction();
		});
	}

	$scope.reset = function() {
		$_sound.playClick();
		$scope.$evalAsync(function(){
			$scope.load.isUploading = false;

			if($scope.data.showimage == false) {
				$ionicHistory.goBack();
			} else {
				$timeout(function(){
					$scope.data.showimage = false;
					$scope.data.image_url = "";
					CameraPreview.show();
				},50);
			}
		});
	}

	$scope.close = function() {
		$_sound.playClick();
		$scope.$evalAsync(function(){
			if($scope.showimage == true) {
			} else {
				$timeout(function(){
					/*$timeout(function(){
						$scope.stop();
					}, 50);*/
					$timeout(function(){
						$ionicHistory.goBack();
					}, 250);
				}, 50);
			}
		});
	}

	$scope.cameraSwitch = function() {
		$_sound.playClick();
		if($scope.data.camera == "front") $scope.data.camera = "back";
		else $scope.data.camera = "front";

		// Prevent double tap issues in android
		if(cordova.platformId === 'android') {
			if(!block) {
				CameraPreview.switchCamera(function(success){$log.debug(success); cameraSwitchFlashModeHandler();}, function(fail){$log.debug(fail)});
			}
			block = true;
			
			$timeout(function(){
				block = false;
			}, 500);
		} else {
			CameraPreview.switchCamera(function(success){$log.debug(success); cameraSwitchFlashModeHandler();}, function(fail){$log.debug(fail)});
		}
	}

	/* Aktiviert oder deaktiviert (je nach Wunsch) den Blitz beim Wechsel der Kamera. */
	function cameraSwitchFlashModeHandler() {
		if($scope.data.flash == 0) {
			CameraPreview.setFlashMode(CameraPreview.FLASH_MODE.OFF, function(success){$log.debug(success)}, function(error){$log.debug(error)});
		}

		if($scope.data.flash == 1) {
			CameraPreview.setFlashMode(CameraPreview.FLASH_MODE.ON, function(success){$log.debug(success)}, function(error){$log.debug(error)});
		}
	}

	$scope.flashmode = function() {
		$_sound.playClick();
		if($scope.data.flash == 0) {
			CameraPreview.setFlashMode(CameraPreview.FLASH_MODE.ON, function(success){$log.debug(success)}, function(error){$log.debug(error)});
		}

		if($scope.data.flash == 1) {
			CameraPreview.setFlashMode(CameraPreview.FLASH_MODE.OFF, function(success){$log.debug(success)}, function(error){$log.debug(error)});
		}

		if($scope.data.flash == 1) {
			$timeout(function(){
				$scope.data.flash = 0;
			},50);
		} else {
			$timeout(function(){
				$scope.data.flash = 1;
			},50);
		}
	}

	

	$scope.saveImage = function() {
		$_sound.playClick();
		$timeout(function(){
			$scope.load.isUploading = true;
			$scope.load.percent = 0;
			$_upload.uploadPopup($scope);
		}, 50);

		$scope.$evalAsync(function(){
			cropImage($scope.data.image_url).then(
				function(cropped_img) { // Crop success				
					$_sdk.setObjectID(objectId);

	                $_sdk.upload(mediaTypeId, cropped_img, function(currentStatus){
	                    $_sdk.debug(currentStatus + "%", "upload");

	                    $timeout(function(){
	                        $scope.load.percent = parseInt(currentStatus);
	                    }, 25);
	                }, function(response){ // Upload erfolgreich
	                	$log.debug("response");
	                	$log.debug(response);
	                	var responseJSON = JSON.parse(response.response);
	                	if(responseJSON.ack == "failure"){
	                		var msg = $filter('translate')('UPLOAD_FAILED');
	                		
	                		if(responseJSON.code == 244) {
	                			msg = $filter('translate')('NO_FACE_RECOGNIZED');
	                		}

	                		var type = $_notification.getNotificationTypes().ERROR;
	                		$_popup.closeAllOpenedPopups();
	                		$_notification.showNotificationBar(msg, type);
	                		$scope.load.isUploading = false;
	                	} else if(responseJSON.ack == "success") {
	                		$scope.load.isUploading = false;
	                		$_popup.closeAllOpenedPopups();

	                		if(mediaTypeId == 1) { // Profilbild
	                			saveProfileImage(cropped_img);
	                			$_account_cache.setUserHasProfileImage(true);
	                		} else { // Verifizierung
	                			$state.go('tab.account');
	                			$ionicHistory.clearHistory();
	                			$_account_cache.setVerificationImageAsCheck();
	                		}
	                	}
	                }, function(error) { // Upload error
	                	$log.debug("error");
	                	$log.debug(error);
	                	$timeout(function(){ // 244
	                		$_popup.closeAllOpenedPopups();

	                		var type = $_notification.getNotificationTypes().ERROR;
	                		var msg = $filter('translate')('UPLOAD_FAILED');
	                		$_notification.showNotificationBar(msg, type);
	                	}, 50);
	                });
				},
				function(error) { // Crop error
					$_notification.showNotificationBar(error.msg, error.type);
					$_popup.closeAllOpenedPopups();
					$scope.load.isUploading = false;
				}
			)
		});
	}

	function saveProfileImage(base64String) {
		//$_account_cache.saveAccountImage(base64String);
		$_account_cache.saveAccountImage(base64String);
		$_account_cache.saveOldAccountImageIdBeforeUpload($_account_cache.getOldAccountImageId());
		$_account_cache.saveOldAccountImageId(0);
		$_account_cache.setUserHasProfileImage(true);
		$timeout(function(){
			$ionicHistory.goBack();
		}, 500);

		//var filename = $_helper.generateRandomString(30) + '.jpg';
		
		/*$_image_cache.cacheBase64Image(base64String, filename).then(function(profile_img){
			$_account_cache.saveAccountImage(profile_img);
			$ionicHistory.goBack();
		}, function(error){
			$log.debug("error saving");
		});*/
	}

	function cropImage(src) {
		return new Promise(function(resolve, reject){
			var imgCutOut = $('.take-picture-cutout');
	      	var orgImg = $('.taken-image').get(0);
			var offset = imgCutOut.offset();

	      	// Faktor zum Umrechnen
	      	var u_w = orgImg.naturalWidth / window.innerWidth;
	      	var u_h = orgImg.naturalHeight / window.innerHeight;

	      	// Maße des gecroppten Bildes.
	      	var left = 0;
	      	var top = offset.top * u_h;

	      	var height = imgCutOut.height() * u_h;
	      	var width = height;

	      	if(height > orgImg.naturalWidth) {
	      		height = imgCutOut.width() * u_w;
	      		width = height;
	      	}

	      	var offsetLR = parseInt((orgImg.naturalWidth - width)) / 2; // Offset zum Zentrieren des Bildes

	      	// draw image to canvas and get image data
		    var canvas = document.createElement("canvas");
		    canvas.width = orgImg.naturalWidth;
		    canvas.height = orgImg.naturalHeight;
		    var ctx = canvas.getContext("2d");

		    var img = new Image();

		    ctx.drawImage(orgImg, 0, 0);
		    var imageData = ctx.getImageData(offsetLR, top, width, height);

		    // context.drawImage(img,sx,sy,swidth,sheight,x,y,width,height);

		    // create destination canvas
		    var canvas1 = document.createElement("canvas");
		    canvas1.width = width;
		    canvas1.height = height;
		    var ctx1 = canvas1.getContext("2d");
		    ctx1.rect(0, 0, width, height);
		    ctx1.fillStyle = 'white';
		    ctx1.fill();
		    ctx1.putImageData(imageData, 0, 0);

		    $timeout(function(){
		    	if(height < 1000 && width < 1000) {
		    		var cropped_url = canvas1.toDataURL("image/jpeg", 1.0);

		    		resolve(cropped_url);
		    	} else {
		    		$_image_resize.resize(canvas1, 1000, 1000, 0).then(
			    		function(url){
			    			resolve(url);
			    		},
			    		function(error){
			    			reject(error);
			    		}
			    	);
		    	}
		    }, 250);
	    });
	}

	function encode(picture) {
		window.plugins.Base64.encodeFile("data:image/jpeg;base64," + picture[0], function(base64){});
	}

	function getScreenHeight() {
		if(cordova.platformId == 'ios') {
			return window.innerHeight - window.innerWidth - 69;
		}

		if(cordova.platformId == 'android') {
			return $(window).height() - $(window).width() - 49;
		}
	}

	function checkCameraAuthorizationStatus() {
		cordova.plugins.diagnostic.getCameraAuthorizationStatus(
		    function(status){
		        if(status === cordova.plugins.diagnostic.permissionStatus.GRANTED){
		            $scope.start();
		        } else if(status === cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS) {
		        	onHasNoCameraPermission();
		        } else {
		        	askForCameraPermissions();
		        }

		    }, function(error){
		    }, false
		); 
	}

	function checkCameraPermissions() {
		cordova.plugins.diagnostic.isCameraAuthorized(
			function(has_permissions){

				if(!has_permissions) {
					onHasNoCameraPermission();
				}
			},
			function(error) {
			}
		);
	}

	function askForCameraPermissions() {
		cordova.plugins.diagnostic.requestCameraAuthorization({
		    successCallback: function(status){
		        if(status === cordova.plugins.diagnostic.permissionStatus.GRANTED) {
		        	$scope.start();
		        }

		        if(status === cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS) {
		        	onHasNoCameraPermission();
		        }

		        if(status === cordova.plugins.diagnostic.permissionStatus.DENIED) {
		        	onHasNoCameraPermission();
		        }
		    },
		    errorCallback: function(error){
		        onHasNoCameraPermission();
		    },
		    externalStorage: false
		});
	}

	function onHasNoCameraPermission() {
		$ionicHistory.goBack();

		if(cordova.platformId === 'ios'){
			$_popup.alert($filter('translate')('ALLOW_CAMERA_ACCESS_IOS'), $filter('translate')('ALLOW_CAMREA_ACCESS'));
		}

		if(cordova.platformId === 'android'){
			$_popup.alert($filter('translate')('ALLOW_CAMERA_ACCESS_ANDROID'), $filter('translate')('ALLOW_CAMREA_ACCESS'));
		}
	}
});
