angular.module('verify_account.controller', [])

.controller('VerifyAccountCtrl', function($scope, $timeout, $_notification, $_tracking, $stateParams, $_verify_account, $_account_cache, $_helper, $ionicHistory, $state, $log, $_upload, $_sdk, $_popup, $filter, $rootScope) {
	$scope.verification = {};

    $scope.attachment = {
        hasMedia: false,
        fileUrl: null,
        previewFileStorageKey: "",
        cropper: {}
    };

    $scope.load = {};
    var mediaTypeId = 'verification'; // 1 == Profilbild
    var objectId;

	$scope.$on('$ionicView.beforeEnter', function (event, viewData) {
		$_tracking.trackPage("Profilbild verifizieren Screen");
		viewData.enableBack = true;

		if($stateParams.id == null || $stateParams == undefined)
			$ionicHistory.goBack();

		$scope.verification = $_account_cache.getMediaVerificationObj($stateParams.id);

		if($scope.verification == null || $scope.verification == undefined) {
			$_helper.showLoadingIndicator();
		}

		getVerificationData();

        // Camera-Fix
        if($rootScope.cameraState.takingPicture && $rootScope.cameraState.currentScreen == "verification") {
            $rootScope.cameraState.currentScreen = "";
            $scope.imageResize($rootScope.cameraState.imageUri);
        }
    });

    function getVerificationData() {
    	$_verify_account.getVerificationData($stateParams.id).then(function(success){
    		$timeout(function(){
    			$scope.verification = success;

                $log.debug($scope.verification);
    		}, 25);
    		$_helper.hideLoadingIndicator();
    	}, function(error){
    		if(error.code == 205 || error.code == 101) {
    			$ionicHistory.goBack();

    			$timeout(function(){
    				$_notification.showNotificationBar(error.msg, error.type);
    				$_helper.hideLoadingIndicator();
    			}, 500);
    		} else {
    			$_notification.showNotificationBar(error.msg, error.type);
    			$_helper.hideLoadingIndicator();
    		}
    	});
    }


    /* Image-Upload-Handling START */

    $scope.submitCroppedMedia = function() {
        // Upload-Indicator
        objectId = $scope.verification.media_verification_id;

        $timeout(function(){
            $scope.load.isUploading = true;
            $scope.load.percent = 0;
            $_upload.uploadPopup($scope);
        }, 50);

        $scope.$evalAsync(function(){
            $_sdk.setObjectID(objectId);
            $_sdk.upload(mediaTypeId, $scope.attachment.cropper.croppedImage, function(currentStatus){

                $timeout(function(){
                    $scope.load.percent = parseInt(currentStatus);
                }, 25);

            }, function(response){ // Upload erfolgreich

                var responseJSON = JSON.parse(response.response);
                $log.debug(responseJSON);
                if(responseJSON.ack == "failure"){

                    $log.debug("responseJSON.ack failure");

                    var msg = $filter('translate')('UPLOAD_FAILED');
                    if(responseJSON.code == 244) msg = $filter('translate')('NO_FACE_RECOGNIZED');

                    var type = $_notification.getNotificationTypes().ERROR;
                    $_popup.closeAllOpenedPopups();
                    $_notification.showNotificationBar(msg, type);
                    $scope.load.isUploading = false;

                } else if(responseJSON.ack == "success") {

                    $log.debug("responseJSON.ack success");

                    $scope.load.isUploading = false;
                    $_popup.closeAllOpenedPopups();

                    $_account_cache.setVerificationImageAsCheck();
                    $ionicHistory.goBack();
                }

            }, function(error) { // Upload error
                $timeout(function(){ // 244
                    $_popup.closeAllOpenedPopups();
                    var type = $_notification.getNotificationTypes().ERROR;
                    var msg = $filter('translate')('UPLOAD_FAILED');
                    $_notification.showNotificationBar(msg, type);
                }, 50);
            });
        });
    };

    $scope.imageResize = function(fileURL) {
        $rootScope.cameraState.takingPicture = false;
        $_upload.resizeImage(1000, fileURL, function(data) {
            $scope.attachment.cropper.croppedImage = data;
            $scope.submitCroppedMedia();
        });
    };

    $scope.showTakePhotoActionsheet = function() {

        var setUploadFile = function(fileURL, previewFileStorageKey, previewID) {
            $scope.attachment.hasMedia = true;
            $scope.attachment.fileUrl = fileURL;
            $scope.attachment.previewFileStorageKey = previewFileStorageKey;

            $rootScope.cameraState.imageUri = fileURL;

            /*plugins.crop.promise(fileURL, {
                quality: 100
            }).then(function success (newPath) {
                $log.debug("Original Image: ");
                $log.debug(fileURL);
                $log.debug("New Cropped Image: ");
                $log.debug(newPath);
                $scope.attachment.cropper.croppedImage = newPath;
                $scope.submitCroppedMedia();
            }).catch(function fail (err) {
                $log.debug("Crop Fail err");
                $log.debug(err);
            });*/

            $scope.imageResize(fileURL);

            
        };

        var imageHandler = function(source) {
            $rootScope.cameraState.takingPicture = true;
            $rootScope.cameraState.imageUri = "";
            $rootScope.cameraState.currentScreen = "verification";
            $_upload.getImage(source).then(function(imageUri) {
                setUploadFile(imageUri, "verificationImage", "verification_image");
            }).catch(function(err) {
                $log.debug("$_upload.getImage catch: ");
                $log.debug(err);
                $rootScope.cameraState.takingPicture = false;
            });
        };

        imageHandler($_helper.getImageSourceFromCam('camera'));
    };

    /* Image-Upload-Handling END */

});