angular.module('listenRemoveClass.directive', [])
    /* Ändert den Ladeindikator je nach dem wie weit der Screen nach unten gezogen wird, wird in ion-refresh eingebunden */
    .directive('listenRemoveClass', [function(){

        var foldername = 'refresh-animation';
        var filename = 'sprites-blury';
        var loadingfile = 'sprites-loading.gif';

        var dateObj = new Date();
        var month = dateObj.getUTCMonth() + 1; //months from 1-12
        var day = dateObj.getUTCDate();
        var year = dateObj.getUTCFullYear();

        if(month == 12 && day <=26) {
          foldername = 'refresh-animation-xmas';
          filename = 'sprites-blury-xmas';
          loadingfile = 'blury-sprites-loading-xmas.gif';
        }

        return {
            link: function(scope, element, attrs) {
                var observer = new MutationObserver(function(mutations) {
                  var startPx = 36; // Wann die Änderung des Ladeindikators beginnen soll
                  var maxPx = 70; // -> ptrThreshold in ionic.bundle.js
                  var noSteps = 34; // Anzahl der Fotos
                  var imgSrcPre = "img/"+foldername+"/"+filename+"_"; // Startgrafik in ionic.bundle.js Z. 65654
                  var imgSrcPost = ".png";
                  var steps = 0.9; // startPx/noSteps

                  var transform = attrs['$$element'][0].style.transform;
                  var transformSlice = transform.slice(17);
                  var endOfYCoordinates = transformSlice.indexOf("px");

                  var transformSlice = transformSlice.slice(0, endOfYCoordinates);

                  if(transformSlice >= 0) {
                    var transformationPx = parseInt(transformSlice, 10);

                    if(transformationPx > startPx) {
                      if(transformationPx > maxPx) {
                          var imgSrc = imgSrcPre + noSteps + imgSrcPost;
                          $('.pull-img').attr('src', imgSrc);
                        } else {
                          var actStep = (transformationPx-startPx) / steps;
                          actStep = parseInt(actStep, 10);
                        if(actStep > noSteps) {
                          var imgSrc = imgSrcPre + noSteps + imgSrcPost;
                          $('.pull-img').attr('src', imgSrc);
                        } else {
                          var imgSrc = imgSrcPre + actStep + imgSrcPost;
                          $('.pull-img').attr('src', imgSrc);
                        }
                      }
                    }
                  }
                });
                observer.observe(element[0], {
                    attributes: true,
                    attributeFilter: ['style'],
                    childList: false,
                    subtree: false
                });
            }
        };
    }]
);
