angular.module('onlineSrc.directive', [])
    /* Wird verwendet, wenn Bilder aus dem Web im img-Tag angezeigt werden. Das Platzhalterbild wird in ng-src hinterlegt. */
    .directive('onlineSrc', function ($rootScope) {
      return{
        link: function postLink(scope, element, attrs) {
          attrs.$observe('onlineSrc', function(newVal, oldVal){
           if(newVal != undefined){
             var img = new Image();
             var imageSrc = attrs.onlineSrc;
             var cachedUrl;

             if($rootScope.image_cache != null && $rootScope.image_cache != undefined) {
              cachedUrl = $rootScope.image_cache.get(imageSrc);
             }

             if(imageSrc == cachedUrl || cachedUrl == null || cachedUrl == undefined) {
              img.src = imageSrc;
              angular.element(img).bind('load', function () {
                element.attr("src", imageSrc);
              });
             } else {
              element.attr("src", cachedUrl);
             }
           }
         });
        }
      }
    }
);
