/// <reference path="jquery.d.ts" />
/// <reference path="FileSystem.d.ts" />
/// <reference path="FileTransfer.d.ts" />
// TO-Do: Nach einer Möglichkeiten gucken wie man Konstanten hier einbezieht und warum ich die Key-Getter Methoden nicht verwenden kann
var StorageManager = (function () {
    function StorageManager() {
        this.keyPrefix = "";
    }
    StorageManager.prototype.setPrefix = function (keyPrefix) {
        this.keyPrefix = keyPrefix + "_";
    };
    StorageManager.prototype.getPrefix = function () {
        return this.keyPrefix;
    };
    StorageManager.prototype.get = function (key, defaultValue, onDefaultValue) {
        var defaultObj;
        if (typeof onDefaultValue === "function") {
            defaultObj = onDefaultValue(defaultValue);
        }
        else {
            defaultObj = defaultValue;
        }
        return localStorage[this.keyPrefix + key] || defaultObj;
    };
    StorageManager.prototype.save = function (key, value) {
        try {
            localStorage.setItem(this.keyPrefix + key, value);
        }
        catch (e) {
            console.log(e);
        }
    };
    StorageManager.prototype.remove = function (key) {
        localStorage.removeItem(this.keyPrefix + key);
    };
    StorageManager.prototype.exist = function (key) {
        return (localStorage.getItem(key) != null);
    };
    StorageManager.prototype.notExist = function (key) {
        return !this.exist(key);
    };
    return StorageManager;
}());
var JsonHelper = (function () {
    function JsonHelper() {
    }
    JsonHelper.prototype.add = function (jsonArray) {
        var tmp = {};
        for (var i in jsonArray)
            tmp[i] = jsonArray[i];
        return tmp;
    };
    return JsonHelper;
}());
var SDK = (function () {
    function SDK(serverURL, userID, clientID, xAuthToken, apiVersion) {
        $.support.cors = true;
        this.storageManager = new StorageManager();
        this.jsonHelper = new JsonHelper();
        this.printAlwaysDebugInformation = false;
        this.asynchronity = true;
        this.appVersion = 1.0;
    }
    SDK.prototype.setPrefix = function (keyPrefix) {
        this.storageManager.setPrefix(keyPrefix);
    };
    SDK.prototype.getPrefix = function () {
        return this.storageManager.getPrefix();
    };
    SDK.prototype.enableDebugInformation = function (option) {
        this.printAlwaysDebugInformation = option;
    };
    SDK.prototype.getStorageManager = function () {
        return this.storageManager;
    };
    SDK.prototype.getJsonHelper = function () {
        return this.jsonHelper;
    };
    SDK.prototype.setServerURL = function (serverURL) {
        this.storageManager.save("serverURL", serverURL);
        this.serverURL = serverURL;
    };
    SDK.prototype.getServerURL = function () {
        var url = this.storageManager.get("serverURL", null, null);
        if (!url)
            url = this.serverURL;
        return url;
    };
    SDK.prototype.setUploadFileKey = function (uploadFileKey) {
        this.storageManager.save("uploadFileKey", uploadFileKey);
        this.uploadFileKey = uploadFileKey;
    };
    SDK.prototype.getUploadFileKey = function () {
        var url = this.storageManager.get("uploadFileKey", null, null);
        if (!url)
            url = this.uploadFileKey;
        return url;
    };
    SDK.prototype.setUploadURL = function (uploadURL) {
        this.storageManager.save("uploadURL", this.getServerURL() + uploadURL);
        this.uploadURL = this.getServerURL() + uploadURL;
    };
    SDK.prototype.getUploadURL = function () {
      var url = this.storageManager.get("uploadURL", null, null);
        if (!url)
            url = this.uploadURL;
        return url;
    };
    SDK.prototype.setUserID = function (userID) {
        this.storageManager.save("userID", userID);
    };
    SDK.prototype.getUserID = function () {
        return this.storageManager.get("userID", null, null);
    };
    SDK.prototype.setClientID = function (clientID) {
        this.storageManager.save("clientID", clientID);
    };
    SDK.prototype.getClientID = function () {
        return this.storageManager.get("clientID", null, null);
    };
    SDK.prototype.setxAuthToken = function (xAuthToken) {
        this.storageManager.save("xAuthToken", xAuthToken);
    };
    SDK.prototype.getxAuthToken = function () {
        return this.storageManager.get("xAuthToken", null, null);
    };
    SDK.prototype.setApiVersion = function (apiVersion) {
        this.storageManager.save("apiVersion", apiVersion);
    };
    SDK.prototype.getApiVersion = function () {
        return this.storageManager.get("apiVersion", null, null);
    };
    SDK.prototype.setLanguageID = function (serverURL) {
        this.storageManager.save("languageID", serverURL);
    };
    SDK.prototype.getLanguageID = function () {
        return this.storageManager.get("languageID", null, null);
    };
    SDK.prototype.setLanguageKey = function (serverURL) {
        this.storageManager.save("languageKey", serverURL);
    };
    SDK.prototype.getLanguageKey = function () {
        return this.storageManager.get("languageKey", null, null);
    };
    SDK.prototype.setRequestID = function () {
        this.storageManager.save("apiRequestID", this.randomString(40));
    };
    SDK.prototype.getRequestID = function () {
        return this.storageManager.get("apiRequestID", null, null);
    };
    SDK.prototype.setGoogleMapsApiKey = function (googleMapsApiKey) {
        this.storageManager.save("googleMapsApiKey", googleMapsApiKey);
    };
    SDK.prototype.getGoogleMapsApiKey = function () {
        return this.storageManager.get("googleMapsApiKey", null, null);
    };
    SDK.prototype.setUnitSystemID = function (unitSystemID) {
        this.storageManager.save("unitSystemID", unitSystemID);
    };
    SDK.prototype.getUnitSystemID = function () {
        return this.storageManager.get("unitSystemID", null, null);
    };
    SDK.prototype.setObjectID = function (objectID) {
        this.storageManager.save("objectID", objectID);
    };
    SDK.prototype.getObjectID = function () {
        return this.storageManager.get("objectID", null, null);
    };
    SDK.prototype.setPushNotificationToken = function (pushNotificationToken) {
        this.storageManager.save("pushNotificationToken", pushNotificationToken);
    };
    SDK.prototype.getPushNotificationToken = function () {
        return this.storageManager.get("pushNotificationToken", null, null);
    };
    SDK.prototype.setPushNotificationPlatform = function (pushNotificationPlatform) {
        this.storageManager.save("pushNotificationPlatform", pushNotificationPlatform);
    };
    SDK.prototype.getPushNotificationPlatform = function () {
        return this.storageManager.get("pushNotificationPlatform", null, null);
    };
    SDK.prototype.setOwnProfileImage = function (imgUrl) {
        this.storageManager.save("ownProfileImage", imgUrl);
    };
    SDK.prototype.getOwnProfileImage = function () {
        return this.storageManager.get("ownProfileImage", null, null);
    };
    SDK.prototype.setAppVersion = function (appVersion) {
        this.appVersion = appVersion;
    };
    SDK.prototype.logout = function () {
        this.storageManager.remove("userID");
        this.storageManager.remove("clientID");
        this.storageManager.remove("xAuthToken");
        this.storageManager.remove("apiVersion");
        this.storageManager.remove("apiRequestID");
        this.storageManager.remove("pushNotificationToken");
        this.storageManager.remove("pushNotificationPlatform");
        this.storageManager.remove("ownProfileImage");
        this.storageManager.remove("unitSystemID");
        this.storageManager.remove("languageKey");
        this.storageManager.remove("languageID");
    };
    SDK.prototype.isNotLoggedIn = function () {
        return this.getxAuthToken() == null || this.getxAuthToken() == undefined;
    };
    SDK.prototype.isLoggedIn = function () {
        return !this.isNotLoggedIn();
    };
    SDK.prototype.loginCheck = function (onLoggedIn, onLoggedOff) {
        if (this.isLoggedIn()) {
            onLoggedIn();
        }
        else {
            onLoggedOff();
        }
    };
    SDK.prototype.debug = function (params, response, route, type) {
        // Farben passe ich noch an
        var template = 'background: #222;color: #bada55;';
        switch (type) {
            case "request":
                template = 'background: #222;color: #bada55;';
                break;
            case "upload":
                template = 'background: #222;color: #bada55;';
                break;
            default:
                template = 'background: #222;color: #bada55;';
        }
        console.log("");
        console.log('%c ' + route, template + 'font-weight: bold;padding: 5px;');
        console.log("Params: ");
        console.log(params);
        console.log("Response: ");
        console.log(response);
        console.log('%c ' + route, template + 'font-weight: bold;padding: 5px;');
        console.log("");
    };
    SDK.prototype.modRewriteIsDisabledOnServer = function () {
        this.setServerURL(this.getServerURL() + '/index.php');
    };
    SDK.prototype.randomString = function (length) {
        var text = "";
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < length; i++)
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        return text;
    };
    SDK.prototype.randomClientID = function () {
        return this.randomString(45);
    };
    SDK.prototype.data = function (response) {
        return response.data;
    };
    SDK.prototype.first = function (response) {
        return response.data[0];
    };
    SDK.prototype.iterator = function (responseData, callback) {
        this.data(responseData).forEach(callback);
    };
    SDK.prototype.hasNextPageURL = function (responseData, onNextPageURL, onLastPageURL) {
        var nextPageURL = responseData.next_page_url;
        if (nextPageURL === null) {
            onLastPageURL();
        }
        else {
            onNextPageURL(nextPageURL);
        }
    };
    SDK.prototype.withoutServerURL = function (fullApiURL) {
        return fullApiURL.replace(this.getServerURL(), "");
    };
    SDK.prototype.getRequestHeader = function () {
        return {
            'User-ID': this.getUserID(),
            'Client-ID': this.getClientID(),
            'Api-Request-ID': this.getRequestID(),
            'X-Auth-Token': this.getxAuthToken(),
            'Language-ID': this.getLanguageID(),
            'Api-Version': this.getApiVersion(),
            'Unit-System-ID': this.getUnitSystemID(),
            'Object-ID': this.getObjectID(),
            'App-Version': this.appVersion
        };
    };
    SDK.prototype.upload = function (mediaTypeID, fileURL, onProgress, onSuccess, onFail) {
        var SDK = this;
        var uri = encodeURI(this.getUploadURL() + "?media_type_id=" + mediaTypeID);
        var options = new FileUploadOptions();
        options.fileKey = this.getUploadFileKey();
        options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";
        options.headers = this.getRequestHeader();
        var ft = new FileTransfer();
        ft.onprogress = function (progressEvent) {
            if (progressEvent.lengthComputable) {
                var currentStatus = progressEvent.loaded / progressEvent.total * 100;
                if (typeof onProgress === "function")
                    onProgress(currentStatus);
            }
            else {
                // $('.pie_progress').asPieProgress('go','99%');
            }
        };
        ft.upload(fileURL, uri, function (response) {
            if (typeof onSuccess === "function")
                onSuccess(response);
        }, function (error) {
            if (typeof onFail === "function")
                onFail(error);
        }, options);
    };
    SDK.prototype.uploadViaDownloarUrl = function (mediaTypeID, downloadUrl, requestCallbacks) {
        this.request("POST", "/upload", {
            media_type_id: mediaTypeID,
            download_url: downloadUrl
        }, requestCallbacks);
    };
    SDK.prototype.disableAsynchronity = function () {
        this.asynchronity = false;
    };
    SDK.prototype.enableAsynchronity = function () {
        this.asynchronity = true;
    };
    SDK.prototype.onTokenInvalid = function (callback) {
        this.onTokenInvalidCallback = callback;
    };
    SDK.prototype.onAjaxError = function (callback, excludeRoutes) {
        this.onAjaxErrorCallback = callback;
        this.onAjaxErrorCallbackExcludeRouteList = excludeRoutes;
    };
    SDK.prototype.onValidatorPutOrPost = function (callback) {
        this.onValidatorPutOrPostCallback = callback;
    };
    SDK.prototype.onTimeout = function (callback) {
        this.onTimeoutCallback = callback;
    };
    SDK.prototype.onWartungsmodus = function (callback) {
        this.onWartungsmodusCallback = callback;
    };
    SDK.prototype.onAppVersionTooOld = function (callback) {
        this.onAppVersionTooOldCallback = callback;
    };
    SDK.prototype.onAcceptNewTerms = function (callback) {
        this.onAcceptNewTermsCallback = callback;
    };
    SDK.prototype.request = function (requestMethod, route, params, userCallbackOptions) {
        var callbackOptions = {
            onSuccessAck: null,
            onFailAck: null,
            onValidator: null,
            onPlainMsg: null,
            onDebug: null,
            onError: null,
            onAlways: null,
            onBeforeRequest: null,
            onAfterRequest: null,
            onTimeout: null
        };
        if (userCallbackOptions)
            callbackOptions = userCallbackOptions;
        var SDK = this;
        var headerData = this.getRequestHeader();
        if (typeof callbackOptions.onBeforeRequest === "function")
            callbackOptions.onBeforeRequest(headerData);
        var response = $.ajax({
            url: SDK.getServerURL() + route,
            dataType: "json",
            crossDomain: true,
            async: SDK.asynchronity,
            timeout: 20000,
            headers: headerData,
            method: requestMethod,
            data: params,
            success: function (data, textStatus, jqXHR) {
                if ((data.code == 180 || data.code == 181 || data.code == 14 || data.code == 15) && typeof SDK.onTokenInvalidCallback === "function")
                    SDK.onTokenInvalidCallback();
                if (data.code == 999 && typeof SDK.onWartungsmodusCallback === "function")
                    SDK.onWartungsmodusCallback();
                if (data.code == 998 && typeof SDK.onAppVersionTooOldCallback === "function")
                    SDK.onAppVersionTooOldCallback();
                if (data.code == 997 && typeof SDK.onAcceptNewTermsCallback === "function")
                    SDK.onAcceptNewTermsCallback(data);
                if (typeof callbackOptions.onAlways === "function")
                    callbackOptions.onAlways(data);
                var debugInfo = requestMethod + "-> " + route;
                var ack = data.ack;
                if (typeof ack != 'undefined') {
                    if (ack == "success") {
                        //if (data.hasOwnProperty('msg')) {
                        //    SDK.debug(debugInfo + " onPlainMsg@success", "request");
                        //    if(typeof callbackOptions.onPlainMsg === "function") callbackOptions.onPlainMsg(msg);
                        //} else {
                        if (SDK.printAlwaysDebugInformation)
                            SDK.debug(params, data, debugInfo, "request");
                        if (typeof callbackOptions.onSuccessAck === "function")
                            callbackOptions.onSuccessAck(data.data);
                        //}
                    }
                    else if (ack == "failure") {
                        /*if(data.hasOwnProperty('debug')) {
                            SDK.debug(debugInfo + " onDebug", "request");
                            if(SDK.printAlwaysDebugInformation) console.log(data.debug);
                            if(typeof callbackOptions.onDebug === "function") callbackOptions.onDebug(data.debug);
                        } else */
                        if (data.hasOwnProperty('msg') && data.msg.hasOwnProperty('validator')) {
                            if (SDK.printAlwaysDebugInformation)
                                SDK.debug(params, data, debugInfo, "request");
                            if (typeof callbackOptions.onValidator === "function")
                                callbackOptions.onValidator(data.msg.validator);
                            else if (typeof SDK.onValidatorPutOrPostCallback === "function" && (requestMethod == "POST" || requestMethod == "PUT")) {
                                SDK.onValidatorPutOrPostCallback(data.msg.validator);
                            }
                        }
                        else {
                            if (SDK.printAlwaysDebugInformation)
                                SDK.debug(params, data, debugInfo, "request");
                            if (typeof callbackOptions.onFailAck === "function")
                                callbackOptions.onFailAck(data);
                        }
                        /*

                            } else if (typeof msg == "string") {
                                SDK.debug(debugInfo + " onPlainMsg@failure", "request");
                                if(typeof callbackOptions.onPlainMsg === "function") callbackOptions.onPlainMsg(msg);
                            } else {
                                SDK.debug(debugInfo + " onError@failure", "request");
                                if(typeof callbackOptions.onError === "function") callbackOptions.onError("Unbekannter JSON-Wert");
                            }

                        } else {
                            SDK.debug(debugInfo + " onFailAck", "request");
                            if(typeof callbackOptions.onFailAck === "function") callbackOptions.onFailAck(data);
                        } */
                    }
                    else {
                        if (SDK.printAlwaysDebugInformation)
                            SDK.debug(params, data, debugInfo, "request");
                        if (typeof callbackOptions.onError === "function")
                            callbackOptions.onError("Unbekannter ACK-Wert");
                    }
                }
            },
            error: function (qXHR, textStatus, errorThrown) {
                //console.log("ajax error: "+textStatus);
                var debugInfo = requestMethod + "-> " + route;
                SDK.debug(params, textStatus, debugInfo, "request");
                
                if (textStatus == "timeout") {
                    if (typeof callbackOptions.onTimeout === "function")
                        callbackOptions.onTimeout();
                    else if (typeof SDK.onTimeoutCallback === "function")
                        SDK.onTimeoutCallback();
                } else if (typeof callbackOptions.onError === "function")
                    callbackOptions.onError(errorThrown);
                else if (typeof SDK.onAjaxErrorCallback === "function") {
                    if (!(SDK.onAjaxErrorCallbackExcludeRouteList.indexOf(route) > -1))
                        SDK.onAjaxErrorCallback();
                }
            },
            complete: function (jqXHR, textStatus) {
                if (typeof callbackOptions.onAfterRequest === "function")
                    callbackOptions.onAfterRequest();
            }
        });
    };
    return SDK;
}());
