angular.module('delete_account.service', [])
.factory('$_delete_account', function($_sdk, $_profile_cache, $_helper, $filter, $_notification, $log) {
  function deleteDeviceIdAccount(reason_id) {
    return new Promise(function(resolve, reject){
        var deleteUserCallback = {
            onSuccessAck: function(successData) {
                resolve(successData);
            },
            onFailAck: function(failData) {
                $log.debug(failData);
                var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                var type = $_notification.getNotificationTypes().ERROR;

                reject($_helper.getObjForNotification(msg, type));
            },
            onValidator: function(validateData) {
                $log.debug(validateData);
                var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                var type = $_notification.getNotificationTypes().ERROR;

                reject($_helper.getObjForNotification(msg, type));
            }
        };

        var params = {
            user_delete_types_id: reason_id
        }

        $_sdk.request("DELETE", "/user", params, deleteUserCallback);
    });
  }

  function deleteMailAccount(reason_id, password) {
    return new Promise(function(resolve, reject){
        var deleteUserCallback = {
            onSuccessAck: function(successData) {
                resolve(successData);
            },
            onFailAck: function(failData) {
                $log.debug(failData);

                // code 5 == falsche login daten
                if(failData.code == 5) {
                    var msg = $filter('translate')('OLD_PASSWORD_INCORRECT');
                    var type = $_notification.getNotificationTypes().ERROR;
                } else {
                    var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                    var type = $_notification.getNotificationTypes().ERROR;
                }
                

                reject($_helper.getObjForNotification(msg, type));
            },
            onValidator: function(validateData) {
                $log.debug(validateData);
                var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                var type = $_notification.getNotificationTypes().ERROR;

                reject($_helper.getObjForNotification(msg, type));
            }
        };

        var params = {
            user_delete_types_id: reason_id,
            password: password
        }

        $_sdk.request("DELETE", "/user", params, deleteUserCallback);
    });
  }

  function deleteFacebookAccount(reason_id, platform, platform_id, platform_token) {
    return new Promise(function(resolve, reject){
        var deleteUserCallback = {
            onSuccessAck: function(successData) {
                resolve(successData);
            },
            onFailAck: function(failData) {
                $log.debug(failData);
                var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                var type = $_notification.getNotificationTypes().ERROR;

                reject($_helper.getObjForNotification(msg, type));
            },
            onValidator: function(validateData) {
                $log.debug(validateData);
                var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                var type = $_notification.getNotificationTypes().ERROR;

                reject($_helper.getObjForNotification(msg, type));
            }
        };

        var params = {
            user_delete_types_id: reason_id,
            platform: platform,
            platform_id: platform_id,
            platform_token: platform_token
        }

        $_sdk.request("DELETE", "/user", params, deleteUserCallback);
    });
  }
    return {
        deleteDeviceIdAccount: function(reason_id) {
          return deleteDeviceIdAccount(reason_id);
        },
        deleteMailAccount: function(reason_id, password) {
          return deleteMailAccount(reason_id, password);
        },
        deleteFacebookAccount: function(reason_id, platform, platform_id, platform_token) {
          return deleteFacebookAccount(reason_id, platform, platform_id, platform_token);
        }
    }
});
