angular.module('login.service', [])
.factory('$_login', function($_sdk, $_location, $_notification, $_helper, $_cache_helper, $timeout, $state/*, $ionicPush*/, $_social_account, $filter, $_account_cache, $ionicScrollDelegate, $log,$_nativestorage) {

	/*
	Registriert dieses Gerät beim Push-Service von Ionic.
	Der Token, der von dem Service zurückkomt wird in der Datenbank gespeichert.
	*/

	function registerIonicPush(i) {

		i = (typeof i === 'undefined') ? 1 : i;
		$log.debug("register"+i);

		$timeout(function() {
			FCMPlugin.getToken(function(token){
			    $log.debug("token");
			    $log.debug(token);

			    if(token == null || token == undefined || token == "") {
			    	i++;
			    	if(i<=5) registerIonicPush(i);
			    	return;
			    }

				var isIOS = ionic.Platform.isIOS();
				var isAndroid = ionic.Platform.isAndroid();

				if(isIOS) var type = "ios";
				else if(isAndroid) var type = "android";
				else return;

				$_sdk.setPushNotificationToken(token);
	            $_sdk.setPushNotificationPlatform(type);

	            var tokenCallback = {
	              onSuccessAck: function(successAckData) {
	                $log.debug(successAckData);
	              },
	              onFailAck: function(failAckData) {
	                $log.debug(failAckData);
	              }
	            };

	            $_sdk.request("POST", "/user/pushtoken", {"token":token, "platform":type}, tokenCallback);
			});
		}, 2000);
	}

	function deleteIonicPush(i) {

		i = (typeof i === 'undefined') ? 1 : i;
		$log.debug("deletePush"+i);

		$timeout(function() {
			FCMPlugin.getToken(function(token){
			    $log.debug("token");
			    $log.debug(token);

			    if(token == null || token == undefined || token == "") {
			    	i++;
			    	if(i<=5) deleteIonicPush(i);
			    	return;
			    }

				var isIOS = ionic.Platform.isIOS();
				var isAndroid = ionic.Platform.isAndroid();

				if(isIOS) var type = "ios";
				else if(isAndroid) var type = "android";
				else return;

	            var tokenCallback = {
	              onSuccessAck: function(successAckData) {
	                $log.debug(successAckData);
	              },
	              onFailAck: function(failAckData) {
	                $log.debug(failAckData);
	              }
	            };

	            $_sdk.request("DELETE", "/user/pushtoken", {"token":token, "platform":type}, tokenCallback);
			});
		}, 2000);
	}
	
	/*function registerIonicPushOLD() {
		$ionicPush.register({
			canRunActionsOnWake: true
      	}).then(function(t) {
            return $ionicPush.saveToken(t);
        }).then(function(t) {
        	$_sdk.setPushNotificationToken(t.token);
            $_sdk.setPushNotificationPlatform(t.type);

            var tokenCallback = {
              onSuccessAck: function(successAckData) {
                $log.debug(successAckData);
              },
              onFailAck: function(failAckData) {
                $log.debug(failAckData);
              }
            };

            $_sdk.request("POST", "/user/pushtoken", {"token":t.token, "platform":t.type}, tokenCallback);
        });
	}*/

	function unRegisterIonicPush() {
		return new Promise(function(resolve, reject) {

		    var deletePushTokenCallback = {
		      onSuccessAck: function(successData) {
		        $_helper.resetBadges();
		        resolve(successData);
		      },
		      onFailAck: function(failData) {
		        $log.debug(failData);
		        reject(failData);
		      },
		      onValidator: function(validateData) {
		        $log.debug(validateData);
		        reject(validateData);
		      }
		    };

		    if($_sdk.getPushNotificationToken() == null || $_sdk.getPushNotificationToken() == undefined || $_sdk.getPushNotificationPlatform() == null || $_sdk.getPushNotificationPlatform() == undefined) {
		    	resolve("success");
		    } else {
		    	$_sdk.request("DELETE", "/user/pushtoken", {"token": $_sdk.getPushNotificationToken(), "platform": $_sdk.getPushNotificationPlatform()}, deletePushTokenCallback);
		    }
		});
	}

	/*function unRegisterIonicPushOLD() {
		return new Promise(function(resolve, reject) {
			$ionicPush.unregister();

		    var deletePushTokenCallback = {
		      onSuccessAck: function(successData) {
		        $_helper.resetBadges();
		        resolve(successData);
		      },
		      onFailAck: function(failData) {
		        $log.debug(failData);
		        reject(failData);
		      },
		      onValidator: function(validateData) {
		        $log.debug(validateData);
		        reject(validateData);
		      }
		    };

		    if($_sdk.getPushNotificationToken() == null || $_sdk.getPushNotificationToken() == undefined || $_sdk.getPushNotificationPlatform() == null || $_sdk.getPushNotificationPlatform() == undefined) {
		    	resolve("success");
		    } else {
		    	$_sdk.request("DELETE", "/user/pushtoken", {"token": $_sdk.getPushNotificationToken(), "platform": $_sdk.getPushNotificationPlatform()}, deletePushTokenCallback);
		    }
		});
	}*/

	function loginMail(mail, password) {
		return new Promise(function(resolve, reject){
			var callbacks = {
				onSuccessAck: function(successData) {
					$_sdk.setUserID(successData.user_id);
					$_sdk.setxAuthToken(successData.token);
          $_nativestorage.setItem("userID",successData.user_id);
          $_nativestorage.setItem("xAuthToken",successData.token);
          $_nativestorage.setItem("lastEmail",mail);
          
					$_account_cache.setLoginStatus(true);
					$_account_cache.setShouldShowCreateAccountBox(false);

					var msg = $filter('translate')('LOGIN_SUCCESSFULL');
					var type = $_notification.getNotificationTypes().ERROR;
					registerIonicPush();
					resolve($_helper.getObjForNotification(msg, type));
				},
				onFailAck: function(failData) {
					var msg;
					var type;
					if(failData.code == 5) {
						msg = $filter('translate')('CHECK_YOUR_LOGIN_DATA');
						type = $_notification.getNotificationTypes().ERROR;
					} else if(failData.code == 274) {
						msg = "email_popup";
						type = $_notification.getNotificationTypes().ERROR;
					} else {
						msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
						type = $_notification.getNotificationTypes().ERROR;
					}

					reject($_helper.getObjForNotification(msg, type));
				},
				onValidator: function(validateData) {
					var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
					var type = $_notification.getNotificationTypes().VALIDATE;

					reject($_helper.getObjForNotification(msg, type));
				}
			}

			var param = {
				email: mail,
				password: password
			}

			$_sdk.request("POST", "/user/signin", param, callbacks);
		});
	}

	function logoutAPI() {
		return new Promise(function(resolve, reject) {

		    var logoutCallback = {
		      onSuccessAck: function(successData) {
		        resolve(successData);
		      },
		      onFailAck: function(failData) {
		        $log.debug(failData);
		        reject(failData);
		      },
		      onValidator: function(validateData) {
		        $log.debug(validateData);
		        reject(validateData);
		      }
		    };

			$_sdk.request("POST", "/user/logout", null, logoutCallback);
		    
		});
	}

	function logout(type) {
		unRegisterIonicPush().then(function(success){
			logoutAPI().then(function(success){
				$timeout(function(){
					$_cache_helper.clear();
					$timeout(function(){
						$ionicScrollDelegate.scrollTop();
						$state.go('start-screen');
					}, 250);
				}, 250);
			},
			function(error){});
		},
		function(error){});
	}

	return {
		login: function(device_id, hash) { // Standardlogin via device_id
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						$_sdk.setxAuthToken(successData.token);
            $_nativestorage.setItem("xAuthToken",successData.token);
						resolve(successData);
					},
					onFailAck: function(failData) {
						var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
						var type = $_notification.getNotificationTypes().ERROR;

						reject($_helper.getObjForNotification(msg, type));
					},
					onValidator: function(validateData) {
						var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
						var type = $_notification.getNotificationTypes().VALIDATE;

						reject($_helper.getObjForNotification(msg, type));
					}
				}

				var param = {
					device_id: device_id,
					login_hash: hash
				}

				$_sdk.request("POST", "/user/signin", param, callbacks);
			});
		},
		logout: function(type) { // type == login_type
			logout(type);
		},
		registerIonicPush: function() {
			registerIonicPush();
		},
		deleteIonicPush: function() {
			deleteIonicPush();
		},
		unRegisterIonicPush: function(){
			return unRegisterIonicPush();
		},
		loginMail: function(mail, password) {
			return loginMail(mail, password);
		},
		loginFacebook: function() {
			return $_social_account.loginFacebook();
		}
	}
});
