angular.module('points.service', [])
.factory('$_points', function($_sdk, $_helper, $filter, $_notification, $log) {


	return {
		getPointsList: function() {
			return new Promise(function(resolve, reject){
				var callbacks = {
						onSuccessAck: function(successData) {
							var data = successData.data;
							resolve(data);
						},
						onFailAck: function(failData) {
							var msg = $filter('translate')('REQUEST_FAILED');
							var type = $_notification.getNotificationTypes().ERROR;

							reject($_helper.getObjForNotification(msg, type));
						},
						onValidator: function(validateData) {
							var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
							var type = $_notification.getNotificationTypes().ERROR;

							reject($_helper.getObjForNotification(msg, type));
						}
				}


				$_sdk.request("GET", "/point/types", null, callbacks);
			});
		},
		getValueForType: function(type) {
			return new Promise(function(resolve, reject){
				var callbacks = {
						onSuccessAck: function(successData) {
							var data = successData.data;
							resolve(data);
						},
						onFailAck: function(failData) {
							var msg = $filter('translate')('REQUEST_FAILED');
							var type = $_notification.getNotificationTypes().ERROR;

							reject($_helper.getObjForNotification(msg, type));
						},
						onValidator: function(validateData) {
							var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
							var type = $_notification.getNotificationTypes().ERROR;

							reject($_helper.getObjForNotification(msg, type));
						}
				}


				$_sdk.request("GET", "/point/type/"+type, null, callbacks);
			});
		},
		changeQuestion: function(flirtRoundID) {
			return new Promise(function(resolve, reject){
				var callbacks = {
						onSuccessAck: function(successData) {
							var data = successData.data;
							resolve(data);
						},
						onFailAck: function(failData) {
							reject(failData);
						},
						onValidator: function(validateData) {
							reject(validateData);
						}
				}


				$_sdk.request("POST", "/changequestion/"+flirtRoundID, null, callbacks);
			});
		},
		reactivateFlirt: function(flirtID) {
			return new Promise(function(resolve, reject){
				var callbacks = {
						onSuccessAck: function(successData) {
							var data = successData.data;
							resolve(data);
						},
						onFailAck: function(failData) {
							reject(failData);
						},
						onValidator: function(validateData) {
							reject(validateData);
						}
				}


				$_sdk.request("POST", "/reactivateflirt/"+flirtID, null, callbacks);
			});
		}
	};
});
