angular.module('profile.service', [])
.factory('$_profile', function($_sdk, $_profile_cache, $_helper, $filter, $_notification, $_image_cache) {
    return {
        getProfile: function(usr_id) {
            return new Promise(function(resolve, reject){
                var callbacks = {
                    onSuccessAck: function(successData) {
                        var data = successData.data[0];
                        var age = $_helper.getAge(data.birthdate);
                        var profile_img = $_helper.getMediumImg(data.profile_images);
                        var is_verified = $_helper.isFalseOrTrue(data.media_verification);
                        var profile = {
                            name: data.name,
                            age: age,
                            city: data.city,
                            hashtag1: data.hashtag1,
                            hashtag2: data.hashtag2,
                            hashtag3: data.hashtag3,
                            profile_img: profile_img,
                            distance: data.distance,
                            is_verified: is_verified
                        };
                        $_profile_cache.saveProfile(profile, usr_id);
                        $_image_cache.cacheAllImages();
                        resolve(profile);
                    },
                    onFailAck: function(failData) {
                        if(failData.code == 148) {
                            $_profile_cache.removeProfile(usr_id)
                        }

                        var msg = $filter('translate')('REQUEST_FAILED');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
                }

                $_sdk.request("GET", "/user/" + usr_id, null, callbacks);
            });
        }
    }
});
