angular.module('registrate.service', [])
.factory('$_registrate', function($_sdk, $_account_cache, $_notification, $_helper, $_tos, $filter, $_language, $_nativestorage) {
	return {
		registrate: function(data) {
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						$_account_cache.saveAccountId(successData.user_id);
						$_sdk.setClientID(data.device_id);
						$_sdk.setUserID(successData.user_id);
            $_nativestorage.setItem("userID",successData.user_id);
        
						$_language.setCacheLanguage();
						resolve(successData);
					},
					onFailAck: function(failData) {
						var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
						var type = $_notification.getNotificationTypes().ERROR;

						reject($_helper.getObjForNotification(msg, type));
					},
					onValidator: function(validateData) {
						var msg = $filter('translate')('SOMETHING_IS_MISSING');
						var type = $_notification.getNotificationTypes().ERROR;

						reject($_helper.getObjForNotification(msg, type));
					}
				};

				
				//var getPrivacyPolicy;
				var tos1;
				var tos2;

				$_tos.getTos().then(
					function(tos){
						tos1 = tos.terms_of_service_id;

						$_tos.getPrivacyPolicy().then(
							function(privay_policy){
								tos2 = privay_policy.terms_of_service_id;
								data.birthdate = moment(data.birthdate).format('YYYY-MM-DD');
								
								var params = {
									device_id: data.device_id,
									name: data.name,
									birthdate: data.birthdate,
									city: data.city,
									hashtag1: data.hashtag1,
									hashtag2: data.hashtag2,
									hashtag3: data.hashtag3,
									gender: data.gender,
									looking_for_gender: data.looking_for_gender,
									login_hash: data.hash,
									tos1_version: tos1,
									tos2_version: tos2
								}
								$_sdk.request("POST", "/user/register", params, callbacks);
							},
							function(error){
								var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
								var type = $_notification.getNotificationTypes().ERROR;

								reject($_helper.getObjForNotification(msg, type));
							}
						);
					},
					function(error){
						var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
						var type = $_notification.getNotificationTypes().ERROR;

						reject($_helper.getObjForNotification(msg, type));
					}
				)
			});
		}
	}
});
