angular.module('verify_account.service', [])
.factory('$_verify_account', function($_sdk, $_helper, $_notification, $filter, $_account_cache, $log) {

    /* Holt die Daten für die Verifizierung des Profilbilds.  */
    function getVerificationData(media_id) {
        return new Promise(function(resolve, reject){
            var callbacks = {
                onSuccessAck: function(successData) {
                    $log.debug(successData);

                    var verificationObj = {
                        code: successData.code,
                        media_verification_id: successData.media_verification_id,
                        verification_status: successData.verification_status
                    }

                    $_account_cache.setMediaVerificationObj(media_id, verificationObj);

                    resolve(verificationObj);
                },
                onFailAck: function(failData) {
                    $log.debug(failData);

                    if(failData.code == 205) {
                        var msg = $filter('translate')('PLEASE_UPLOAD_AN_IMAGE_FIRST');
                        var type = $_notification.getNotificationTypes().ERROR;
                    } else {
                        var msg = $filter('translate')('COULD_NOT_GET_DATA_TRY_AGAIN');
                        var type = $_notification.getNotificationTypes().ERROR;
                    }
                    

                    var notificationObj = $_helper.getObjForNotification(msg, type);

                    notificationObj.code = failData.code;

                    reject(notificationObj);
                },
                onValidator: function(validateData) {
                    $log.debug(validateData);

                    var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
                    var type = $_notification.getNotificationTypes().ERROR;

                    reject($_helper.getObjForNotification(msg, type));
                }
            }

            var params = {
                object_has_media_id: media_id
            };

            $_sdk.request("GET", "/media/verify", params, callbacks);
        })
    }

    return {
        getVerificationData: function(media_id) {
            return getVerificationData(media_id);
        }
    }
});
