angular.module('account_cache.service', [])
.factory('$_account_cache', function(CacheFactory, CACHE_ROUTE) {
	if (!CacheFactory.get(CACHE_ROUTE().ACCOUNT_CACHE)) {
		CacheFactory.createCache(CACHE_ROUTE().ACCOUNT_CACHE, {
			storageMode: 'localStorage'
		});
	}

	var accountCache = CacheFactory.get(CACHE_ROUTE().ACCOUNT_CACHE);

	return {
		saveAccountData: function(obj) {
			accountCache.put(CACHE_ROUTE().ACCOUNT, obj);
		},
		getAccountData: function() {
			return accountCache.get(CACHE_ROUTE().ACCOUNT);
		},
		saveAccountId: function(id) {
			accountCache.put(CACHE_ROUTE().ACCOUNT_ID, id);
		},
		getAccountId: function() {
			return accountCache.get(CACHE_ROUTE().ACCOUNT_ID);
		},
		saveAccountImage: function(src) {
			accountCache.put(CACHE_ROUTE().ACCOUNT_IMAGE, src);
		},
		getAccountImage: function() {
			var img = accountCache.get(CACHE_ROUTE().ACCOUNT_IMAGE);

			if(img == null || img == undefined)
				return null
			else
				return img;
		},
		saveLoginEmail: function(obj) {
			accountCache.put(CACHE_ROUTE().LOGIN_EMAIL, obj);
		},
		getLoginEmail: function() {
			return accountCache.get(CACHE_ROUTE().LOGIN_EMAIL);
		},
		saveBase64Image: function(base64String) {
			accountCache.put(CACHE_ROUTE().BASE64_ACCOUNT_IMAGE, base64String);
		},
		getBase64Image: function() {
			return accountCache.get(CACHE_ROUTE().BASE64_ACCOUNT_IMAGE);
		},
		saveOldAccountImageId: function(id) {
			accountCache.put(CACHE_ROUTE().OLD_ACCOUNT_IMAGE_ID, id);
		},
		getOldAccountImageId: function() {
			return accountCache.get(CACHE_ROUTE().OLD_ACCOUNT_IMAGE_ID);
		},
		saveOldAccountImageIdBeforeUpload: function(id) {
			accountCache.put(CACHE_ROUTE().OLD_ACCOUNT_IMAGE_ID_BEFORE_UPLOAD, id);
		},
		getOldAccountImageIdBeforeUpload: function() {
			return accountCache.get(CACHE_ROUTE().OLD_ACCOUNT_IMAGE_ID_BEFORE_UPLOAD);
		},
		shouldShowPopup: function() { // Speichert & zeigt die Variable für die AGB Popups beim Registrieren
			return accountCache.get(CACHE_ROUTE().SHOW_PP_POPUP);
		},
		saveShouldShowPopup: function(bool) {
			accountCache.put(CACHE_ROUTE().SHOW_PP_POPUP, bool);
		},
		setLoginStatus: function(bool) {
			if(bool == null || bool == undefined) {
				bool = true;
			}

			accountCache.put(CACHE_ROUTE().LOGIN_STATUS, bool);
		},
		isLoggedIn: function() {
			return accountCache.get(CACHE_ROUTE().LOGIN_STATUS);
		},
		setOffline: function(bool) {
			accountCache.put(CACHE_ROUTE().IS_OFFLINE, bool);
		},
		isOffline: function() {
			return accountCache.get(CACHE_ROUTE().IS_OFFLINE);
		},
		setShouldShowCreateAccountBox: function(bool) { // Speichert ob die "Account erstellen" Box oben angezeigt werden soll oder nicht
			accountCache.put(CACHE_ROUTE().SHOW_CREATE_ACCOUNT_BOX, bool);
		},
		getShouldShowCreateAccountBox: function() {
			var show = accountCache.get(CACHE_ROUTE().SHOW_CREATE_ACCOUNT_BOX);
			if(show == null || show == undefined) {
				return true;
			} else {
				return show;
			}
		},
		setMediaVerificationObj: function(media_id, obj) {
			accountCache.put(CACHE_ROUTE().MEDIA_VERIFICATION_CODE, obj);
		},
		getMediaVerificationObj: function(media_id) {
			return accountCache.get(CACHE_ROUTE().MEDIA_VERIFICATION_CODE);
		},
		setVerificationImageAsCheck: function() {
			var accountObj = this.getAccountData().verification_status = 'check';
			this.saveAccountData(accountObj);
		},
		setUserHasProfileImage: function(bool) {
			accountCache.put(CACHE_ROUTE().USER_HAS_PROFILE_IMAGE, bool);
		},
		getUserHasProfileImage: function() {
			var hasProfileImg = accountCache.get(CACHE_ROUTE().USER_HAS_PROFILE_IMAGE);

			if(hasProfileImg == null || hasProfileImg == undefined)
				return true;
			
			return hasProfileImg;
		},
		setSoundSetting: function(bool) {
			accountCache.put(CACHE_ROUTE().SOUND_SETTING, bool);
		},
		getSoundSetting: function() {
			var bool = accountCache.get(CACHE_ROUTE().SOUND_SETTING);

			if(bool == null || bool == undefined) return true;
			return bool;
		},
		setVibrationSetting: function(bool) {
			accountCache.put(CACHE_ROUTE().VIBRATION_SETTING, bool);
		},
		getVibrationSetting: function() {
			var bool = accountCache.get(CACHE_ROUTE().VIBRATION_SETTING);

			if(bool == null || bool == undefined) return true;
			return bool;
		},
		setUserHasRegistered: function(bool) {
			accountCache.put(CACHE_ROUTE().USER_HAS_REGISTERED, bool);
		},
		getUserHasRegistered: function() {
			var bool = accountCache.get(CACHE_ROUTE().USER_HAS_REGISTERED);

			if(bool == null || bool == undefined) return false;
			return bool;
		},
		setAppWasClosed: function(bool) {
			accountCache.put(CACHE_ROUTE().APP_WAS_CLOSED, bool);
		},
		getAppWasClosed: function() {
			var bool = accountCache.get(CACHE_ROUTE().APP_WAS_CLOSED);

			if(bool == null || bool == undefined) return false;
			return bool;
		}
	}
});
