angular.module('blocked_users_cache.service', [])
.factory('$_blocked_users_cache', function(CacheFactory, CACHE_ROUTE, $_cache_helper) {
	if (!CacheFactory.get(CACHE_ROUTE().BLOCKED_USERS_CACHE)) {
		CacheFactory.createCache(CACHE_ROUTE().BLOCKED_USERS_CACHE, {
			storageMode: 'localStorage'
		});
	}

	var blockedUsersCache = CacheFactory.get(CACHE_ROUTE().BLOCKED_USERS_CACHE);

	return {
		saveBlockedUsers: function(obj) {
			blockedUsersCache.put(CACHE_ROUTE().BLOCKED, obj);
		},
		getBlockedUsers: function() {
			return blockedUsersCache.get(CACHE_ROUTE().BLOCKED);
		},
		removeBlockedUser: function(user_id) {
			var blockedUsers = this.getBlockedUsers();

			if(blockedUsers != null && blockedUsers != undefined) {
				for(var i=0; i<=blockedUsers.length-1; i++) {
					if(blockedUsers[i].user_id == user_id) {
						blockedUsers.splice(i, 1);
					}
				}

				this.saveBlockedUsers(blockedUsers);
			}
		}
	}
});