angular.module('cache_helper.service', [])
.factory('$_cache_helper', function(CacheFactory, $ionicHistory, $_sdk, $_image_cache, $timeout, $_nativestorage) {

	return {
		cacheExists: function(cache) { // Prüft ob der Cache mit dem key existiert. Keys definiert in cache_constants
			var cache_keys = CacheFactory.keys();
			if(cache_keys[cache] != null && cache_keys[cache] != undefined) {
				return true;
			} else {
				return false;
			}
		},
		clearCachedData: function() { // löscht nur gecachte Daten; User bleibt eingeloggt
			CacheFactory.clearAll();
			$_image_cache.clearImageCache();
		},
		clearUserData: function() { // User logout; gecachte Daten bleiben erhalten
			$_sdk.logout();
      $_nativestorage.remove("userID");
      $_nativestorage.remove("xAuthToken");
		},
		clear: function() { // Löscht alle Daten und loggt den User aus
			$_sdk.logout();
      $_nativestorage.remove("userID");
      $_nativestorage.remove("xAuthToken");
			$_sdk.setObjectID("");
			CacheFactory.clearAll();
			$ionicHistory.clearHistory();
			$_image_cache.clearImageCache();
			this.clearViewCache();
		},
		clearViewCache: function() {
			var viewsArr = ['tab.blury', 'tab.chats', 'tab.flirts', 'tab.account', 'login', 'registrate-step1', 'registrate-step2', 'registrate-step3', 'registrate-step4'];
			var tabs = ["blury", "chats", "flirts", "account", "registrate"];

			for (index = 0; index < tabs.length; index++) { // Erzeugt die Liste der Subviews
				var tabName = tabs[index];
				var tab_tabName = 'tab-' + tabName;

				viewsArr.push('tab.'+tabName+'-flirt-detail');
				viewsArr.push('tab.'+tabName+'-chat-detail');
				viewsArr.push('tab.'+tabName+'-profile');
				viewsArr.push('tab.'+tabName+'-flirt-detail-rate');
				viewsArr.push('tab.'+tabName+'-flirt-detail-answer');
				viewsArr.push('tab.'+tabName+'-flirt-detail-my-answer');
			}
			
			$ionicHistory.clearCache(viewsArr);
		},
		destroyCache: function() {
			CacheFactory.destroyAll();
			$_image_cache.clearImageCache();
		}
	}
});
