angular.module('chat_list_cache.service', [])
.factory('$_chat_list_cache', function(CacheFactory, CACHE_ROUTE, $filter) {
	if (!CacheFactory.get(CACHE_ROUTE().CHAT_LIST_CACHE)) {
		CacheFactory.createCache(CACHE_ROUTE().CHAT_LIST_CACHE, {
			maxAge: 120 * 60 * 60 * 1000,
			deleteOnExpire: 'aggressive',
			recycleFreq: 240 * 60 * 60 * 1000,
			storageMode: 'localStorage'
		});
	}

	var chatCache = CacheFactory.get(CACHE_ROUTE().CHAT_LIST_CACHE);

	return {
		saveChatList: function(obj) {
			chatCache.put(CACHE_ROUTE().CHAT_LIST, obj);
		},
		getChatList: function() {
			var chats = chatCache.get(CACHE_ROUTE().CHAT_LIST);
			return chats;
		},
		deleteElementFromList: function(chat_id) {
			var chat_list = chatCache.get(CACHE_ROUTE().CHAT_LIST);
			if(chat_list != null && chat_list != undefined) {
				for(var i=0; i<=chat_list.length-1; i++) {
					if(chat_list[i].match_id == chat_id) {
						chat_list.splice(i, 1);
					}
				}
				this.saveChatList(chat_list);
			}
		},
		updateLastMessage: function(chat_id, user_id, message) { // Synchronisiert die letzte Nachricht vom Chat mit der im Cache
			var chat_list = chatCache.get(CACHE_ROUTE().CHAT_LIST);
			if(chat_list != null && chat_list != undefined) {
				for(var i=0; i<=chat_list.length-1; i++) {
					if(chat_list[i].match_id == chat_id) {
						var chatObj = chat_list[i];

						chatObj.user_id = parseInt(user_id);
						chatObj.last_message_user_id = parseInt(user_id);
						chatObj.last_message_text = message;
						chatObj.last_message_sent = $filter('date')(new Date(), 'dd.MM.yy');
						chatObj.last_message_sent_order = $filter('date')(new Date(), 'yyyy-MM-dd HH:mm:ss');
						chat_list[i] = chatObj;
					}
				}
				this.saveChatList(chat_list);
			}
		}
	}
});