angular.module('flirt_answer_cache.service', [])
.factory('$_flirt_answer_cache', function(CacheFactory, CACHE_ROUTE, $_cache_helper) {
	if (!CacheFactory.get(CACHE_ROUTE().FLIRT_ANSWER_CACHE)) {
		CacheFactory.createCache(CACHE_ROUTE().FLIRT_ANSWER_CACHE, {
			storageMode: 'localStorage',
			maxAge: 120 * 60 * 60 * 1000,
			deleteOnExpire: 'aggressive',
			recycleFreq: 121 * 60 * 60 * 1000,
		});
	}

	var flirt_answer_cache = CacheFactory.get(CACHE_ROUTE().FLIRT_ANSWER_CACHE);

	return {
		saveFlirtAnswer: function(flirtId, flirtRoundId, msg) { // Speichert die Antwort in einem Flirt mit bestimmter Runde
			flirt_answer_cache.put(CACHE_ROUTE().UNSEND_FLIRT_ANSWERS + '' + flirtId + '/' + flirtRoundId, msg);
		},
		getFlirtAnswer: function(flirtId, flirtRoundId) {
			return flirt_answer_cache.get(CACHE_ROUTE().UNSEND_FLIRT_ANSWERS + '' + flirtId + '/' + flirtRoundId);
		}
	}
});