angular.module('users_cache.service', [])
.factory('$_users_cache', function(CacheFactory, CACHE_ROUTE) {
	if (!CacheFactory.get(CACHE_ROUTE().USERS_CACHE)) {
		CacheFactory.createCache(CACHE_ROUTE().USERS_CACHE, {
			maxAge: 120 * 60 * 60 * 1000,
			deleteOnExpire: 'aggressive',
			recycleFreq: 240 * 60 * 60 * 1000,
			storageMode: 'localStorage'
		});
	}

	var bluryCache = CacheFactory.get(CACHE_ROUTE().USERS_CACHE);

	return {
		saveUsers: function(obj) {
			bluryCache.put(CACHE_ROUTE().USERS, obj);
		},
		getUsers: function() {
			var users = bluryCache.get(CACHE_ROUTE().USERS);
			return users;
		},
		deleteUser: function(usr_id) {
			var users = this.getUsers();
			for(var i=0; i<=users.length-1; i++) {
				if(users[i].user_id == usr_id) {
					users.splice(i, 1);
					this.saveUsers(users);
					break;
				}
			}
		}
	}
});