angular.module('flirt_answer.service', [])
.factory('$_flirt_answer', function($_sdk, $_flirt_detail_cache, $_helper, $filter, $_notification) {
	return {
		sendAnswer(roundId, answer, questionId) {
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						resolve("success");
					},
					onFailAck: function(failData) {
						if(failData.code == 142) {
							var msg = $filter('translate')('THIS_FLIRT_DOESNT_EXIST');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 141) {
							var msg = $filter('translate')('FLIRT_ROUND_EXPIRED');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 232 || failData.code == 160 || failData.code == 161) {
	                        var notificationObj = {
	                        	code: failData.code
	                        };

	                        reject(notificationObj);
						} else if(failData.code == 272) { // bereits geantwortet
	                        var msg = $filter('translate')('YOU_ALREADY_ANSWERED_THIS');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 279) { // Frage wurde geändert
	                        var msg = $filter('translate')('QUESTION_WAS_CHANGED');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else {
	                        var msg = $filter('translate')('ANSWERING_FAILED');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);

	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
                    	}
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
				}

				var params = {
					answer: answer,
					user_accept: "answered",
					question_id: questionId
				}

				$_sdk.request("PUT", "/flirt/" + roundId + "/round", params, callbacks);
			});
		}
	};
});
