angular.module('flirt_detail.service', [])
.factory('$_flirt_detail', function($_sdk, $_flirt_detail_cache, $_helper, $filter, $_notification, $_image_cache, $log) {

	function getFlirtDetailObj(data) {
		return new Promise(function(resolve, reject){
			var my_profile_image = $_helper.getSmallImg(data.me.profile_images);
			var other_profile_image = $_helper.getSmallImg(data.other_user.profile_images);
			var is_verified = $_helper.isFalseOrTrue(data.other_user.media_verification);

			var flirtObj = {};

			var meObj = {
				profile_image: my_profile_image
			}

			var otherUserObj = {
				name: data.other_user.name,
				age: data.other_user.age,
				gender: data.other_user.gender,
				hashtag1: data.other_user.hashtag1,
				hashtag2: data.other_user.hashtag2,
				hashtag3: data.other_user.hashtag3,
				profile_image: other_profile_image,
				user_id: data.other_user.user_id,
				distance: data.other_user.distance,
				is_verified: is_verified
			}

			var roundObj = [];
			if(data.rounds[0] != null && data.rounds[0] != undefined) {
				var round1 = {
					my_answer: data.rounds[0].my_answer,
					other_answer: data.rounds[0].other_answer,
					user1_accept: data.rounds[0].user1_accept,
					user2_accept: data.rounds[0].user2_accept,
					my_round_status: data.rounds[0].my_round_status,
					state: data.rounds[0].my_round_status,
					other_round_status: data.rounds[0].other_round_status,
					question: data.rounds[0].question,
					round_id: data.rounds[0].flirt_round_id,
					my_accept: data.rounds[0].my_accept,
					other_accept: data.rounds[0].other_accept,
					my_seen_time: data.rounds[0].my_seen_time,
					flirt_round_valid_until: data.rounds[0].flirt_round_valid_until,
					flirt_round_expired: data.rounds[0].flirt_round_expired,
					is_deleted_by_other_user: data.rounds[0].is_deleted_by_other_user,
					user_id: data.other_user.user_id
				}

				flirtObj.next_round = 1;
				roundObj.push(round1);
			}

			if(data.rounds[1] != null && data.rounds[1] != undefined) {
				var round2 = {
					my_answer: data.rounds[1].my_answer,
					other_answer: data.rounds[1].other_answer,
					user1_accept: data.rounds[1].user1_accept,
					user2_accept: data.rounds[1].user2_accept,
					my_round_status: data.rounds[1].my_round_status,
					state: data.rounds[1].my_round_status,
					other_round_status: data.rounds[1].other_round_status,
					question: data.rounds[1].question,
					round_id: data.rounds[1].flirt_round_id,
					my_accept: data.rounds[1].my_accept,
					other_accept: data.rounds[1].other_accept,
					my_seen_time: data.rounds[1].my_seen_time,
					flirt_round_valid_until: data.rounds[1].flirt_round_valid_until,
					flirt_round_expired: data.rounds[1].flirt_round_expired,
					is_deleted_by_other_user: data.rounds[1].is_deleted_by_other_user,
					user_id: data.other_user.user_id
				}

				flirtObj.next_round = 2;
				roundObj.push(round2);
			}

			if(data.rounds[2] != null && data.rounds[2] != undefined) {
				var round3 = {
					my_answer: data.rounds[2].my_answer,
					other_answer: data.rounds[2].other_answer,
					user1_accept: data.rounds[2].user1_accept,
					user2_accept: data.rounds[2].user2_accept,
					my_round_status: data.rounds[2].my_round_status,
					state: data.rounds[2].my_round_status,
					other_round_status: data.rounds[2].other_round_status,
					question: data.rounds[2].question,
					round_id: data.rounds[2].flirt_round_id,
					my_accept: data.rounds[2].my_accept,
					other_accept: data.rounds[2].other_accept,
					my_seen_time: data.rounds[2].my_seen_time,
					flirt_round_valid_until: data.rounds[2].flirt_round_valid_until,
					flirt_round_expired: data.rounds[2].flirt_round_expired,
					is_deleted_by_other_user: data.rounds[1].is_deleted_by_other_user,
					user_id: data.other_user.user_id
				}

				flirtObj.match_id = data.rounds[2].match_id;

				flirtObj.next_round = 3;
				roundObj.push(round3);
			}

			flirtObj.me = meObj;
			flirtObj.other_user = otherUserObj;
			flirtObj.rounds = roundObj;
			flirtObj.flirtId = data.rounds[0].flirt_id;

			$_flirt_detail_cache.saveFlirtRoundImage(flirtObj.flirtId, roundObj.length, other_profile_image); // Speichern um das letzte Foto beim Entblurren zur Verfügung zu haben

			flirtObj.round_img = $_flirt_detail_cache.getFlirtRoundImage(flirtObj.flirtId);

			$_image_cache.cacheAllImages();
			resolve(flirtObj);
		});
	}


	function getRoundDetailObj(data, roundId, ignoreExpired) {
		return new Promise(function(resolve, reject){
			if(data.rounds[0].current_flirt_round != roundId) {
				reject($filter('translate')('NOT_CURRENT_ROUND'));
			} else {
				var other_profile_image = $_helper.getSmallImg(data.other_user.profile_images);

				var actRound = 1;
				if(data.rounds[0] != null && data.rounds[0] != undefined && data.rounds[0].flirt_round_id == roundId) {
					actRound = 0;
				}

				if(data.rounds[1] != null && data.rounds[1] != undefined && data.rounds[1].flirt_round_id == roundId) {
					actRound = 1;
				}

				if(data.rounds[2] != null && data.rounds[2] != undefined && data.rounds[2].flirt_round_id == roundId) {
					actRound = 2;
				}

				if(actRound == null || actRound == undefined) {
					reject($filter('translate')('THIS_ROUND_DOESNT_EXIST'));
				} else {
					actRound = data.rounds[actRound];
					var roundObj = {
						user_id: data.other_user.user_id,
						age: data.other_user.age,
						name: data.other_user.name,
						profile_img: other_profile_image,
						my_round_status: actRound.my_round_status,
						question: actRound.question,
						question_id: actRound.question_id1,
						answer: actRound.other_answer,
						flirt_round_expired: actRound.flirt_round_expired,
						flirt_round_valid_until: actRound.flirt_round_valid_until
					}

					if(roundObj.flirt_round_expired == true && !ignoreExpired) {
						var msg = $filter('translate')('FLIRT_ROUND_EXPIRED');
						var type = $_notification.getNotificationTypes().ERROR;
						var notificationObj = $_helper.getObjForNotification(msg, type);
						notificationObj.code = 141;

						reject(notificationObj);
					} else {
						$_image_cache.cacheAllImages();
						resolve(roundObj);
					}
				}
			}
		});
	}

	return {
		getFlirtDetail(id) {
			return new Promise(function(resolve, reject){
                var callbacks = {
                    onSuccessAck: function(successData) {
                        getFlirtDetailObj(successData.data).then(
                            function(flirtObj) {
                                $_flirt_detail_cache.saveFlirtDetail(flirtObj, id);
                                $_flirt_detail_cache.saveFlirtRounds(flirtObj.rounds, id);

                                resolve(flirtObj);
                            },
                            function(error) {
                            	var msg = $filter('translate')('OOPS_SOMETHING_WENT_WRONG');
                            	var type = $_notification.getNotificationTypes().ERROR;

                            	reject($_helper.getObjForNotification(msg, type));
                            }
                        );
                    },
                    onFailAck: function(failData) {
                    	$log.debug(failData);
                        var msg = $filter('translate')('REQUEST_FAILED');
                        var type = $_notification.getNotificationTypes().ERROR;
                        var notificationObj = $_helper.getObjForNotification(msg, type);

                        notificationObj.code = failData.code;

                        reject(notificationObj);
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
                }

                $_sdk.request("GET", "/flirt/" + id, null, callbacks)
            });
		},
		getRoundDetail(flirtId, roundId, ignoreExpired) {
			return new Promise(function(resolve, reject){
                var callbacks = {
                    onSuccessAck: function(successData) {
                        getRoundDetailObj(successData.data, roundId, ignoreExpired).then(
                            function(roundObj) {
                                resolve(roundObj);
                            },
                            function(msg) {
                            	reject(msg);
                            }
                        );
                    },
                    onFailAck: function(failData) {
                        var msg = $filter('translate')('REQUEST_FAILED');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_LOAD_DATA');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
                }

                $_sdk.request("GET", "/flirt/" + flirtId, null, callbacks)
            });
		}
	};
});
