angular.module('flirt_rate.service', [])
.factory('$_flirt_rate', function($_sdk, $_flirt_detail_cache, $_helper, $filter, $_notification, $ionicHistory) {
	return {
		rejectAnswer(roundId) {
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						resolve(roundId);
					},
					onFailAck: function(failData) {
						if(failData.code == 142) {
							var msg = $filter('translate')('THIS_FLIRT_DOESNT_EXIST');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 141) {
							var msg = $filter('translate')('FLIRT_ROUND_EXPIRED');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 162) {
							var notificationObj = {
								code: failData.code
							}
	                        reject(notificationObj);
						} else {
	                        var msg = $filter('translate')('FAILED_TO_REJECT_ANSWER');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        
	                        reject($_helper.getObjForNotification(msg, type));
                    	}
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_REJECT_ANSWER');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
				}

				var params = {
					user_accept: "rejected"
				}

				$_sdk.request("PUT", "/flirt/" + roundId + "/round", params, callbacks);
			});
		},
		acceptAnswer(roundId) {
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						resolve(roundId);
					},
					onFailAck: function(failData) {
						if(failData.code == 142) {
							var msg = $filter('translate')('THIS_FLIRT_DOESNT_EXIST');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 141) {
							var msg = $filter('translate')('FLIRT_ROUND_EXPIRED');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;
	                        reject(notificationObj);
						} else if(failData.code == 162) {
							var notificationObj = {
								code: failData.code
							}
	                        reject(notificationObj);
						} else {
	                        var msg = $filter('translate')('FAILED_TO_ACCEPT_ANSWER');
	                        var type = $_notification.getNotificationTypes().ERROR;

	                        var notificationObj = $_helper.getObjForNotification(msg, type);
	                        notificationObj.code = failData.code;

	                        reject($_helper.getObjForNotification(msg, type));
                    	}
                    },
                    onValidator: function(validateData) {
                        var msg = $filter('translate')('FAILED_TO_ACCEPT_ANSWER');
                        var type = $_notification.getNotificationTypes().ERROR;

                        reject($_helper.getObjForNotification(msg, type));
                    }
				}

				var params = {
					user_accept: "accepted"
				}

				$_sdk.request("PUT", "/flirt/" + roundId + "/round", params, callbacks);
			});
		}
	};
});