angular.module('crop.service', [])
.factory('$_crop', function($filter, $_helper, $rootScope, $ionicActionSheet, $_sdk, $timeout) {

  var cropService =  {

    showModal: function ($scopeModal) {
      $scopeModal.show();
    },

    hideModal: function ($scopeModal) {
      $scopeModal.hide();
    },

    closeModal: function($scopeModal) {
      $_helper.confirm($filter('translate')('CONFIRM'), $filter('translate')('DO_YOU_WANT_TO_CLOSE_EDIT_IMAGE_DIALOG'), function(res) {
        if(res) cropService.hideModal($scopeModal);
      });
    },

    resetMedia: function(resetHandling) {
      $_helper.confirm($filter('translate')('RESET_MEDIA_CONFIRM_TITLE'), $filter('translate')('RESET_MEDIA_CONFIRM_TEXT'), function(res){
        if(res) resetHandling();
      });
    },

    submitCroppedMedia: function($scopeModal, $scopeDataFileUrl, croppedImage) {

      $timeout(function(){
        $scopeDataFileUrl = croppedImage;
      });

      cropService.hideModal($scopeModal);

    },

    openCropSheet: function($scopeModal, cropperHandling, fileUrl, previewFileStorageKey, width, height) {

      var cropperData  = {
          "sourceImage": fileUrl,
          "croppedImage": '',
          "previewFileStorageKey": previewFileStorageKey,
          "aspect_ratio": 0,
          "width": width,
          "height": height,
          "title": $filter('translate')('CROP_YOUR_IMAGE'),
          "loading_text": $filter('translate')('LOADING'),
          "close_text": $filter('translate')('CANCEL'),
          "send_text": $filter('translate')('SEND'),
          "area_type": 'square',
          "imageFormat": "image/jpeg"
      };

      cropperHandling(cropperData);

      cropService.showModal($scopeModal);

    }

  };

  return cropService;

});