angular.module('font_color_helper.service', [])
.factory('$_font_color_helper', function() {
	//Farben für den Counter
	var counter_colorArr = ['#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC', '#DCDCDC',
	'#DCD7D9', '#DCD3D6', '#DCCFD4', '#DCCBD1', '#DCC6CE', '#DCC2CC', '#DCBEC9', '#DCBAC6', '#DCB5C4', '#DCB1C1',
	'#DCADBF', '#DCA9BC', '#DCA5B9', '#DCA0B7', '#DC9CB4', '#DC98B1', '#DC94AF', '#DC8FAC', '#DC8BA9', '#DC87A7',
	'#DC83A4', '#DC7FA2', '#DC7A9F', '#DC769C', '#DC729A', '#DC6E97', '#DC6994', '#DC6592', '#DC618F', '#DC5D8D',
	'#DC598A', '#DC5487', '#DC5085', '#DC4C82', '#DC487F', '#DC437D', '#DC437D', '#DC3F7A', '#DC3B77', '#DC3775',
	'#DC3372', '#DC2E70', '#DC2A6D', '#DC266A', '#DC2268', '#DC2268', '#DC1D65', '#DC1962', '#DC1560', '#DC115D', '#DD0D5B'
	];

	var taFontSizeArr = ['36px', '34px', '32px', '30px', '28px', '26px', '24px'];
	var questionFontSizeArr = ['2.1rem', '2rem', '1.9rem', '1.75rem', '1.7rem', '1.6rem', '1.5rem'];

	var counter_font_contrast_color = '#FFFFFF';
	var counter_font_base_color = '#000000';

	var taMax = 150;
	var counterColorSteps = 2;
	var taFontSteps = 26;

	var questionFontSteps = 15;

	return {
		getCounterColor(length) {
			if(length == 0) {
				return counter_colorArr[0];
			} else {
				var actualColor = length/counterColorSteps;
				actualColor = parseInt(actualColor, 10);

				if(actualColor >= counter_colorArr.length-1)
					actualColor = counter_colorArr.length-1;
				return counter_colorArr[actualColor];
			}
		},
		getActualColor(length) {
			return parseInt(length/counterColorSteps, 10);
		},
		getFontSize(length) {
			if(length == 0) {
				return taFontSizeArr[0];
			} else {
				var actualFont = length/taFontSteps;
				actualFont = parseInt(actualFont, 10);

				return taFontSizeArr[actualFont];
			}
		},
		getCounterFontBaseColor() {
			return counter_font_base_color;
		},
		getCounterFontContrastColor() {
			return counter_font_contrast_color;
		},
		getQuestionFontSize(length) {
			var actualSize = length/questionFontSteps;
			actualSize = parseInt(actualSize, 10);

			return questionFontSizeArr[actualSize];
		}
	};
});
