angular.module('helper.service', [])
.run(function($rootScope) {
	// Regex-Helper
	$rootScope.regexHelper = [];
	$rootScope.regexHelper.hashtags = '^[a-zA-Z0-9\u00C0-\u017F]+$';
	$rootScope.default_profile_img = "img/profile-img-default.jpg";

	$rootScope.badges = {
		flirts: 0,
		chats: 0,
		account: 0
	};

	$rootScope.points = {
		current_points: 0
	};
})

.factory('$_helper', function($http, $location, $ionicPopup, $filter, $ionicPlatform, $rootScope, $_image_cache,
	$ionicBackdrop, $timeout, $ionicBody, $_locale_settings, $_badges, $cordovaBadge, $ionicLoading, $state, CONFIG, $log, $ionicModal) {
	var blurImg;
	var defaultImage = "img/profile-img-default.jpg";

	function setCordovaBadges(value) {
		$cordovaBadge.hasPermission().then(function(result) {
			$cordovaBadge.set(value);
		}, function(error) {
			$log.debug(error);
		});
	}

	function hideSendOrLoadIndicator() {
		$ionicLoading.hide();
	}

	/*
	* Zeigt Lade- oder Sendeindikator an
	* bool is_loading: Gibt an ob der Indikator für das Laden oder Senden zuständig (true == laden)
	*/
	function showSendOrLoadIndicator(is_loading) {
		var msg = $filter('translate')('LOADING');
		if(!is_loading) msg = $filter('translate')('SENDING');

		if(navigator.connection != null || navigator.connection != undefined) {
			var networkState = navigator.connection.type;

			if(Connection.CELL || CONNECTION.NONE || CONNECTION.UNKNOWN) {
				$ionicLoading.show({
					template: '<ion-spinner icon="ios"></ion-spinner><br/>', // + msg,
					animation: 'fade-in',
					showBackdrop: true,
					maxWidth: 300,
					showDelay: 0
				});
			}
		}
	}

  return {
	initIonicModal: function(getScope, templateName) {

		var templateName = (typeof templateName === 'undefined') ? 'crop-image' : templateName;

		$ionicModal.fromTemplateUrl('templates/modal/' + templateName + '.html', {
		  scope: getScope,
		  animation: 'slide-in-up'
		}).then(function(modal) {
		  getScope.modal = modal;
		});

		// Cleanup the modal when we're done with it!
		getScope.$on('$destroy', function() {
		  getScope.attachment.cropper = {};
		  getScope.modal.remove();
		});

		// Execute action on hide modal
		getScope.$on('modal.hidden', function() {
		  // Execute action
		});

		// Execute action on remove modal
		getScope.$on('modal.removed', function() {
		  // Execute action
		});

	},
	convertLocalImageToBase64: function(url, callback) {   
		var request = new XMLHttpRequest();
		request.onload = function() {
			var file = new FileReader();
			file.onloadend = function() {
				callback(file.result);
			}
			file.readAsDataURL(request.response);
		};   
		request.open('GET', url);   
		request.responseType = 'blob';              
		request.send(); 
	},
	getImageSourceFromCam: function(type) {
		if(type == "camera") {
			return Camera.PictureSourceType.CAMERA;
		} else if(type == "gallery") {
			return Camera.PictureSourceType.PHOTOLIBRARY;
		} else {
			return Camera.PictureSourceType.CAMERA 
		}
	},
  	alertWithCallback: function(msg,callback) {
  		/*var error = $_notification.getNotificationTypes().ERROR;
  		$timeout(function(){
  			$_notification.showNotificationBar(msg, error);
  		}, 250);*/
  	},
  	hashtagIsValid: function(val) {
  		var regex = new RegExp($rootScope.regexHelper.hashtags);
  		if(val != null && val != undefined) {
  			if(val.length == 0) return true;
			if (regex.test(val)) {
				return true;
			} else {
				return false;
			}
  		} else return true;
  	},
  	newDate: function(date) {
  		return new Date(date.replace(' ', 'T'));
  	},
	getBirthDatePickerOptions: function() {
		var options;

		if(cordova.platformId === 'ios') {
			var localeKey = $_locale_settings.getLocaleKey();
			var date = new Date().setFullYear(new Date().getFullYear() - 20);
			options = {
		      mode: 'date', // or 'time'
		      minDate: new Date(new Date().setFullYear(new Date().getFullYear() - 99)),
		      maxDate: new Date(new Date().setFullYear(new Date().getFullYear() - CONFIG.min_age)),
		      date: date,
		      allowOldDates: true,
		      androidTheme: 3,
		      allowFutureDates: false,
		      doneButtonLabel: $filter('translate')('DONE'),
		      doneButtonColor: '#000000',
		      cancelButtonLabel: $filter('translate')('CANCEL'),
		      cancelButtonColor: '#DD0D5B',
		      okText: $filter('translate')('DONE'),
		      cancelText: $filter('translate')('CANCEL'),
		      locale: localeKey
		    };
		}
		if(cordova.platformId === 'android') {
			var today = moment();
			var year = today.get('year') - CONFIG.min_age;
			var month = today.format('MM');
			var day = today.format('DD');
			var todayStr = month + '/' + day + '/' + year;

			var minDate = (new Date('01/01/1900')).valueOf();
	    var maxDate = (new Date(todayStr)).valueOf(); // mm/dd/yyyy
			options = {
			  date: new Date(),
			  minDate: minDate,
			  maxDate: maxDate,
			  mode: 'date',
			  androidTheme: 3
			};
		}

	  return options;
	},
	blurProfileImage: function(elem) { // blurred das übergebene element
		blurImg = true;
		var x = 1;

		var blurInterval = setInterval(function() {
			if(blurImg) {
				elem.css('filter', 'blur('+ x + 'px)');
				elem.css('-webkit-filter', 'blur('+ x +'px)');
				elem.css('-moz-filter', 'blur('+ x +'px)');
				elem.css('-o-filter', 'blur('+ x +'px)');
			}
			if (++x === 10) {
				window.clearInterval(blurInterval);
			}
		}, 50);
	},
	resetBlur: function(elem) {
		blurImg = false;

		var blurVal = elem.css('filter');
		if(blurVal == null || blurVal == undefined || blurVal == 'none') {
			blurVal = elem.css('-webkit-filter');
		}

		if(blurVal == null || blurVal == undefined || blurVal == 'none') {
			blurVal = elem.css('-moz-filter');
		}

		if(blurVal == null || blurVal == undefined || blurVal == 'none') {
			blurVal = elem.css('-o-filter');
		}

		var blurVal = blurVal.slice(0,-3);
		var blurVal = blurVal.slice(5,blurVal.length);

		var resetBlurInterval = setInterval(function () {
			if(!blurImg) {
				elem.css('filter', 'blur('+ blurVal + 'px)');
				elem.css('-webkit-filter', 'blur('+ blurVal +'px)');
				elem.css('-moz-filter', 'blur('+ blurVal +'px)');
				elem.css('-o-filter', 'blur('+ blurVal +'px)');
			}
			if (--blurVal === -1) {
				window.clearInterval(resetBlurInterval);
			}
		}, 50);
	},
  	getAge: function(dateString) {
	    var today = new Date();
	    var birthDate = new Date(dateString);
	    var age = today.getFullYear() - birthDate.getFullYear();
	    var m = today.getMonth() - birthDate.getMonth();
	    if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
	      age--;
	    }
	    return age;
	},
	getCurrentTab: function(state) {
		if(state.current.name.indexOf("tab.blury") !== -1) return "blury";
		if(state.current.name.indexOf("tab.chats") !== -1) return "chats";
		if(state.current.name.indexOf("tab.flirts") !== -1) return "flirts";
		if(state.current.name.indexOf("registrate") !== -1) return "registrate";
		if(state.current.name.indexOf("tab.account") !== -1) return "account";
	},
	generateRandomString: function(length) {
	    var text = "";
	    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

	    for( var i=0; i < length; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

	    return text;
	},
	getDate: function(dateString) {
		var locale = "de-de";
		var localeOptions = {year: 'numeric', month: 'long', day: 'numeric'};
		var date = new Date(dateString);
		date = date.toLocaleString(locale, localeOptions);

		return date;
	},
	/*
	 *	Gibt an wie viele Stunden der Nutzer von UTC entfernt ist.
	 *	date: Datum
	 *	format: Gewünschtes Rückgabeformat
	 *	multiplikator: Wie oft der Offset Multipliziert werden soll (null == 1)
	 */
	getUTCOffset: function(date, format, multiplikator) {
		if(multiplikator == null || multiplikator == undefined)
			multiplikator = 1;

		var timezone = moment.tz.guess();
		var timezoneDate = moment.tz(date, timezone).format();
		var offset = moment.parseZone(timezoneDate)._offset * multiplikator;

		var offsetDate = moment.utc(timezoneDate).utcOffset(offset).format(format);

		return offsetDate;
	},
	getDeviceId: function() {
		  return window.device.uuid;
	},
	getSmallImg: function(profile_images) { // Holt aus profile_images (Object) das small_image heraus
		var getter = function(profile_images) {
			if(profile_images != null && profile_images != undefined) {
				if(profile_images.small != null && profile_images.small != undefined) {
					return profile_images.small;
				} else {
					var original = profile_images.original;

					if(original != null && original != undefined)
						return original;
					else
						return null;
				}
			}
		}
		var img = getter(profile_images);
		var cached = $_image_cache.cacheImage(img);

		return cached;
	},
	getMediumImg: function(profile_images) {
		var getter = function(profile_images) {
			if(profile_images != null && profile_images != undefined) {
				if(profile_images.medium != null && profile_images.medium != undefined) {
					var url = $_image_cache.cacheImage(profile_images.medium);
					return url;
				} else {
					var original = profile_images.original;

					if(original != null && original != undefined)
						return original;
					else
						return null;
				}
			}
		}

		var img = getter(profile_images);
		if(img != null && img != undefined) {
			return $_image_cache.cacheImage(img);
		}
		return img;
	},
	getObjForNotification: function(msg, type, time, link) {
		return {
			msg: msg,
			type: type,
			time: time,
			link: link
		}
	},
	moveArrayElement: function() { // Initialisiert eine Funktion, die in einem Array ein Objekt von old_index zu new_index schiebt.
		Array.prototype.move = function (old_index, new_index) {
		    if (new_index >= this.length) {
		        var k = new_index - this.length;
		        while ((k--) + 1) {
		            this.push(undefined);
		        }
		    }
		    this.splice(new_index, 0, this.splice(old_index, 1)[0]);
		    return this; // for testing purposes
		};
	},
	hideAccessoryBar(bool) { // Zeigt an oder versteckt die "Done"-Leiste bei der iOS Tastatur
		if(window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(bool);
		}
	},
	setBadges(count) {
		$timeout(function(){
			$rootScope.badges.flirts = count.flirts;
			$rootScope.badges.chats = count.messages;
		}, 50);
	},
	refreshBadges(count) { // setzt die Badges auf die Count Werte
		if(count != null && count != undefined) {
			$timeout(function(){
				$rootScope.badges.flirts = count.flirts;
				$rootScope.badges.chats = count.messages;
				$rootScope.points.current_points = count.points;

				setCordovaBadges(count.total);
			}, 50);
		} else { // count == null, hole die Count werte aus der API
			$_badges.getUnreadCount().then(function(count){
				$timeout(function(){
					$rootScope.badges.flirts = count.flirts;
					$rootScope.badges.chats = count.messages;
					$rootScope.badges.account = $rootScope.badges.account + count.profile;
					$rootScope.points.current_points = count.points;
					setCordovaBadges(count.total);
				}, 50);
			},
			function(error){

			});
		}

	},
	resetBadges() {
		setCordovaBadges(0);
	},
	isRoundValid(rounds) {
		var round = rounds.length;
		var flirt_round_valid_until = rounds[round-1].flirt_round_valid_until;
		var until = moment.utc(flirt_round_valid_until);
		var now = moment.utc();

		if(until < now) {
			return false;
		}
		return true;
	},
	showLoadingIndicator: function(){
		showSendOrLoadIndicator(true);
	},
	showSendIndicator: function() {
		showSendOrLoadIndicator(false);
	},
	hideLoadingIndicator: function(){
		hideSendOrLoadIndicator();
	},
	hideSendIndicator: function() {
		hideSendOrLoadIndicator();
	},
	getSHA1RegistrationCode: function() { // sha1(DEVICE ID + Timestamp + Random string)
		var hash = sha1.create();

        var device_id = this.getDeviceId();
        var randomStr = this.generateRandomString(30);
        var timestamp = Date.now();

        hash.update(device_id + '' + randomStr + '' + timestamp);

        return hash.hex();
	},
	refreshNewTab: function(){ // Wenn der aktuelle tab flirts oder chats ist, wird die liste aktualisiert
		var currentTab = $state.current.name;
		var tabname = $rootScope.rootCurrentTab;
		var tabChatStr = 'tab.chats';
		var tabFlirtStr = 'tab.flirts';

		if(currentTab == tabChatStr) {
			$rootScope.$broadcast('refresh-chat-list');
		}

		if(currentTab == tabFlirtStr) {
			$rootScope.$broadcast('refresh-flirt-list');
		}
	},
	checkDomain: function(url) {
		if (url.indexOf('//') === 0 ) {
			url = location.protocol + url;
		}
		return url.toLowerCase().replace(/([a-z])?:\/\//,'$1').split('/')[0];
	},
	isExternal: function(url) {
		return ((url.indexOf(':') > -1 || url.indexOf('//') > -1) && this.checkDomain(location.href) !== this.checkDomain(url));
	},
	isFalseOrTrue: function(item) {
		if(item == 0) return false;
		if(item == 1) return true;
	},
	getFalseOrTrueFlag: function(item) {
		if(item == false) return 0;
		if(item == true) return 1;
	},
	isScrolledToBottom(scrollDelegate){
	    var currentTop = scrollDelegate.getScrollPosition().top;
	    var maxScrollableDistanceFromTop = scrollDelegate.getScrollView().__maxScrollTop;
	    $log.debug("isScrolledToBottom " + currentTop + ">=" + (maxScrollableDistanceFromTop - 15));
	    return (currentTop >= (maxScrollableDistanceFromTop - 15));
	},
	replaceURLWithHTMLLinks: function(text){
		if(text != null && text != "" && text != undefined) {
			var urlRegex = /(((https?:\/\/)|(www\.))[^\s]+)/g;
				return text.replace(urlRegex, function(url,b,c) {
					var url2 = (c == 'www.') ?  'http://' +url : url;
					return '<a onclick="window.open(\'' + url2 + '\', \'_system\', \'location=yes\'); return false;">' + url + '</a>';
				});
		} else {
			return "";
		}
	}
  };
});
