angular.module('sound.service', [])
.factory('$_sound', function($cordovaNativeAudio, $_vibration, $_account_cache, $ionicPlatform, $log) {
	var soundpath = "/audio/";

	if(ionic.Platform.isAndroid()){
		soundpath = "audio/";
	}

	var sounds = [
		{
			key: 'REFRESH',
			url: soundpath + 'aktualisieren.mp3'
		},
		{
			key: 'REFRESH_FINISH',
			url: soundpath + 'aktualisieren_ende.mp3'
		},
		{
			key: 'NOTIFICATION',
			url: soundpath + 'notification.mp3'
		},
		{
			key: 'CLICK',
			url: soundpath + 'klick.mp3'
		},
		{
			key: 'RATE_POSITIVE',
			url: soundpath + 'positiv-bewerten.mp3'
		},
		{
			key: 'NEXT_ROUND',
			url: soundpath + 'runde-weiter.mp3'
		},
		{
			key: 'TAB_CHANGE',
			url: soundpath + 'tabwechsel.mp3'
		},
		{
			key: 'ZONK',
			url: soundpath + 'zonk.mp3'
		},
		{
			key: 'MATCH',
			url: soundpath + 'match.mp3'
		}
	];

	/* Initialisiert die Sounds */
	function preloadSounds() {
		$ionicPlatform.ready(function() {
			var array_length = sounds.length-1;
			for(var i=0; i<=array_length; i++) {
				var key = sounds[i].key;
				var url = sounds[i].url;

				$cordovaNativeAudio.preloadSimple(key, url)
				//$cordovaNativeAudio.preloadComplex(key, url, 0.5, 1, 0)
				.then(function(msg) {
					$log.debug(msg);
				})
				.catch(function(error) {
					$log.debug(key + ' failed');
					$log.debug(error);
				});
			}
		});
	}

	function playSound(type) {
		$log.debug("playing sound");
		$log.debug(type);
		if($_account_cache.getSoundSetting() == true && (ionic.Platform.isAndroid() || ionic.Platform.isIOS())) {
			if(ionic.Platform.isAndroid()){
				window.plugins.NativeAudio.play(type); // Play audio track
			} else {
				$cordovaNativeAudio.play(type)
				.then(function(msg) {
					$log.debug(msg);
				})
				.catch(function(error) {
					$log.debug(error);
				});
			}
		}
	}

  	return {
		preloadSounds: function() {
			preloadSounds();
		},
		playRefresh() {
			playSound("REFRESH");
		},
		playRefreshFinish() {
			playSound("REFRESH_FINISH");
		},
		playClick() {
			playSound("CLICK");
		},
		playNotification() {
			playSound("NOTIFICATION");
		},
		playRatePositive() {
			playSound("RATE_POSITIVE");
		},
		playNextRound() {
			playSound("NEXT_ROUND");
		},
		playTabChange() {
			playSound("TAB_CHANGE");
		},
		playZonk() {
			playSound("ZONK");
		},
		playMatch() {
			playSound("MATCH");
		}
  	};
});
