angular.module('tracking.service', [])
.factory('$_tracking', function() {
	function trackPage(viewTitle) {
		var isIOS = ionic.Platform.isIOS();
		var isAndroid = ionic.Platform.isAndroid();

		if(isIOS || isAndroid){
			if(typeof analytics !== 'undefined') {
				analytics.trackView(viewTitle);
			}
		}
	}

	function trackEvent(category, action, label, value) {
		var isIOS = ionic.Platform.isIOS();
		var isAndroid = ionic.Platform.isAndroid();

		if(isIOS || isAndroid){
			if(typeof analytics !== 'undefined') {
				analytics.trackEvent(category, action, label, value);
			}
		}
	}

	function setUserId(userID) {
		var isIOS = ionic.Platform.isIOS();
		var isAndroid = ionic.Platform.isAndroid();

		if(isIOS || isAndroid){
			if(typeof analytics !== 'undefined') {
				analytics.setUserId(userID);
			}
		}
	}

	return {
		trackPage: function(viewTitle) {
			trackPage(viewTitle);
		},
		trackEvent: function(category, action, label, value) {
			trackEvent(category, action, label, value);
		},
		setUserId: function(userID) {
			setUserId(userID);
		}
	};
});
