angular.module('wink_animation.service', [])

.factory('$_wink_animation', function($timeout, $interval) {
	var times = 0;
	var animationRange = 7; // Für Abweichungen um nicht zu viele Animationen laufen zu lassen
	var animationsNumber = 6;
	var animationCountInterval = 2000; // Alle wie viele Sekunden soll eine Animation berechnet werden
	var animationInterval = 150; // Abstand zwischen den Intervallen

	var showFirst = true;
	var showSecond = false;
	var winkAnimationPromise;


	function startAnimation() {
		if(times > 0) {
			animate();
			$timeout(startAnimation, animationInterval);
		}
	}

	function animate() {
		times = times-1;

		if(showFirst) showFirst = false;
		else showFirst = true;

		if(showSecond) showSecond = false;
		else showSecond = true;

		if(!showFirst) {
			$('.wink_first').css("opacity", 0);
			$('.wink_second').css("opacity", 1);
		} else {
			$('.wink_second').css("opacity", 0);
			$('.wink_first').css("opacity", 1);
		}
	}


  return {
  	start: function() {
  		$('.wink_second').css("opacity", 0);
  		showFirst = true;
  		showSecond = false;

  		winkAnimationPromise = $interval(function(){
  			if(times == 0) {
  				var number = Math.floor(Math.random() * animationRange) + 1;
  				var mod = number % 2;

  				if(mod == 0 && number <= animationsNumber) {
  					times = number;
  					startAnimation();
  				}
  			}
  		}, animationCountInterval);
  	},
  	stop: function() {
  		if(winkAnimationPromise != null && winkAnimationPromise != undefined) {
  			$interval.cancel(winkAnimationPromise);
  		}
  	}
  };
});
