angular.module('notification.service', [])
.factory('$_notification', function($timeout, $state, $rootScope, $_helper, $stateParams, $_account_cache, $_sound, $log) {

	var hideNotificationsIn = ["registrate", "introduction-swiper", "start-screen"]; // Liste der States in denen Notifications ausgeblendet werden sollen

	function closeNotification() {
		$(".notification-bar").addClass("animated fadeOutUp");
		$timeout(function(){
			$(".notification-bar").remove();
			$_account_cache.setOffline(false);
		}, 1000);
	}

	function notificationTypes() {
		return {
			NEUTRAL: 0,
			POSITIVE: 1,
			ERROR: 2
		}
	}

	function getNotificationClass(type) {
		if(type == notificationTypes().NEUTRAL) return 'notification-neutral';
		if(type == notificationTypes().POSITIVE) return 'notification-positive';
		if(type == notificationTypes().ERROR) return 'notification-error';
	}

	/*
	* Verarbeitet eine Push-notification
	* @param {object} data - Die Push-Notification
	*/
	function processPushNotification(data) {

		$log.debug(data);

		if(data['payload'] != undefined && data['payload'] != null) {
			var payload = JSON.parse(data['payload']);
		} else if(data['gcm.notification.payload'] != undefined && data['gcm.notification.payload'] != null) {
			var payload = JSON.parse(data['gcm.notification.payload']);
		} else {
			return;
		}
		if(data.wasTapped) {
			var foreground = false;
		} else {
			var foreground = true;
		}
		var currentState = $state.current.name;
		var parent_id = payload.notification_parent_id;
		var notification_type = payload.notification_type;
		var msg;
		var link;
		var badge_count = payload.badge_counts;

		$_helper.refreshBadges(badge_count);
		var flirtTab = 'tab.'+$rootScope.rootCurrentTab+'-flirt-detail';
		var flirtAnswerTab = 'tab.'+$rootScope.rootCurrentTab+'-flirt-detail-answer';
		var accountTab = 'tab.account';

		if(!foreground) { // App aus dem Hintergrund heraus gestartet -> gehe zum Screen
			if(payload.notification_href == 'match') {

				if(notification_type == 4 && currentState == flirtTab && parent_id == $stateParams.flirtId) {
					$rootScope.$broadcast('refresh-flirt-detail');
				} else if(parent_id == $stateParams.chatId) {
					$rootScope.$broadcast('refresh-chat-detail');
				} else if(currentState == 'tab.chats') {
					$rootScope.$broadcast('refresh-chat-list');
				}

				if(parent_id != $stateParams.chatId && notification_type != 4) {
					$state.go('tab.'+$rootScope.rootCurrentTab+'-chat-detail', {chatId: parent_id});
				}
			}

			if(payload.notification_href == 'flirt') {
				if(currentState == flirtTab && parent_id == $stateParams.flirtId) {
					$rootScope.$broadcast('refresh-flirt-detail');
				} else if(currentState == flirtAnswerTab && parent_id == $stateParams.flirtId && notification_type == 9) {
					$rootScope.$broadcast('refresh-flirt-detail-answer');
				} else if(currentState == 'tab.flirts') {
					$rootScope.$broadcast('refresh-flirt-list');
				}

				if(parent_id != $stateParams.flirtId) {
					$state.go('tab.'+$rootScope.rootCurrentTab+'-flirt-detail', {flirtId: parent_id});
				}
			}

			if(payload.notification_href == 'profile') {
				$rootScope.filterChanged = true;
				if(currentState == accountTab) {
					$rootScope.$broadcast('refresh-account-tab');
				} else if(currentState != accountTab) {
					$state.go(accountTab);
				}
			}
		} else { // App ist im Vordergrund -> Aktualisiere/Zeige Notificationbar
			if(payload.notification_href == 'match') {

				if(notification_type == 4 && currentState == flirtTab && parent_id == $stateParams.flirtId) {
					$rootScope.$broadcast('refresh-flirt-detail');
				} else if(parent_id == $stateParams.chatId) {
					$rootScope.$broadcast('refresh-chat-detail');
				} else if(currentState == 'tab.chats') {
					$rootScope.$broadcast('refresh-chat-list');
				}

				if(parent_id != $stateParams.chatId && parent_id != $stateParams.flirtId) {
					link = 'tab.'+$rootScope.rootCurrentTab+'-chat-detail';
					linkObj = {chatId: parent_id};

					msg = payload.notification_title;
					showNotificationBar(msg, 1, null, link, linkObj);
				}
			}

			if(payload.notification_href == 'flirt') {
				if(currentState == flirtTab && parent_id == $stateParams.flirtId) {
					$rootScope.$broadcast('refresh-flirt-detail');
				} else if(currentState == flirtAnswerTab && parent_id == $stateParams.flirtId && notification_type == 9) {
					$rootScope.$broadcast('refresh-flirt-detail-answer');
				} else if(currentState == 'tab.flirts') {
					$rootScope.$broadcast('refresh-flirt-list');
				}

				if(parent_id != $stateParams.flirtId) {
					link = 'tab.'+$rootScope.rootCurrentTab+'-flirt-detail';
					linkObj = {flirtId: parent_id};

					msg = payload.notification_title;
					showNotificationBar(msg, 1, null, link, linkObj);
				}
			}

			if(payload.notification_href == 'profile') {
				$rootScope.filterChanged = true;
				if(currentState == accountTab) {
					$rootScope.$broadcast('refresh-account-tab');
				}

				if(currentState != accountTab) {
					link = accountTab;
					msg = payload.notification_title;

					showNotificationBar(msg, 1, null, link);
				}
			}
		}
	}

	function processPushNotificationOLD(data) {
		var payload = data.raw.additionalData.payload;
		var coldstart = data.raw.additionalData.coldstart;
		var foreground = data.raw.additionalData.foreground;
				var currentState = $state.current.name;
				var parent_id = payload.notification_parent_id;
				var msg;
				var link;
				var badge_count = payload.badge_counts;

				$_helper.refreshBadges(badge_count);
				var flirtTab = 'tab.'+$rootScope.rootCurrentTab+'-flirt-detail';
				var accountTab = 'tab.account';

				if(!foreground) { // App aus dem Hintergrund heraus gestartet -> gehe zum Screen
					if(payload.notification_href == 'match') {
						if(parent_id == $stateParams.chatId) {
							$rootScope.$broadcast('refresh-chat-detail');
						} else if(currentState == 'tab.chats') {
							$rootScope.$broadcast('refresh-chat-list');
						}

						if(parent_id != $stateParams.chatId) {
							$state.go('tab.'+$rootScope.rootCurrentTab+'-chat-detail', {chatId: parent_id});
						}
					}

					if(payload.notification_href == 'flirt') {
						if(currentState == flirtTab && parent_id == $stateParams.flirtId) {
							$rootScope.$broadcast('refresh-flirt-detail');
						} else if(currentState == 'tab.flirts') {
							$rootScope.$broadcast('refresh-flirt-list');
						}

						if(parent_id != $stateParams.flirtId) {
							$state.go('tab.'+$rootScope.rootCurrentTab+'-flirt-detail', {flirtId: parent_id});
						}
					}

					if(payload.notification_href == 'profile') {
						if(currentState == accountTab) {
							$rootScope.$broadcast('refresh-account-tab');
						} else if(currentState != accountTab) {
							$state.go(accountTab);
						}
					}
				} else { // App ist im Vordergrund -> Aktualisiere/Zeige Notificationbar
					if(payload.notification_href == 'match') {

						if(parent_id == $stateParams.chatId) {
							$rootScope.$broadcast('refresh-chat-detail');
						} else if(currentState == 'tab.chats') {
							$rootScope.$broadcast('refresh-chat-list');
						}

						if(parent_id != $stateParams.chatId) {
							link = 'tab.'+$rootScope.rootCurrentTab+'-chat-detail';
							linkObj = {chatId: parent_id};

							msg = payload.notification_title;
							this.showNotificationBar(msg, 1, null, link, linkObj);
						}
					}

					if(payload.notification_href == 'flirt') {
						if(currentState == flirtTab && parent_id == $stateParams.flirtId) {
							$rootScope.$broadcast('refresh-flirt-detail');
						} else if(currentState == 'tab.flirts') {
							$rootScope.$broadcast('refresh-flirt-list');
						}

						if(parent_id != $stateParams.flirtId) {
							link = 'tab.'+$rootScope.rootCurrentTab+'-flirt-detail';
							linkObj = {flirtId: parent_id};

							msg = payload.notification_title;
							this.showNotificationBar(msg, 1, null, link, linkObj);
						}
					}

					if(payload.notification_href == 'profile') {
						if(currentState == accountTab) {
							$rootScope.$broadcast('refresh-account-tab');
						}

						if(currentState != accountTab) {
							link = accountTab;
							msg = payload.notification_title;

							this.showNotificationBar(msg, 1, null, link);
						}
					}
				}
	}

	/*
	* Zeigt die Notification-Bar oberhalb der Anwendung an
	* @param {string} msg - Nachricht, die angezeigt werden soll
	* @param {int} type - Typ der Nachricht
	* @param {int} showtime - Wie lange die Nachricht angezeigt werden soll in ms. Wenn null, dann ist showtime = 3000 ms.
	* @param {string} link - href; Seite die angezeigt werden soll nach Klick auf Notification
	* @param {string} linkObj - Parameter für den Link
	*/
	function showNotificationBar(msg, type, showtime, link, linkObj) {
		if($_account_cache.getAppWasClosed()) return;
		
		if(msg != null && msg != undefined && type != null && type != undefined) {
			var notificationHTML;

			if(hideNotificationsIn.indexOf($state.current.name) != -1) return;

			var time = 3000;
			if(showtime != null && showtime != undefined && showtime != 0) {
				time = showtime;
			}

			var notificationClass = getNotificationClass(type);
			var top = $(".nav-bar-block[nav-bar='active']").find('ion-header-bar').outerHeight();
			if(top == null || top == undefined) top = '50';

			notificationHTML =
				'<div class="notification-bar ' +
					notificationClass +
					' animated fadeInDown" style="top:' + top +'px;">' +
					msg +
				'</div>';

			$("ion-header-bar").after(notificationHTML);
			$_sound.playNotification();

			if(showtime != 0) {
				var closeTimer = $timeout(function(){
					closeNotification();
				}, time);
			}

			/*$(".notification-bar").click(function() {
				$_sound.playClick();
				closeNotification();

				if(link != null && link != undefined) {
					$state.go(link, linkObj);
				}
			});

			if(link != null) {
				$rootScope.$on('$stateChangeStart',
					function(event, toState, toParams, fromState, fromParams, options){
						$log.debug("close 3");
						closeNotification();
					}
				);
			}*/
		}
	}

	return {
		showNotificationBar: function(msg, type, showtime, link, linkObj) {
			showNotificationBar(msg, type, showtime, link, linkObj);
		},
		getNotificationTypes: function() {
			return notificationTypes();
		},
		processPushNotification: function(data) {
			processPushNotification(data);
		},
		hasPushPermission: function() {
			return true;
		},
		closeNotification: function() {
			closeNotification();
		}
  };
});
