angular.module('popup.service', [])
.factory('$_popup', function($_confetti, $ionicPopup, $filter, $ionicBackdrop, $timeout, $ionicBody, $_options, $_notification, $rootScope, $_login, $_sound, $ionicScrollDelegate,
	$ionicHistory, $_cache_helper, $state, $_chat_list_cache, $_flirt_list_cache, $_account_cache, $_flirt_detail_cache, $_tracking, $_users_cache) {
	var nextRoundPopup;
	var photoRulesPopup;
	var blurImg;

	function confirmReportUser(reason_id, user_id, goBack) {

		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_REPORT_USER'),
			template: $filter('translate')('CONFIRM_REPORT_USER_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('DECLINE'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				//var report = $_options.reportUser(user_id, reason_id);
				$_options.reportUser(user_id, reason_id).then(
					function(success) {
						$_notification.showNotificationBar(success.msg, success.type);
						if(goBack) {
							$ionicHistory.goBack();
						}
					},
					function(error) {
						$_notification.showNotificationBar(error.msg, error.type);
					}
				)
			}
		});
	}

  return {
  	alert: function(msg, title) {
  		if(title == null || title == undefined)
  			title = $filter('translate')('ALERT');

  		var alertPopup = $ionicPopup.alert({
  			title: title,
  			template: msg,
  			cssClass: 'alert-popup'
  		});
	},
	showNextRoundPopup: function(scope, round) {
		var buttonText = $filter('translate')('NEXT_ROUND_GO');

		if(round == 2) {
			buttonText = $filter('translate')('LAST_ROUND_GO');
		}

		if(round == 3) {
			buttonText = $filter('translate')('START_CHAT');
		}

		if(nextRoundPopup == null || nextRoundPopup == undefined) {
			nextRoundPopup = $ionicPopup.show({
				templateUrl: 'templates/popup_next_round.html',
				"scope": scope,
				buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							$_sound.playClick();
							if(round == 3) {
								$_confetti.removeConfettiCanvas();
								if(scope.flirt.match_id != null && scope.flirt.match_id != undefined) {
									$state.go('tab.' + $rootScope.rootCurrentTab + '-chat-detail', {chatId: scope.flirt.match_id});
								}
							}
							$ionicBody.removeClass('modal-open');
							nextRoundPopup = null;
							return true;
						}
					}
				],
				cssClass: 'hide-popup-title popup-bottom-button'
			});
		}

		$timeout(function(){
			$('.prev-round-img').addClass('fade-out-img'); // Setze die Klasse, um das Bild klarer zu machen
		}, 1000);

		if(round == 3) {
			$_sound.playMatch();
			$_confetti.addConfettiCanvas();
		} else {
			$_sound.playNextRound();
		}
	},
	showPhotoRulesPopup: function() {
		return new Promise(function(resolve, reject) {
			var buttonText = $filter('translate')('OK');
			photoRulesPopup = $ionicPopup.show({
				templateUrl: 'templates/popup_photo_rules.html',
				buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							resolve();
							$ionicBody.removeClass('modal-open');
							photoRulesPopup = null;
							return true;
						}
					}
				],
				cssClass: 'hide-popup-title popup-bottom-button'
			});
		});
	},
	closeNextRoundPopUp: function() {
		$_confetti.removeConfettiCanvas();
		nextRoundPopup.close();
		nextRoundPopup = null;
		$ionicBody.removeClass('modal-open');
	},
	closePhotoRulesPopUp: function() {
		photoRulesPopup.close();
		photoRulesPopup = null;
		$ionicBody.removeClass('modal-open');
	},
	reportUserPopup: function(usr_id, scope, goBack) {
		scope.reportReason = {};
		$ionicPopup.show({
	      template: $filter('translate')('REPORT_USER_TEXT') + '<br/> <select class="popup-select" ng-model="reportReason.reason" ng-init="reportReason.reason = reasons[0]" ng-options="reason.name for reason in reasons"></select>',
	      title: $filter('translate')('REPORT_USER'),
	      cssClass: 'confirm-popup',
	      scope: scope,
	      buttons: [
	        { text: $filter('translate')('CANCEL'),
	          onTap: function(e) {
	          	$_sound.playClick();
	          }
	         },
	        {
	          text: $filter('translate')('REPORT'),
	          type: 'button-positive',
	          onTap: function(e) {
	          	$_sound.playClick();
	          	if(!scope.reportReason) e.preventDefault();
	          	else {
	          		confirmReportUser(scope.reportReason.reason.id, usr_id, goBack);
	          	}
	          }
	        }
	      ]
	  });
	},
	deleteGamePopup: function(id, goBack, scope, index, userId) {
		userId = (typeof userId === 'undefined') ? false : userId;
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_DELETE_GAME'),
			template: $filter('translate')('CONFIRM_DELETE_GAME_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_options.deleteFlirt(id).then(
					function(success){
						if(scope != null && scope != undefined && index != null && index != undefined) {
							scope.flirts.splice(index, 1);
							$_flirt_list_cache.saveFlirtList(scope.flirts);
							$_flirt_detail_cache.deleteAllStartedFlirtRounds();
						} else {
							$_flirt_list_cache.deleteElementFromList(id);
						}

						if(userId !== false) {
							$_users_cache.deleteUser(userId);
						}

						if(goBack) {
							$ionicHistory.goBack();
						}

						$timeout(function(){
							$_notification.showNotificationBar(success.msg, success.type);
						}, 250);
					},
					function(error) {
						$_notification.showNotificationBar(error.msg, error.type);
					}
				);
			} else {
				$_sound.playClick();
			}
		});
	},
	deleteFailedFlirtsPopup: function(scope) {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_DELETE_FAILED_FLIRTS'),
			template: $filter('translate')('CONFIRM_DELETE_FAILED_FLIRTS_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_options.deleteFailedFlirts().then(
					function(success){
						if(scope != null && scope != undefined && index != null && index != undefined) {
							scope.refresh(false);
						}

						$timeout(function(){
							$_notification.showNotificationBar(success.msg, success.type);
						}, 250);
					},
					function(error) {
						$_notification.showNotificationBar(error.msg, error.type);
					}
				);
			} else {
				$_sound.playClick();
			}
		});
	},
	deleteChatPopup: function(id, goBack, scope, index) {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_DELETE_CHAT'),
			template: $filter('translate')('CONFIRM_DELETE_CHAT_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('DECLINE'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_options.deleteMatch(id).then(
					function(success){
						if(scope != null && scope != undefined && index != null && index != undefined) {
							scope.chats.splice(index, 1);
							$_chat_list_cache.saveChatList(scope.chats);
						} else {
							$_chat_list_cache.deleteElementFromList(id);
						}

						if(goBack) {
							$ionicHistory.goBack();
						}
						$timeout(function(){
							$_notification.showNotificationBar(success.msg, success.type);
						}, 250);
					},
					function(error){
						$_notification.showNotificationBar(error.msg, error.type);
					}
				);
			} else {
				$_sound.playClick();
			}
		});
	},
	abortRegistrationPopup: function(id, goBack) {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_ABORT'),
			template: $filter('translate')('CONFIRM_ABORT_REGISTRATION_POPUP'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('DECLINE'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_account_cache.saveAccountData({});
				$_cache_helper.clear();
				$state.go('start-screen');
				$timeout(function(){
					$ionicHistory.clearHistory();
					$ionicHistory.clearCache();
				}, 250);
			} else {
				$_sound.playClick();
			}
		});
	},
	blockUserPopup: function(id, goBack, scope) {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CONFIRM_BLOCK_USER'),
			template: $filter('translate')('CONFIRM_BLOCK_USER_TEXT'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_options.blockUser(id).then(
					function(success){
						if(goBack) {
							$ionicHistory.goBack();
						}
						$timeout(function(){
							$_notification.showNotificationBar(success.msg, success.type);
						}, 250);
					},
					function(error){
						$_notification.showNotificationBar(error.msg, error.type);
					}
				);
			} else {
				$_sound.playClick();
			}
		});
	},
	closeAllOpenedPopups: function() {
		noop = angular.noop;
    	elevated = false;
    	var popupStack = $ionicPopup._popupStack;
    	if (popupStack.length > 0) {
      		popupStack.forEach(function(popup, index) {
	        	if (popup.isShown === true) {
	          		popup.remove();
	          		popupStack.pop();
	        	}
      		});
    	}

	    $ionicBackdrop.release();
	    $timeout(function() {
	      $ionicBody.removeClass('popup-open');
	    }, 400, false);
    	($ionicPopup._backButtonActionDone || noop)();
	},
	logoutPopup: function(type) {
		// Text je nach Login Typ
		// Wenn mit device_id, dann auf Löschen des Accounts hinweisen
		var logout_title;
		var logout_text;

		if(type == 'device_id') {
			logout_title = $filter('translate')('CONFIRM_LOGOUT');
			logout_text = $filter('translate')('CONFIRM_ACCOUNT_DELETE_TEXT');
		} else {
			logout_title = $filter('translate')('CONFIRM_LOGOUT');
			logout_text = $filter('translate')('CONFIRM_LOGOUT_TEXT');
		}

		var confirmPopup = $ionicPopup.confirm({
			title: logout_title,
			template: logout_text,
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('SUBMIT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$_tracking.trackEvent("Profile", "Logout", "", 0);
				$_login.unRegisterIonicPush();
				$_login.logout(type);
			} else {
				$_sound.playClick();
			}
		});
	},
	verificateAccountToStartFlirtPopup: function() {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('VERIFICATE_ACCOUNT'),
			template: $filter('translate')('VERIFICATE_ACCOUNT_TO_FLIRT_WITH_THIS_USER'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('VERIFICATE')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$state.go('tab.account');
				$timeout(function(){
					$ionicScrollDelegate.scrollTop();
				}, 150);
			} else {
				$_sound.playClick();
			}
		});
	},
	createAccountToVerificatePopup: function() {
		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('CREATE_ACCOUNT'),
			template: $filter('translate')('CREATE_ACCOUNT_TO_VERIFY_PROFILE'),
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('REGISTER')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$state.go('tab.' + $rootScope.rootCurrentTab + '-create-account');
				$timeout(function(){
					$ionicScrollDelegate.scrollTop();
				}, 150);
			} else {
				$_sound.playClick();
			}
		});
	},
	accountDoesntExistPopup: function(fb) {
		if(fb) var text = $filter('translate')('ACCOUNT_DOESNT_EXIST_TEXT_FB');
		else var text = $filter('translate')('ACCOUNT_DOESNT_EXIST_TEXT');

		var confirmPopup = $ionicPopup.confirm({
			title: $filter('translate')('ACCOUNT_DOESNT_EXIST'),
			template: text,
			cssClass: 'confirm-popup',
			cancelText: $filter('translate')('CANCEL'),
			okText: $filter('translate')('OK_NEXT')
		})
		.then(function(res) {
			if(res) {
				$_sound.playClick();
				$state.go('start-screen');
				$timeout(function(){
					$state.go('introduction-swiper');
				}, 150);
				
			} else {
				$_sound.playClick();
			}
		});
	}
  };
});
