angular.module('register.service', [])
.factory('$_register', function($_sdk, $_flirt_detail_cache, $_helper, $filter, $_notification, $_social_account, $log, $ionicPopup) {

	return {
		/* Fügt zum Account eine E-Mail und ein Passwort zum Einloggen hinzu. */
		registerMail(mail, password) {
			return new Promise(function(resolve, reject){
				var callbacks = {
					onSuccessAck: function(successData) {
						$log.debug(successData);
						var msg = $filter('translate')('SUCCESSFULLY_REGISTERED_CONFIRM_MAIL');
						var type = $_notification.getNotificationTypes().POSITIVE;

						var notificationObj = $_helper.getObjForNotification(msg, type);

						resolve(notificationObj);
					},
					onFailAck: function(failData) {
						$log.debug(failData);
						var msg;
						var type;
						if(failData.code == 255) { // Mail bereits vergeben
							msg = $filter('translate')('MAIL_ALREADY_IN_USE');
							type = $_notification.getNotificationTypes().ERROR;
						} else if(failData.code == 47) {
							msg = $filter('translate')('ALREADY_HAVE_REGISTERED');
							type = $_notification.getNotificationTypes().ERROR;
						} else {
							msg = $filter('translate')('FAILED_TO_REGISTER');
							type = $_notification.getNotificationTypes().ERROR;
						}

						var notificationObj = $_helper.getObjForNotification(msg, type);

						notificationObj.code = failData.code;
						reject(notificationObj);
										},
										onValidator: function(validateData) {
											$log.debug(validateData);
												var msg = $filter('translate')('FAILED_TO_REGISTER');
												var type = $_notification.getNotificationTypes().ERROR;

												reject($_helper.getObjForNotification(msg, type));
										}
				}

				var confirmPopup = $ionicPopup.confirm({
	                title: $filter('translate')('CONFIRM_EMAIL_PERMISSIONS'),
	                template: $filter('translate')('CONFIRM_EMAIL_PERMISSIONS_TEXT'),
	                cssClass: 'confirm-popup',
	                cancelText: $filter('translate')('APP_RATE_NO'),
	                okText: $filter('translate')('APP_RATE_YES')
	              })
	              .then(function(res) {
		            var params = {
						email: mail,
						password: password
					}
	                if(res) {
	                  params.mail_permission = 1;
	                } 

	                $_sdk.request("PUT", "/user/upgrade", params, callbacks);
	                
	              });

				
			});
		},
		registerFacebook() {
			return $_social_account.registerFacebook();
		}
	};
});
