angular.module('sdk.service', [])
.factory('$_sdk', function($location, $filter, $rootScope, $timeout, $log, $_network, $_nativestorage, $_account_cache) {
  var sdk = new SDK();
  
  var initSDK = function() {
    sdk.setPrefix("blury_beta");
    //$rootScope.environment = "TESTSERVER";
    //$rootScope.environment = "DEVELOPMENT";
    $rootScope.environment = "PRODUCTION";
      
    if($rootScope.environment ==="TESTSERVER"){
      sdk.setServerURL("http://beta2.bluryapp.com/public");
      $log.debug('working on server1');
    } else if ($rootScope.environment==="PRODUCTION") {
      sdk.setServerURL("https://api.bluryapp.com/public");
      $log.debug('working on server2');
    } else if ($rootScope.environment==="DEVELOPMENT") {
      sdk.setServerURL("http://dev.bluryapp.com/public");
      $log.debug('working on server3');
    }
  
    sdk.setUploadURL("/upload");
    sdk.setUploadFileKey("blury-upload");
    sdk.enableDebugInformation(false);
    sdk.setAppVersion("1.3.7");
  };
  
  var logoutAction = function(){
    $location.path('/start-screen');
    $rootScope.$broadcast('delete-push-token');
    sdk.logout();
  };
  

  initSDK();
  
  var onStorageFail = function() {
    
    $log.debug("onStorageFail");
 
    initSDK();
    $_account_cache.setLoginStatus(true);
    $_nativestorage.getItem("userID").then(function(value){
      sdk.setUserID(value);
    },function(){
      logoutAction();
    });
      
    $_nativestorage.getItem("xAuthToken").then(function(value){
        sdk.setxAuthToken(value);
    },function(){
      logoutAction();
    });
    
  };
  
  sdk.onTokenInvalid(function() {
    var curr = $location.path(); // $state nicht verwenden, da noch nicht initialisiert
    if( // Seiten, die auch ohne eingeloggt zu sein, angezeigt werden dürfen
      curr!="/start-screen"
       && curr!="/introduction-swiper"
       && curr!="/registrate"
       && curr!="/registrate/step1"
       && curr!="/registrate/step2"
       && curr!="/registrate/step3"
       && curr!="/registrate/step4"
      ){
        if (sdk.getxAuthToken() == undefined || sdk.getxAuthToken() == null) {
          $log.debug("tokenInvalid -> storageFail");
          onStorageFail();
        } else {
          $log.debug("tokenInvalid -> logout");
          logoutAction();
        }
        
       }
  });

  sdk.onAjaxError(function (){ // Bei Problemen den Request abzusenden
    $timeout(function(){
      $rootScope.$broadcast('connectivity-error');
      $rootScope.$broadcast('scroll.refreshComplete');
      $rootScope.$broadcast('scroll.infiniteScrollComplete');
    }, 250);

  },["/counts"]);

  sdk.onValidatorPutOrPost(function (validator){
    //$_notification.showNotificationBar($filter('translate')('FORM_MESSAGE_VALIDATION_HAS_FAILED'), $_notification.getNotificationTypes().ERROR);
  });

  sdk.onTimeout(function(){
    $log.debug("onTimeout");
    $timeout(function(){
      $rootScope.$broadcast('request-timeout');
      $rootScope.$broadcast('scroll.refreshComplete');
      $rootScope.$broadcast('scroll.infiniteScrollComplete');
    }, 250);
  });

  sdk.onWartungsmodus(function () {
    $rootScope.$broadcast('wartungsmodus');
  });

  sdk.onAppVersionTooOld(function () {
    $rootScope.$broadcast('app-version-too-old');
  });

  sdk.onAcceptNewTerms(function (data) {
    $rootScope.askForEmailPermission = false;
    if(data.email != undefined && data.email != null) $rootScope.askForEmailPermission = true;
    $rootScope.$broadcast('tos-update');
  });

  return sdk;
});
